define(['lex!easyBinding'], function (lexicons) {
    return function renderDOM(React, ReactDOM,baja,sendLogBajaInfo) {
        const lex = lexicons[0];
        const SearchItem = React.createClass({

            propTypes: {
                ord: React.PropTypes.string,
                slotPathOrd: React.PropTypes.string,
                pointname: React.PropTypes.string,
                pointtype: React.PropTypes.string,
                pointOrd: React.PropTypes.string,
                icon: React.PropTypes.string,
            },

            getDefaultProps: function () {
                return {
                    ord: null,
                    slotPathOrd: "",
                    pointname: "",
                    pointtype: "",
                    pointOrd: "",
                    icon:""
                }
            },

            getInitialState: function () {
                return {
                    ord: this.props.ord,
                    slotPathOrd: this.props.slotPathOrd,
                    pointname: this.props.pointname,
                    pointtype: this.props.pointtype,
                    pointOrd: this.props.pointOrd,
                    icon: this.props.icon,
                }
            },

            componentWillReceiveProps: function (nextProps) {
                this.setState({
                    ord: nextProps.ord,
                    slotPathOrd: nextProps.slotPathOrd,
                    pointname: nextProps.pointname,
                    pointtype: nextProps.pointtype,
                    pointOrd: nextProps.pointOrd,
                    icon: nextProps.icon
                });
            },

            drag: function (ev) {
                ev.dataTransfer.setData("ord", this.state.ord);
            },

            pointClicked: function (event) {
                // ev.dataTransfer.setData("ord", this.state.ord);
                const initallySelected = event.currentTarget.className.includes("-selected");
                const treeLines = document.getElementsByClassName("list-group-item-selected");
                for(let i = 0; i < treeLines.length; i++){
                    treeLines[i].className= treeLines[i].className.replace("-selected", "");
                }
                if (!initallySelected){
                    event.currentTarget.className += "-selected";
                }
            },
            formatIcon:function (icon) {
                let retrieveIcon="";
                if(icon.lastIndexOf("module://")>-1) {
                    retrieveIcon =   "/module/" + icon.substring(icon.lastIndexOf("module://") + 9);
                }
                return retrieveIcon;
            },
            render: function () {

                return (
                    <div id={"point" + this.state.slotPathOrd} data-point-ord={this.state.slotPathOrd} style={{ width: '100%', display: 'flex', flexDirection: 'row', flexWrap: 'nowrap' }} className="list-group-item"
                         onClick={this.pointClicked}>
                        <div style={{display: 'flex', flexDirection: 'column', justifyContent: 'center', marginLeft: '4px', marginRight: '4px' }}>
                            <img src={this.formatIcon(this.state.icon)} />
                        </div>
                        <div style={{display: 'flex', flexDirection: 'column', justifyContent: 'center'}}>
                            <div>
                                        <span className="wrap">
                                            <span className="overflow" style={{float:'left',width:'250px'}}>{this.state.pointname}</span>
                                            <span id="tooltipId" className="tooltip" style={{float:'left',width:'450px'}}>{this.state.pointname}</span>
                                        </span>
                            </div>
                        </div>
                    </div>
                );
            }
        });
        const TreeNode = React.createClass({

            getInitialState: function () {
                const node = this.props.node;
                return {
                    expanded: (node.state && node.state.hasOwnProperty('expanded')) ?
                        node.state.expanded :
                        (this.props.level < this.props.options.levels) || this.isPathInExpanded(node.slotPathOrd) ?
                            true :
                            false,
                }
            },

            toggleExpanded: function (id, event) {
                const that=this;
                if(!this.state.expanded && this.props.node.nodes.length>50) {
                    this.props.options.notifyWait(true);
                }
                setTimeout(function () {
                    that.setState({ expanded: !that.state.expanded });
                    that.props.options.updateExpandNodesList(that.props.node.slotPathOrd,!that.state.expanded);
                },100);

                event.stopPropagation();
            },
            componentDidUpdate:function() {
                this.props.options.notifyWait(false);
            },
            toggleSelected: function (id, node, event) {
                if((this.props.options.allowFolderSelect && !node.isPoint)|| node.isPoint){
                    const initiallySelected = event.currentTarget.className.includes("-selected");

                    const treeLines = document.getElementsByClassName("list-group-item1-selected");
                    for(let i = 0; i < treeLines.length; i++){
                        treeLines[i].className= treeLines[i].className.replace("-selected", "");
                    }

                    try {
                        if (!initiallySelected) {
                            event.currentTarget.className += "-selected";
                            this.props.options.updateRoot("", node.slotPathOrd);
                        } else {
                            this.props.options.updateRoot("", "");
                        }
                    }catch (e) {

                    }
                }

                event.stopPropagation();
            },

            drag: function (ev) {
                ev.dataTransfer.setData("ord", this.node.ord);
            },
            formatIcon:function (icon) {
                let retrieveIcon ="";
                if(icon.lastIndexOf("module://")>-1) {
                    retrieveIcon =   "/module/" + icon.substring(icon.lastIndexOf("module://") + 9);
                }
                return retrieveIcon;
            },
            isPathInExpanded:function(path){
                return this.props.options.expandedNodes.filter(a=>a.includes(path)).length>0;
            },
            addNode:function(node){
                let add=true;
                const that=this;
                if(node.isPoint) {
                    let contains = false;
                    node.nodes.forEach(function (n) {
                        if(!contains) {
                            contains = that.isPathInExpanded(n.slotPathOrd);
                        }
                    });
                    if(!contains) {
                        const op = this.props.options.filterConfig;
                        const nodeDataType = node.nodeType.toLowerCase();
                        contains = (op.isBoolean && nodeDataType.includes("boolean") && !nodeDataType.includes("securedboolean"))
                            || (op.isNumeric && nodeDataType.includes("numeric") && !nodeDataType.includes("securednumeric"))
                            || (op.isEnum && nodeDataType.includes("enum") && !nodeDataType.includes("securedenum"))
                            || (op.isSecureBoolean && nodeDataType.includes("securedboolean"))
                            || (op.isSecureNumeric && nodeDataType.includes("securednumeric"))
                            || (op.isSecureEnum && nodeDataType.includes("securedenum"));

                        if (contains && this.props.options.currentSearchText.trim() !== "") {
                            if(this.props.options.selParent!==""){
                                contains = node.slotPathOrd.toUpperCase().includes(this.props.options.selParent.toUpperCase());
                            }else {
                                contains = node.displayName.toUpperCase().includes(this.props.options.currentSearchText.trim().toUpperCase());
                            }
                        }
                    }
                    add=contains;
                }
                return add;

            },
            render: function () {
                const node = this.props.node;
                const options = this.props.options;
                let style;
                const style1={
                    width:'max-content'
                };
                if (!this.props.visible) {
                    style = {
                        display: 'none'
                    };
                }
                else {
                    style = {
                        color: node.color || options.color,
                        backgroundColor: 'none',
                    };
                }
                //indentations//
                const indents = [];
                for (let i = 0; i < this.props.level - 1; i++) {
                    indents.push(<span className='indent'></span>);
                }

                //expand collapse icon//
                let expandCollapseIcon;
                const divSpace= (<div>&nbsp;</div>)
                if (node.nodes) {
                    const bId = 'b' + node.slotPathOrd.toString();
                    let   hideStyle = { }
                    if(node.nodes.length===0 && node.isPoint){
                        hideStyle={ opacity:0};
                    }
                    if (!this.state.expanded) {
                        expandCollapseIcon = (
                            <button id={bId } className="expand collapsed" style={Object.assign({}, hideStyle)} onClick={this.toggleExpanded.bind(this, node.nodeId)} type="button"></button>
                        );
                    }
                    else {
                        expandCollapseIcon = (
                            <button id={bId} className="expand expanded" style={Object.assign({}, hideStyle)} onClick={this.toggleExpanded.bind(this, node.nodeId)} type="button"></button>
                        );
                    }
                }

                //Point Name//
                let nodeText;
                if (node.isPoint) {
                    nodeText = (
                        <div style={{ display: 'inline-block', flexGrow: '2', 'margin-top': '2px','margin-left': '3px', }}>
                            <SearchItem ord={node.ord} pointname={node.displayName} pointtype={node.pointtype}
                                        icon={node.icon} slotPathOrd={node.slotPathOrd} /></div>
                    );
                } else {
                    nodeText = (
                        <div>
                               <span class="icon"> &nbsp;
                                   <img src={this.formatIcon(node.icon)} /></span>&nbsp;
                            <span style={{'margin-top': '2px'}}>{node.displayName}</span>
                        </div>
                    );
                }

                //Child
                const children = [];
                if (node.nodes && (this.state.expanded ||this.props.options.currentSearchText.trim()!=="")) {
                    const _this = this;
                    node.nodes.forEach(function (node) {
                        if(_this.addNode(node)) {
                            children.push(<TreeNode node={node}
                                                    level={_this.props.level + 1}
                                                    visible={_this.state.expanded && _this.props.visible}
                                                    options={options}/>);
                        }
                    });
                }
                let paddingStyle = { }
                if(!node.isPoint){
                    paddingStyle={marginLeft:'3px'};
                }
                const that = this;
                return (
                    <li id={node.slotPathOrd}
                        data-folder-ord={node.slotPathOrd}
                        className='list-group-item1'
                        style={Object.assign({}, style, style1,paddingStyle)}
                        onClick={this.toggleSelected.bind(that, node.nodeId, node)}
                        key={node.nodeId}>
                        <div style={{display: 'flex', flexDirection: 'row', marginBottom: '0px',marginRight: '10px'}}>
                            {indents}
                            {node.isPoint && node.nodes.length>0?divSpace:null}
                            {expandCollapseIcon}
                            {nodeText}
                        </div>
                        {children}

                    </li>
                );
            }
        });

         const TreeView = React.createClass({

                    propTypes: {
                        levels: React.PropTypes.number,

                        color: React.PropTypes.string,
                        backColor: React.PropTypes.string,
                        borderColor: React.PropTypes.string,
                        onhoverColor: React.PropTypes.string,
                        selectedColor: React.PropTypes.string,
                        selectedBackColor: React.PropTypes.string,

                        enableLinks: React.PropTypes.bool,
                        highlightSelected: React.PropTypes.bool,
                        showBorder: React.PropTypes.bool,
                        showTags: React.PropTypes.bool,

                        nodes: React.PropTypes.arrayOf(React.PropTypes.number),

                        updateRoot: React.PropTypes.func,
                        lastSelectedFolder: React.PropTypes.string,
                        updateTree:React.PropTypes.bool
                    },

                    getDefaultProps: function () {
                        return {
                            levels: 2,

                            color: undefined,
                            backColor: undefined,
                            borderColor: undefined,
                            onhoverColor: '#F5F5F5', // TODO Not implemented yet, investigate radium.js 'A toolchain for React component styling'
                            selectedColor: '#FFFFFF',
                            selectedBackColor: '#428bca',

                            enableLinks: false,
                            highlightSelected: true,
                            showBorder: true,
                            showTags: false,

                            nodes: [],

                            updateRoot: () => { },
                            lastSelectedFolder: "",
                            updateTree:true
                        }
                    },

                    getInitialState: function () {
                        return {
                            data: undefined,
                            lastSelectedFolder: this.props.lastSelectedFolder,
                            updateTree:this.props.updateTree
                        }
                    },

                    shouldComponentUpdate: function (nextProps, nextState) {
                        if (this.state.updateTree &&
                            nextProps.data.length !== 0) {
                            this.state.data = nextProps.data;
                            this.state.lastSelectedFolder = nextProps.lastSelectedFolder;
                            this.state.updateTree=false;
                            return true;
                        }else if(nextProps.lastSearchText!==nextProps.currentSearchText){
                             this.state.data = nextProps.data;
                             return true;
                        } else {
                            return false;
                        }
                    },

                    componentDidUpdate() {
                    
                    const overflowpoint = document.getElementsByClassName("overflow");
                    const tooltippoint = document.getElementsByClassName("tooltip")
                    for (let i = 0; i < overflowpoint.length; i++) {
                        if(overflowpoint[i].innerText.length > 40){
                            tooltippoint[i].style.visibility="visible";
                        }
                        else{
                            tooltippoint[i].style.visibility="hidden";
                        }

                    }


                        const arr= this.props.expandedNodes;
                        arr.sort(function(a, b){
                          // ASC  -> a.length - b.length
                          // DESC -> b.length - a.length
                          return a.length - b.length;
                        });
                       for(let i=0;i<arr.length;i++){
                        if (arr[i] === "") {
                            continue;
                        }
                        const lastExpandedPaths = arr[i];
                            const buttonDom = document.getElementById("b"+ lastExpandedPaths);
                            if (buttonDom != null && !buttonDom.className.includes('expanded')) {
                                buttonDom.click();
                            }
                     }
                     if(this.props.lastSelectedPoint!==undefined && this.props.lastSelectedPoint.trim()!==""){
                      const lastPoint = this.props.lastSelectedPoint
                      this.setLastSelectedPoint(lastPoint);
                     }
                    },
                    setLastSelectedPoint:function(lastPoint){
                        const folderPaths = lastPoint.split('/');
                        for (let folderPathIndex = 0; folderPathIndex < folderPaths.length - 1; folderPathIndex++) {
                            const buttonDomId = folderPaths.slice(0, folderPathIndex + 1).join('/');
                            const buttonDom = document.getElementById("b"+ buttonDomId);
                            if (buttonDom != null && !buttonDom.className.includes('expanded')) {
                                buttonDom.click();
                            }
                        }
                        const selectedDom = document.getElementById("point"+lastPoint);
                        if (selectedDom != null) {
                            if(!selectedDom.className.includes('list-group-item-selected')){
                                selectedDom.className= selectedDom.className+"-selected";
                                this.props.updateRoot("",lastPoint);
                               }
                        }else{
                              this.props.updateRoot("","");
                        }
                    },
                    setNodeId: function (node) {

                        if (!node.nodes){ return;}

                        const _this = this;
                        node.nodes.forEach(function checkStates(node) {
                            node.nodeId = _this.props.nodes.length;
                            _this.props.nodes.push(node);
                            _this.setNodeId(node);
                        });
                    },

                    render: function () {

                        const data = this.state.data;

                        this.setNodeId({ nodes: data });

                        const children = [];
                        if (data) {
                            const _this = this;
                            data.forEach(function (node) {
                                children.push(<TreeNode node={node}
                                    level={1}
                                    visible={true}
                                    options={_this.props} />);
                            });
                        }

                        return (
                            <div id='treeview' className='treeview'>
                                <ul className='list-group' >
                                    {children}
                                </ul>
                            </div>

                        );
                    }
                });

                const SearchTree = React.createClass({

                    propTypes: {
                        items: React.PropTypes.array,
                        pointChooserConfig: React.PropTypes.object,
                        lastSearchText:React.PropTypes.string,
                        updateTree:React.PropTypes.bool,
                        expandedNodes:React.PropTypes.array,
                        filterBoolean:React.PropTypes.bool,
                        filterSecureBoolean:React.PropTypes.bool,
                        filterNumeric:React.PropTypes.bool,
                        filterSecureNumeric:React.PropTypes.bool,
                        filterEnum:React.PropTypes.bool,
                        filterSecureEnum:React.PropTypes.bool,
                        allowFolderSelect:React.PropTypes.bool,
                        collapseAll:React.PropTypes.bool,
                        currentPoints:React.PropTypes.array,
                    },

                    getDefaultProps: function () {
                        return {
                            items: [],
                            pointChooserConfig: null,
                            currentSearchText:"",
                            lastSearchText:"",
                            updateTree: false,
                            expandedNodes:[],
                            filterBoolean:true,
                            filterSecureBoolean:true,
                            filterNumeric:true,
                            filterSecureNumeric:true,
                            filterEnum:true,
                            filterSecureEnum:true,
                            allowFolderSelect:false,
                            collapseAll:false,
                            currentPoints:[]
                        }
                    },

                    getInitialState: function () {
                        return {
                            items: this.props.items,
                            pointChooserConfig: this.props.pointChooserConfig,
                            searchString: "",
                            rootFolder: "",
                            currentSearchText:this.props.currentSearchText,
                            lastSearchText:this.props.lastSearchText,
                            updateTree:this.props.updateTree,
                            expandedNodes:this.props.expandedNodes,
                            filterBoolean:this.props.filterBoolean,
                            filterSecureBoolean:this.props.filterSecureBoolean,
                            filterNumeric:this.props.filterNumeric,
                            filterSecureNumeric:this.props.filterSecureNumeric,
                            filterEnum:this.props.filterEnum,
                            filterSecureEnum:this.props.filterSecureEnum,
                            allowFolderSelect:this.props.allowFolderSelect,
                            collapseAll: this.props.collapseAll,
                            currentPoints:this.props.currentPoints
                        }
                    },

                    componentWillReceiveProps: function (nextProps) {
                        if (this.state.pointChooserConfig === null &&
                            nextProps.pointChooserConfig != null) {
                            this.setState({
                                items: nextProps.items,
                                pointChooserConfig: nextProps.pointChooserConfig,
                                searchString: nextProps.pointChooserConfig.lastSearchText,
                            });
                            this.setSearchRoot(nextProps.pointChooserConfig.lastSelectedFolder,"");
                        }
                         this.setState({
                                items: nextProps.items,
                                pointChooserConfig: nextProps.pointChooserConfig,
                                filterBoolean:nextProps.filterBoolean,
                                filterSecureBoolean:nextProps.filterSecureBoolean,
                                filterNumeric:nextProps.filterNumeric,
                                filterSecureNumeric:nextProps.filterSecureNumeric,
                                filterEnum:nextProps.filterEnum,
                                filterSecureEnum: nextProps.filterSecureEnum,
                                currentSearchText:nextProps.currentSearchText,
                                lastSearchText:nextProps.lastSearchText,
                                updateTree:nextProps.updateTree,
                                allowFolderSelect:nextProps.allowFolderSelect,
                                collapseAll:nextProps.collapseAll
                           });

                    },

                    setSearchRoot: function (root,selectSlotOrd){
                        this.setState({
                            rootFolder: root
                        });
                        this.props.selectedOrdNotify(selectSlotOrd);
                    },
                    updateExpandNodesList:function(nodeId,add){
                        if(add){
                         if(!this.checkExistOrRemove(nodeId,true)){
                            this.state.expandedNodes.push(nodeId);}
                        }else{
                             this.checkExistOrRemove(nodeId);
                        }

                    },
                    checkExistOrRemove: function(nodeVal,checkExists=false){
                     let exists=false;
                     for(let i=0;i<this.state.expandedNodes.length;i++){
                        if(nodeVal=== this.state.expandedNodes[i]){
                         exists=true;
                         if(!checkExists){
                            this.state.expandedNodes.splice(i,1);
                         }
                        }
                     }
                     return exists;
                    },
                    getLastSelectedFolder: function () {
                        if (this.state.pointChooserConfig != null) {
                            return this.state.pointChooserConfig.lastSelectedFolder;
                        } else {
                            return "";
                        }
                    },
                   getLastSelectedPoint: function () {
                        if (this.state.pointChooserConfig != null) {
                            return this.state.pointChooserConfig.lastSelectedPoint;
                        } else {
                            return "";
                        }
                    },
                    filterTree:function(pointName,nodeType,slotPathOrd){
                     const nodeDataType= nodeType.toLowerCase();
                        let contains = (this.state.filterBoolean && nodeDataType.includes("boolean") && !nodeDataType.includes("securedboolean"))
                                    || (this.state.filterNumeric && nodeDataType.includes("numeric") && !nodeDataType.includes("securednumeric"))
                                    || (this.state.filterEnum && nodeDataType.includes("enum") && !nodeDataType.includes("securedenum"))
                                    || (this.state.filterSecureBoolean && nodeDataType.includes("securedboolean"))
                                    || (this.state.filterSecureNumeric && nodeDataType.includes("securednumeric"))
                                    || (this.state.filterSecureEnum && nodeDataType.includes("securedenum"));

                      if(contains && this.state.currentSearchText.trim()!==""){
                        if(this.props.selParent!==""){
                            contains = slotPathOrd.toUpperCase().includes(this.props.selParent.toUpperCase());
                        }else {
                            contains = pointName.toUpperCase().includes(this.state.currentSearchText.trim().toUpperCase());
                        }
                        if(contains){
                         this.addFilteredPointToExpandList(slotPathOrd);
                        }
                      }
                      return contains;
                    },
                    addFilteredPointToExpandList(ord){
                    const folderPaths = ord.split('/');
                    for (let folderPathIndex = 0; folderPathIndex < folderPaths.length - 1; folderPathIndex++) {
                        const buttonDomId = folderPaths.slice(0, folderPathIndex + 1).join('/');
                        this.updateExpandNodesList(buttonDomId,true);
                      }
                    },
                    removeFromExpandedNodes:function(){
                      const that=this;
                      const currentList = that.state.currentPoints;
                      const expandedNodes = that.state.expandedNodes;
                     for(let i=0;i<expandedNodes.length;i++){
                       const slotArray=expandedNodes[i].split('/');
                       const point = slotArray[slotArray.length-1];
                        if(currentList.filter(a=>a.includes(point)).length===0){
                            that.state.expandedNodes.splice(i,1);
                        }
                     }
                    },
                    filterTreeData:function(objTree){
                            for (let i = 0; i < objTree.length; i++) {
                                this.filterData(objTree[i]);
                            }
                    },
                    filterData:function(obj){
                    if(obj.isPoint){
                        this.filterTree(obj.displayName,obj.nodeType,obj.slotPathOrd);
                    }
                   if(obj.nodes.length>0) {
                       for (let i = 0; i < obj.nodes.length; i++) {
                           this.filterData(obj.nodes[i]);
                       }
                   }
                   },
                    render: function () {
                        if(this.state.collapseAll && this.state.expandedNodes.length>0){
                         this.state.expandedNodes.splice(0,this.state.expandedNodes.length);
                        }
                        this.filterTreeData(this.state.items);
                        const tree = this.state.items;
                        const lastSelectedFolder = this.getLastSelectedFolder();
                        const lastSelectedPoint = this.getLastSelectedPoint();
                        return (
                            <div   style={{height: '100%', overflow: 'auto'}}>

                                    <TreeView
                                        data={tree}
                                        levels={0}
                                        highlightSelected={true}
                                        updateRoot={this.setSearchRoot}
                                        lastSelectedFolder={lastSelectedFolder}
                                        currentSearchText = {this.state.currentSearchText}
                                        lastSearchText = {this.state.lastSearchText}
                                        expandedNodes = {this.state.expandedNodes}
                                        updateExpandNodesList={this.updateExpandNodesList}
                                        allowFolderSelect={this.state.allowFolderSelect}
                                        lastSelectedPoint={lastSelectedPoint}
                                        filterConfig={{isBoolean:this.state.filterBoolean,
                                                       isSecureBoolean:this.state.filterSecureBoolean,
                                                       isNumeric:this.state.filterNumeric,
                                                       isSecureNumeric:this.state.filterSecureNumeric,
                                                       isEnum:this.state.filterEnum,
                                                       isSecureEnum:this.state.filterSecureEnum
                                        }}
                                        notifyWait={this.props.notifyWait}
                                        selParent={this.props.selParent}
                                        />
                            </div>
                        );
                    }
                });


        return SearchTree;
    }
});