
/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225 on 7/16/2019
 *
 */



define('nmodule/easyDatabaseManager/rc/js/defaultView',['baja!',
        'jquery',
        'lex!easyDatabaseManager'],
    function (Baja,
              $,
              lexicons) {

        

        var lex = lexicons[0];
        /**
         * Description of your widget.
         *
         * @class
         * @alias module:nmodule/easyDatabaseManager/rc/js/defaultView
         */
        var view = function(dom, vname, id, message, featureDescription, summaryMessage, stepDescription, stepCount, backBttnMsg, nextBttnMsg, cancelBttnMsg, skipBttnMsg)
        {
            /*
             * Everything defined here (as part of _self) are available across all views.
            */

            var _self = this;
            //widget dom (this gives access to header and navigation buttons as well.
            _self.dom = dom;
            // All data to be passed between views will go in data{} object.
            _self.data = {};
            // Params required to initialise view
            _self.params = {
                "vname" : vname,
                "vid" : id,
                "message" : message || "",
                "featureDescription" : featureDescription || "",
                "summaryMessage" : summaryMessage || "",
                "stepDescription" : stepDescription || "",
                "stepCount" : stepCount || "",
                "backBttnMsg" : backBttnMsg || lex.get("pdm.PointDatabaseManager.button.back"),
                "nextBttnMsg" : nextBttnMsg || lex.get("pdm.PointDatabaseManager.button.next"),
                "cancelBttnMsg" : cancelBttnMsg || lex.get("pdm.PointDatabaseManager.button.cancel"),
                "skipBttnMsg" : skipBttnMsg || lex.get("pdm.PointDatabaseManager.button.skip")};
            // To track navigation button status within view
            _self.buttonstatus = {
                disabledBack : false,
                disabledNext : false,
                disabledCancel: false,
                disabledSkip: false}
        };

        //these are prototype functions and needs to be overridden in extended screens.
        /**
         * Load view of current wizard step - licenseStatusView/unusedPointsView/
         * unwantedPointsView/reviewPointsView/deletePointsView/postDeleteStatusView
         * @param element: dom element the view will be appended to.
         * @param params: javascript object with widget parameters required to load the view within the widget
         */
        view.prototype.loadView = function(element, params) {
            throw new Error('Cannot call abstract method, please overwrite in current view: ' + element + " :: " + params);
        };

        //these are prototype functions and needs to be overridden in extended screens.
        /**
         * validate user input before proceeding to next screen.
         * This is called before view.prototype.next is called.
         *
         * @returns {boolean}: return true/false based on validity of user input
         */
        view.prototype.validate = function() {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        //these are prototype functions and needs to be overridden in extended screens.
        /**
         * clean up and save before going to next view
         *
         */
        view.prototype.next = function() {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        //these are prototype functions and needs to be overridden in extended screens.
        /**
         * clean up and save before going to previous view
         *
         */
        view.prototype.back = function() {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        //these are prototype functions and needs to be overridden in extended screens.
        /**
         * cancel operation - cancel button supported cancellable operation in current view
         *
         */
        view.prototype.cancel = function() {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        //these are prototype functions and needs to be overrdiden in extended screens.
        view.prototype.updateView = function() {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        /**
         * To pass data between views
         *
         */
        view.prototype.getData = function() {
            return this.data;
        };

        /**
         * provides navigation button status as set by view.
         *
         */
        view.prototype.getActionBttnsStatus = function () {
            return this.buttonstatus;
        };

        /**
         * Provide params needed to update view headers
         *
         */
        view.prototype.getViewHeaders = function() {
            return this.params;
        };

        return view;
    });

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/licenseStatusViewTemplate',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div id=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"vid") || (depth0 != null ? lookupProperty(depth0,"vid") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"vid","hash":{},"data":data,"loc":{"start":{"line":1,"column":9},"end":{"line":1,"column":16}}}) : helper)))
    + "\" class=\"\">\n    <div class=\"PDM-step-details\">\n        <div class=\"PDM-contents-step-summary\">\n            <span class=\"PDM-step-count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepCount") || (depth0 != null ? lookupProperty(depth0,"stepCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepCount","hash":{},"data":data,"loc":{"start":{"line":4,"column":41},"end":{"line":4,"column":54}}}) : helper)))
    + "</span>\n            <span class=\"PDM-step-name\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"summaryMessage") || (depth0 != null ? lookupProperty(depth0,"summaryMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"summaryMessage","hash":{},"data":data,"loc":{"start":{"line":5,"column":40},"end":{"line":5,"column":58}}}) : helper)))
    + "</span>\n        </div>\n        <div class=\"PDM-step-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepDescription") || (depth0 != null ? lookupProperty(depth0,"stepDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepDescription","hash":{},"data":data,"loc":{"start":{"line":7,"column":42},"end":{"line":7,"column":61}}}) : helper)))
    + "</div>\n    </div>\n    <div class=\"PDM-contents-step1-details\">\n        <div class=\"PDM-network-capacity-available-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"networkCapacityDescription") || (depth0 != null ? lookupProperty(depth0,"networkCapacityDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"networkCapacityDescription","hash":{},"data":data,"loc":{"start":{"line":10,"column":64},"end":{"line":10,"column":94}}}) : helper)))
    + "\n            <span class=\"PDM-network-capacity-count\" id=\"PDM-network-available-count\"></span>\n        </div>\n        <div id=\"PDM-license-status-view-stage\">\n        </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/licenseStatusViewTemplate', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/LicenseSummaryTable',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"PDM-license-status-counter-container-col\">\n    <div class=\"PDM-license-status-counter-table-container\">\n        <div class=\"Table\">\n            <div class=\"Heading\">\n                <div class=\"Cell\">\n                    <p>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"driver") || (depth0 != null ? lookupProperty(depth0,"driver") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"driver","hash":{},"data":data,"loc":{"start":{"line":6,"column":23},"end":{"line":6,"column":33}}}) : helper)))
    + "</p>\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\" >\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"licensePoints") || (depth0 != null ? lookupProperty(depth0,"licensePoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"licensePoints","hash":{},"data":data,"loc":{"start":{"line":11,"column":27},"end":{"line":11,"column":44}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell\">\n                    <input type=\"number\"  min=\"0\" step=\"1\" oninput=\"validity.valid||(value='');\" class=\"PDM-license-status-text\" value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"target") || (depth0 != null ? lookupProperty(depth0,"target") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"target","hash":{},"data":data,"loc":{"start":{"line":14,"column":136},"end":{"line":14,"column":146}}}) : helper)))
    + "\" placeholder=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"unlimited") || (depth0 != null ? lookupProperty(depth0,"unlimited") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"unlimited","hash":{},"data":data,"loc":{"start":{"line":14,"column":161},"end":{"line":14,"column":174}}}) : helper)))
    + "\">\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUse") || (depth0 != null ? lookupProperty(depth0,"pointsInUse") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUse","hash":{},"data":data,"loc":{"start":{"line":19,"column":27},"end":{"line":19,"column":42}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"points-in-use numeric-value\" data-value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValue") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValue","hash":{},"data":data,"loc":{"start":{"line":22,"column":74},"end":{"line":22,"column":94}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValueFormatted") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValueFormatted") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValueFormatted","hash":{},"data":data,"loc":{"start":{"line":22,"column":96},"end":{"line":22,"column":125}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPoints") || (depth0 != null ? lookupProperty(depth0,"remainingPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPoints","hash":{},"data":data,"loc":{"start":{"line":27,"column":27},"end":{"line":27,"column":46}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"remaining-points numeric-value "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPointsClass") || (depth0 != null ? lookupProperty(depth0,"remainingPointsClass") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPointsClass","hash":{},"data":data,"loc":{"start":{"line":30,"column":64},"end":{"line":30,"column":88}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPointsValue") || (depth0 != null ? lookupProperty(depth0,"remainingPointsValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPointsValue","hash":{},"data":data,"loc":{"start":{"line":30,"column":90},"end":{"line":30,"column":114}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/LicenseSummaryTable', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/GlobalLicenseNetworkTable',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"PDM-license-status-counter-container-col\">\n    <div class=\"PDM-license-status-counter-table-container\">\n        <div class=\"Table\">\n            <div class=\"Heading\">\n                <div class=\"Cell\">\n                    <p>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"driver") || (depth0 != null ? lookupProperty(depth0,"driver") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"driver","hash":{},"data":data,"loc":{"start":{"line":6,"column":23},"end":{"line":6,"column":33}}}) : helper)))
    + "</p>\n                </div>\n            </div>\n            <div class=\"Row\" >\n                <div class=\"Cell\" >\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUse") || (depth0 != null ? lookupProperty(depth0,"pointsInUse") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUse","hash":{},"data":data,"loc":{"start":{"line":11,"column":27},"end":{"line":11,"column":42}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"points-in-use numeric-value\" data-value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValue") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValue","hash":{},"data":data,"loc":{"start":{"line":14,"column":74},"end":{"line":14,"column":94}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValueFormatted") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValueFormatted") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValueFormatted","hash":{},"data":data,"loc":{"start":{"line":14,"column":96},"end":{"line":14,"column":125}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/GlobalLicenseNetworkTable', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/GlobalLicenseSummaryTable',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "    <div class=\"PDM-global-contents-step1-details\">\n        <div class=\"PDM-global-summary-container\">\n            <div class=\"PDM-global-capacity-available-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"globalCapacityDescription") || (depth0 != null ? lookupProperty(depth0,"globalCapacityDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"globalCapacityDescription","hash":{},"data":data,"loc":{"start":{"line":3,"column":67},"end":{"line":3,"column":96}}}) : helper)))
    + "\n            </div>\n            <div class=\"Table Global-points-summary\">\n                <div class=\"Row\">\n                    <div class=\"Cell\">\n                        <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"licensePoints") || (depth0 != null ? lookupProperty(depth0,"licensePoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"licensePoints","hash":{},"data":data,"loc":{"start":{"line":8,"column":31},"end":{"line":8,"column":48}}}) : helper)))
    + "</label>\n                    </div>\n                    <div class=\"Cell\">\n                        <input type=\"number\" min=\"0\" step=\"1\" oninput=\"validity.valid||(value='');\"\n                            class=\"PDM-license-status-text\" value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"target") || (depth0 != null ? lookupProperty(depth0,"target") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"target","hash":{},"data":data,"loc":{"start":{"line":12,"column":67},"end":{"line":12,"column":77}}}) : helper)))
    + "\" placeholder=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"unlimited") || (depth0 != null ? lookupProperty(depth0,"unlimited") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"unlimited","hash":{},"data":data,"loc":{"start":{"line":12,"column":92},"end":{"line":12,"column":105}}}) : helper)))
    + "\" id=\"txtGlobalLicensedPoints\">\n                    </div>\n                </div>\n                <div class=\"Row\">\n                    <div class=\"Cell\">\n                        <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUse") || (depth0 != null ? lookupProperty(depth0,"pointsInUse") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUse","hash":{},"data":data,"loc":{"start":{"line":17,"column":31},"end":{"line":17,"column":46}}}) : helper)))
    + "</label>\n                    </div>\n                    <div class=\"Cell spanwidth\">\n                        <span class=\"points-in-use numeric-value\"\n                            data-value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValue") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValue","hash":{},"data":data,"loc":{"start":{"line":21,"column":40},"end":{"line":21,"column":60}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValueFormatted") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValueFormatted") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValueFormatted","hash":{},"data":data,"loc":{"start":{"line":21,"column":62},"end":{"line":21,"column":91}}}) : helper)))
    + "</span>\n                    </div>\n                </div>\n                <div class=\"Row\">\n                    <div class=\"Cell\">\n                        <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPoints") || (depth0 != null ? lookupProperty(depth0,"remainingPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPoints","hash":{},"data":data,"loc":{"start":{"line":26,"column":31},"end":{"line":26,"column":50}}}) : helper)))
    + "</label>\n                    </div>\n                    <div class=\"Cell spanwidth\">\n                        <span\n                            class=\"remaining-points numeric-value "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPointsClass") || (depth0 != null ? lookupProperty(depth0,"remainingPointsClass") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPointsClass","hash":{},"data":data,"loc":{"start":{"line":30,"column":66},"end":{"line":30,"column":90}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPointsValue") || (depth0 != null ? lookupProperty(depth0,"remainingPointsValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPointsValue","hash":{},"data":data,"loc":{"start":{"line":30,"column":92},"end":{"line":30,"column":116}}}) : helper)))
    + "</span>\n                    </div>\n                </div>\n\n            </div>\n        </div>\n\n        <div id=\"PDM-global-license-status-view-stage\">\n        </div>\n    </div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/GlobalLicenseSummaryTable', t);
return t;
});
/* END_TEMPLATE */
;
/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225 on 7/17/2019
 *
 */
define('nmodule/easyDatabaseManager/rc/js/licenseStatusView',['baja!',
    'jquery',
    'underscore',
    'dialogs',
    'lex!easyDatabaseManager',
    'bajaux/Widget',
    'nmodule/webEditors/rc/fe/fe',
    'nmodule/webEditors/rc/wb/table/Table',
    'nmodule/webEditors/rc/wb/table/model/columns/JsonObjectPropertyColumn',
    'nmodule/webEditors/rc/wb/table/model/TableModel',
    'nmodule/webEditors/rc/wb/table/model/Row',
    'nmodule/easyDatabaseManager/rc/js/defaultView',
    'hbs!nmodule/easyDatabaseManager/rc/hbs/licenseStatusViewTemplate',
    'hbs!nmodule/easyDatabaseManager/rc/hbs/LicenseSummaryTable',
    'hbs!nmodule/easyDatabaseManager/rc/hbs/GlobalLicenseNetworkTable',
    'hbs!nmodule/easyDatabaseManager/rc/hbs/GlobalLicenseSummaryTable',
],
    function (Baja,
        $,
        _,
        dialogs,
        lexicons,
        Widget,
        fe,
        Table,
        JsonObjectPropertyColumn,
        TableModel,
        Row,
        defaultView,
        template,
        tplPDMSummaryTable,
        tplPDMGlobalNetworkTable,
        tplPDMGlobalSummaryTable
    ) {

        

        var lex = lexicons[0], dom, isIncreaseFooterSize = true;
        var setOfNwNotConsumingGlobalCapacity;
        var globalCapacityNetworksSet;
        var totalGlobalCapcityUsed = 0;
        var brandCode = null;
        var globalcapcitylimit = 0;
        function isUnlimited(limit) {
            if (isNaN(limit)) {
                return true;
            }
            return limit === -1;
        }


        // licenseStatusView step
        // arguments: dom, vname, id, message, summaryMessage, backBttnMsg, nextBttnMsg, cancelBttnMsg
        var licenseStatusView = function () {
            defaultView.apply(this, arguments);
            //update which buttons will be available
            this.buttonstatus = {
                disabledNext: false
            };
        };
        licenseStatusView.prototype = Object.create(defaultView.prototype, {
            'constructor': licenseStatusView
        });

        //these variables will be updated in loadView with values passed from PointDatabaseManagerWidget
        licenseStatusView.component = null;
        licenseStatusView.service = null;
        licenseStatusView.subscriber = null;
        // call this function anytime you want to update nav action button status to enable/disable them
        licenseStatusView.updateActionButtonsStatus = null;
        licenseStatusView.notifyUser = null;

        /**
         * Load view of current wizard step - licenseStatusView
         * @param element: dom element the view will be appended to.
         * @param params: javascript object with widget parameters required to load the view within the widget
         */
        licenseStatusView.prototype.loadView = function (element, params) {
            licenseStatusView.component = params.component;
            licenseStatusView.service = params.service;
            licenseStatusView.subscriber = params.subscriber;
            licenseStatusView.updateActionButtonsStatus = params.updateActionButtonsStatus;
            licenseStatusView.notifyUser = params.notifyUser;
            dom = element;
            $(element).append(template({
                vid: this.params.vid,
                //summaryMessage: this.params.summaryMessage
                summaryMessage: this.params.summaryMessage,
                stepCount: this.params.stepCount,
                stepDescription: this.params.stepDescription,
                networkCapacityDescription: lex.get("pdm.PointDatabaseManager.licenseStatusView.available.network.points.description")
            }));
            $(element).find(".PDM-contents-step-summary").css("border-top-color", params.colorCode);
            brandCode = params.colorCode;
            $startDiscoveryJob("station:|" + params.component.getSlotPath().toString());
        };

        licenseStatusView.prototype.showLoadedView = function () {
            // If we come back to this screen do some actions if required
        };

        /**
         * validate user input before proceeding to next screen.
         * This is called before view.prototype.next is called.
         *
         * @returns {boolean}: return true/false based on validity of user input
         */
        licenseStatusView.prototype.validate = function () {
            return new Promise(function (resolve) {
                //do any validations needed here.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * clean up and save before going to next view
         *
         */
        licenseStatusView.prototype.next = function () {

            var that = this,
                targetLicenseData = [],
                isNext = true;

            return new Promise(function (resolve) {
                // do any backend communication needed here before moving to next screen.
                // resolve once all the input is validated and good to move to next screen

                //PDM-license-status-view-stage
                var globalLicenseInputBox = null;
                $.each($(dom).find("#PDM-license-status-view-stage input, .PDM-global-summary-container input"), function () {
                    /*if ( $(this).val() === "" || (isNaN($(this).val()) && $(this).val() !== "Unlimited")) {
                        isNext = false;
                    }*/
                    if (isNaN($(this).val())) {
                        isNext = false;
                    } else {
                        var item = {};
                        item["Network"] = $(this).attr('id');
                        item["Target"] = $(this).val();
                        if ($(this).val() === "") {
                            item["Target"] = "0";
                        }

                        if(this.id === "txtGlobalLicensedPoints")
                            globalLicenseInputBox = item;
                        else
                            targetLicenseData.push(item);
                    }
                });
                targetLicenseData.push(globalLicenseInputBox)
                if (isNext) {
                    that.data = {
                        licenseViewData: { targetLicense: targetLicenseData },
                        isIncreaseFooterSize : isIncreaseFooterSize
                    };
                    resolve(true);
                } else {
                    // Show Dialog

                    var dialog = dialogs.make({
                        title: lex.get("pdm.PointDatabaseManager.licenseStatusView.error.title"),
                        content: lex.get("pdm.PointDatabaseManager.licenseStatusView.error.message"),
                        ok: function (dlg) {
                            var $dialog = dlg.jq();
                            $dialog.find("div.js-dialog.ux-root").removeClass("confirm-js-dialog");
                            dlg.close();
                        }
                    });
                    dialog.show();
                    resolve(false);
                }
            });
        };

        /**
         * clean up and save before going to previous view
         *
         */
        licenseStatusView.prototype.back = function () {
            return new Promise(function (resolve) {
                // do any cleanup/backend communication needed here before moving to previous screen.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * cancel operation - cancel button supported cancellable operation in current view
         * This is invoked only if this.params.isCancelAvailable is set to true.
         */
        licenseStatusView.prototype.cancel = function () {
            // Cancel Operation
        };

        //these are prototype functions and needs to be overriden in extended screens.
        licenseStatusView.prototype.updateView = function () {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        /**
         * Kick off the discovery job using the component handles of the items selected in the previous
         * screen, and the values of the checkboxes from the options screen.
         *
         * @param {Arrary.<String>} handles - an array of handles for the components selected in the previous screen.
         * @private
         */
        function $startDiscoveryJob(nodeVal) {
            Baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'findLicenseDetails',
                args: [{ nodeOrd: nodeVal }]
            }).then(function (list) {
                Baja.rpc({
                    typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                    method: 'findGlobalCapacityDetails'
                }).then(function (globalCapacityDetails) {
                    $updateDeviceTable(list, globalCapacityDetails);
                })
            })
        };

        /**
         * Tells whether this network can consume global point capacity
         */
        function $excludedFromGlobalCapacity(networkType) {
            var driverName = networkType.substring(0, networkType.indexOf(':'));
            return setOfNwNotConsumingGlobalCapacity.has(driverName);
        }

        /**
         * Update the table with the summaries of devices currently being discovered.
         *
         * @private
         * @param {baja.Component} job - the discovery job.
         */
        function $updateDeviceTable(list, globalCapacityDetails) {
            if (!dom) {
                return;
            }

            var networkList = JSON.parse(list);
            if (!networkList || networkList.length === 0) {
                Baja.outln("Either no data is available or user do not have privilege to view data.");
                licenseStatusView.notifyUser(dom.closest(".PointDataManager-wizard"), lex.get("pdm.PointDatabaseManager.no.data.or.privilege.user.message"));
                licenseStatusView.updateActionButtonsStatus(
                    $(dom).parent(),
                    {
                        disabledNext: true
                    }
                );
                return;
            }

            var tempGlobalCapacityDetails = JSON.parse(globalCapacityDetails);
            globalcapcitylimit = tempGlobalCapacityDetails.globalPointCapacityLimit;
            var GlobalPointsSummaryElem = $(tplPDMGlobalSummaryTable({
                globalCapacityDescription: lex.get("pdm.PointDatabaseManager.licenseStatusView.available.global.points.description"),
                licensePoints: lex.get("pdm.PointDatabaseManager.licenseStatusView.license.points"),
                unlimited: "none",
                remainingPoints: lex.get("pdm.PointDatabaseManager.licenseStatusView.remaining.points"),
                pointsInUse: lex.get("pdm.PointDatabaseManager.licenseStatusView.points.in.use"),
                target: (tempGlobalCapacityDetails.globalPointCapacityLimit > 0) ? tempGlobalCapacityDetails.globalPointCapacityLimit : ""
            }))

            //Display Global Points summary table only if the Global points count is available and do not add border when globalCapacity not available
            var isGlobalPointCapacityAvailable = false;
            if (tempGlobalCapacityDetails.globalPointCapacityLimit)//!tempGlobalCapacityDetails.globalPointCapacityLimit) remove this comment after completion
            {
                isGlobalPointCapacityAvailable = true
                $("#PDM-step1-licenseStatusView > div.PDM-step-details").after($(GlobalPointsSummaryElem));
                $(".PDM-footer").addClass("PDM-footer-increase-margin");
            }

            //set brand color as border for the table when both the elements are created
            if (isGlobalPointCapacityAvailable) {
                $(dom).find(".PDM-global-contents-step1-details,.PDM-contents-step1-details").css("border-color", brandCode);
            }

            if (!tempGlobalCapacityDetails || tempGlobalCapacityDetails.length === 0) {
                setOfNwNotConsumingGlobalCapacity = new Set();
            } else {
                setOfNwNotConsumingGlobalCapacity = new Set(tempGlobalCapacityDetails.networksNotConsumingGlobalPointCapacity);
            }

            //get respective stage element to fill it with each network
            var networkStage = $(dom).find('#PDM-step1-licenseStatusView #PDM-license-status-view-stage');
            var networkGlobalStage = $(dom).find('#PDM-step1-licenseStatusView #PDM-global-license-status-view-stage');
            var networkCount = 0;
            globalCapacityNetworksSet = new Set();

            _.each(networkList, function (network) {
                if (network.visible) {
                    var remainingPointsClass = (network.available >= 0 || network.available == -1) ? "positive" : "negative";

                    var rowElem = $('<div class="PDM-license-status-container-row"></div>');
                    $(rowElem).attr('id', removeSpaceAndSpecialChars(network.name) + "_" + networkCount);
                    var elem = null;

                    if (!$excludedFromGlobalCapacity(network.type) && tempGlobalCapacityDetails.globalPointCapacityLimit != 0) {//!$excludedFromGlobalCapacity(network.type) remove 
                        globalCapacityNetworksSet.add(removeSpaceAndSpecialChars(network.name) + "_" + networkCount);
                        networkGlobalStage.append(rowElem);
                        elem = $(tplPDMGlobalNetworkTable({
                            driver: network.name,
                            pointsInUse: lex.get("pdm.PointDatabaseManager.licenseStatusView.points.in.use"),
                            pointsInUseValue: network.existing,
                            pointsInUseValueFormatted: network.existing.toLocaleString(),
                        }));
                    } else {
                        networkStage.append(rowElem);
                        elem = $(tplPDMSummaryTable({
                            driver: network.name,
                            target: network.limit === -1 ? "" : network.limit,
                            unlimited: "none",
                            licensePoints: lex.get("pdm.PointDatabaseManager.licenseStatusView.license.points"),
                            globalPointsCapacity: lex.get("pdm.PointDatabaseManager.licenseStatusView.global.points.capacity"),
                            pointsInUse: lex.get("pdm.PointDatabaseManager.licenseStatusView.points.in.use"),
                            remainingPoints: lex.get("pdm.PointDatabaseManager.licenseStatusView.remaining.points"),
                            pointsInUseValue: network.existing,
                            pointsInUseValueFormatted: network.existing.toLocaleString(),
                            remainingPointsValue: network.available === -1 ? 0 : network.available.toLocaleString(),
                            remainingPointsClass: remainingPointsClass
                        }));
                        var textbox = elem.find('.PDM-license-status-text');
                        $(textbox).attr('id', "txt" + removeSpaceAndSpecialChars(network.name) + "_" + networkCount);
                        networkCount++;
                        $addTextBoxEvent(textbox, network, false);
                    }
                    rowElem.append(elem);
                }
            });

            /*$(".PDM-license-status-text").attr("placeholder", availableGlobalCapacity);*/
            updatePlaceholder(tempGlobalCapacityDetails);
            $addTextBoxEvent($(dom).find("#txtGlobalLicensedPoints"), null, true);

            isIncreaseFooterSize = true;
            //do not display block if there are no networks in drivers with individual licensing and drivers with global licensing respectively.
            if (!($(dom).find('#PDM-step1-licenseStatusView #PDM-license-status-view-stage .PDM-license-status-container-row').length)) {
                $(dom).find(".PDM-contents-step1-details").css("display", "none");
                $(dom).find(".PDM-global-contents-step1-details").addClass("PDM-hide-element-set-margin");
                $(".PDM-footer").removeClass("PDM-footer-increase-margin");
                isIncreaseFooterSize = false;
            }
            if (!($(dom).find('#PDM-step1-licenseStatusView #PDM-global-license-status-view-stage .PDM-license-status-container-row').length)) {
                $(dom).find(".PDM-global-contents-step1-details").css("display", "none");
                $(dom).find(".PDM-contents-step1-details").addClass("PDM-hide-element-set-margin");
                $(".PDM-footer").removeClass("PDM-footer-increase-margin");
                isIncreaseFooterSize = false;
            }
        };

        function updatePlaceholder(tempGlobalCapacityDetails) {
            //set GLobal points summary including licensedPoints, used and remaining count
            //get all network details under Drivers which are using global capacity then calculate remaining Points in use
            var globalCapacityPointsInUse = 0;
            totalGlobalCapcityUsed = 0;
            var tmpGlobalRemainingPointsClass = "";
            Baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'findLicenseDetails',
                args: [{ nodeOrd: "station:|slot:/Drivers" }]
            }).then(function (list) {
                var networkList = JSON.parse(list);
                _.each(networkList, function (network) {
                    if (!$excludedFromGlobalCapacity(network.type)) {
                        globalCapacityPointsInUse = network.existing == -1 ? globalCapacityPointsInUse : parseInt(network.existing, 10) + globalCapacityPointsInUse;
                    }
                });
                $(".PDM-global-summary-container .points-in-use").html(globalCapacityPointsInUse);
                totalGlobalCapcityUsed = globalCapacityPointsInUse;
                var tmpTotalGlobalCapacityRemaining = parseInt(tempGlobalCapacityDetails.globalPointCapacityLimit, 10) - parseInt(globalCapacityPointsInUse, 10);
                $(dom).find(".PDM-global-summary-container .remaining-points").text(tmpTotalGlobalCapacityRemaining);
                if (tmpTotalGlobalCapacityRemaining >= 0)
                    tmpGlobalRemainingPointsClass = "positive";
                else
                    tmpGlobalRemainingPointsClass = "negative"
                $(dom).find(".PDM-global-summary-container .remaining-points").addClass(tmpGlobalRemainingPointsClass);
            });
        };

        function removeSpaceAndSpecialChars(networkName) {
            return networkName.trim().replace(/[^A-Z0-9]+/ig, "_");
        };

        function $addTextBoxEvent(textbox, network, isGlobalPointsTextbox) {
            $(textbox).bind("change keyup", function () {
                var val = $(this).val();

                if ((!isNaN(val) && parseInt(val, 10))
                    || val.toLowerCase() === "unlimited"
                    || val.trim() === ""
                    || parseInt(val, 10) === 0) {
                    $updatePointsCount($(textbox), network, isGlobalPointsTextbox);
                    if (parseInt(val, 10) <= 0) {
                        licenseStatusView.updateActionButtonsStatus(
                            $(dom).parent(),
                            {
                                disabledNext: true,
                            }
                        );
                    } else {
                        licenseStatusView.updateActionButtonsStatus(
                            $(dom).parent(),
                            {
                                disabledNext: false,
                            }
                        );
                    }
                } else {
                    var id = $(textbox).get(0).id.replace("txt", "");
                    $(dom).find("#" + id + " .remaining-points").removeClass("positive negative").addClass("");
                    $(dom).find("#" + id + " .remaining-points").text(lex.get('pdm.PointDatabaseManager.licenseStatusView.Unlimited'));

                    licenseStatusView.updateActionButtonsStatus(
                        $(dom).parent(),
                        {
                            disabledNext: true,
                        }
                    );
                }
            });
        }

        function $updatePointsCount(textbox, network, isGlobalPointsTextbox) {
            var id = $(textbox).get(0).id.replace("txt", ""),
                existing = isGlobalPointsTextbox ? totalGlobalCapcityUsed : network.existing,
                newVal = parseInt($(textbox).val(), 10),
                unlimited = isUnlimited(newVal),
                remaining,
                remainingPointsClass = "";

            //In license points text box, if user enters non-numeric value or it is empty,
            //then unlimited will be true. For calculation purpose we are making newVal as 0.
            // Other newVal will have special characters and it will lead to error or wrong calculation.
            if (unlimited) {
                newVal = 0;
            }
            //If user enters zero or negative value
            if (newVal < 0) {
                unlimited = true;
            }

            if (unlimited) {
                remaining = 0;
            }
            else {
                remaining = newVal - existing;
            }
            remainingPointsClass = getRemainingPointsClass(remaining, network, isGlobalPointsTextbox, newVal);
            remaining = remaining.toLocaleString();
            if (!isGlobalPointsTextbox) {
                $(dom).find("#" + id + " .remaining-points").removeClass("positive negative").addClass(remainingPointsClass);
                $(dom).find("#" + id + " .remaining-points").text(remaining);
            }
            else {
                $(dom).find(".PDM-global-summary-container .remaining-points").removeClass("positive negative").addClass(remainingPointsClass);
                $(dom).find(".PDM-global-summary-container .remaining-points").text(remaining);
            }
        };

        function getRemainingPointsClass(remaining, network, isGlobalPointsTextbox, newVal)
        {
            if (remaining >= 0) {
                if((isGlobalPointsTextbox && (parseInt(newVal,10) - parseInt(globalcapcitylimit)) <= 0) ||
                (!isGlobalPointsTextbox && (network.limit == -1 || (parseInt(newVal,10) - parseInt(network.limit)) <= 0)))
                    return "positive";
                else
                    return "negative"
            } else {
                return "negative";
            }
        }

        return licenseStatusView;
    });

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/unusedPointsViewTemplate',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div id=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"vid") || (depth0 != null ? lookupProperty(depth0,"vid") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"vid","hash":{},"data":data,"loc":{"start":{"line":1,"column":9},"end":{"line":1,"column":16}}}) : helper)))
    + "\">\n    <div class=\"PDM-step-details\">\n        <div class=\"PDM-contents-step-summary\">\n            <span class=\"PDM-step-count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepCount") || (depth0 != null ? lookupProperty(depth0,"stepCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepCount","hash":{},"data":data,"loc":{"start":{"line":4,"column":41},"end":{"line":4,"column":54}}}) : helper)))
    + "</span>\n            <span class=\"PDM-step-name\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"summaryMessage") || (depth0 != null ? lookupProperty(depth0,"summaryMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"summaryMessage","hash":{},"data":data,"loc":{"start":{"line":5,"column":40},"end":{"line":5,"column":58}}}) : helper)))
    + "</span>\n        </div>\n        <div class=\"PDM-step-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepDescription") || (depth0 != null ? lookupProperty(depth0,"stepDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepDescription","hash":{},"data":data,"loc":{"start":{"line":7,"column":42},"end":{"line":7,"column":61}}}) : helper)))
    + "</div>\n    </div>\n    <div class=\"PDM-contents-step-details\" style=\"height:100%\">\n        <div id=\"PDM-step2-unused-points-checkbox-container\" class=\"PDM-step2-unused-points-checkbox\"\n         style=\"height: calc(95% - (50px)); overflow-x:hidden; overflow-y:auto\">\n            <div class=\"deletePointsViewWidget PDM-step2-rectangle\">\n                <table class=\"ui-datatable\" style=\"width:99%\">\n                    <thead class=\"ui-datatable-thead\">\n                    <tr>\n                        <th>\n                        </th>\n                        <th>\n                        </th>\n                    </tr>\n                    </thead>\n                    <tbody class=\"ui-datatable-data ui-widget-content\">\n\n                    </tbody>\n                </table>\n            </div>\n        </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/unusedPointsViewTemplate', t);
return t;
});
/* END_TEMPLATE */
;
/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225 on 7/18/2019
 *
 */

define('nmodule/easyDatabaseManager/rc/js/unusedPointsView',['baja!',
        'jquery',
        'underscore',
        'Promise',
        'nmodule/easyDatabaseManager/rc/js/defaultView',
        'hbs!nmodule/easyDatabaseManager/rc/hbs/unusedPointsViewTemplate',
        'lex!easyDatabaseManager',
        'css!nmodule/easyDatabaseManager/rc/css/pointDataManager',
        'css!nmodule/easyDatabaseManager/rc/css/datatable'],
    function (baja,
              $,
              _,
              promise,
              defaultView,
              template,
              lexicons) {

        

        var dom,
            isUnusedSkiped = false,
            lex = lexicons[0], isIncreaseFooterSize = true;


        // unusedPointsView step
        // arguments: dom, vname, id, message, summaryMessage, backBttnMsg, nextBttnMsg, cancelBttnMsg
        var unusedPointsView = function () {
            defaultView.apply(this, arguments);

            //update which buttons will be available
            this.buttonstatus = {
                disabledBack: false,
                disabledNext: false,
                disabledSkip: false
            };
        };
        unusedPointsView.prototype = Object.create(defaultView.prototype,
            {'constructor': unusedPointsView}
        );

        //these variables will be updated in loadView with values passed from PointDatabaseManagerWidget
        unusedPointsView.component = null;
        unusedPointsView.service = null;
        unusedPointsView.subscriber = null;
        // call this function anytime you want to update nav action button status to enable/disable them
        unusedPointsView.updateActionButtonsStatus = null;

        /**
         * Load view of current wizard step - unusedPointsView
         * @param element: dom element the view will be appended to.
         * @param params: javascript object with widget parameters required to load the view within the widget
         */
        unusedPointsView.prototype.loadView = function (element, params) {
            var that = this;
            dom = element;
            unusedPointsView.component = params.component;
            unusedPointsView.service = params.service;
            unusedPointsView.subscriber = params.subscriber;
            unusedPointsView.updateActionButtonsStatus = params.updateActionButtonsStatus;
            isUnusedSkiped = false;
            isIncreaseFooterSize = params.pdmData.isIncreaseFooterSize;

            $(element).append(template({
                    vid: this.params.vid,
                    summaryMessage: this.params.summaryMessage,
                    stepCount: this.params.stepCount,
                    stepDescription: this.params.stepDescription

                }
            ));
            $(element).find(".PDM-contents-step-summary").css("border-top-color",params.colorCode);
            that.$getUnusedSearchCriteria();

            //remove margin increased set in the first screen since content size less from screen 2-4
            $(".PDM-footer").removeClass("PDM-footer-increase-margin");

            if(isUnusedSkiped) {
                unusedPointsView.prototype.updateActionButtonsStatus(
                    $(dom).parent(),
                    {
                        disabledBack: false,
                        disabledNext: false,
                        disabledSkip: true
                    }
                );
            }
        };

        unusedPointsView.prototype.showLoadedView = function () {
            if (isUnusedSkiped) {
                unusedPointsView.prototype.updateActionButtonsStatus(
                    $(dom).parent(),
                    {
                        disabledBack: false,
                        disabledNext: false,
                        disabledSkip: true
                    }
                );
            }
        };
            /**
         * validate user input before proceeding to next screen.
         * This is called before view.prototype.next is called.
         *
         * @returns {boolean}: return true/false based on validity of user input
         */
        unusedPointsView.prototype.validate = function () {
            baja.outln("inside: unusedPointsView.prototype.validate ...");
            return new promise(function (resolve) {
                //do any validations needed here.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * clean up and save before going to next view
         *
         */
        unusedPointsView.prototype.next = function () {
            var that = this;
            baja.outln("inside: unusedPointsView.prototype.next ...");

            var criteria = {};

            // If any checkbox is selected, set Enabled = true;
            // var item = {};
            criteria["enabled"] = "true";

            $.each($(that.dom).find(".ui-state-default"), function () {
                criteria[$(this).attr('id')] = $(this).hasClass("ui-state-active") ? "true" : "false";
            });

            return baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'saveUnusedSearchCriteria',
                args: [
                    {
                        enabled: criteria["enabled"],
                        includePxView: criteria["includePxView"],
                        includeTagBasedPxView: criteria["includeTagBasedPxView"],
                        includeLinkMark: criteria["includeLinkMark"],
                        includeAlarmExt: criteria["includeAlarmExt"],
                        includeHistoryExt: criteria["includeHistoryExt"],
                        includeHistoryImport: criteria["includeHistoryImport"],
                        includePointListView: criteria["includePointListView"],
                        includeAnalytics: criteria["includeAnalytics"],
                        includeLinkTrendLog: criteria["includeLinkTrendLog"] === undefined ? false : criteria["includeLinkTrendLog"],
                        includeEasyTemplate: criteria["includeEasyTemplate"]
                    }
                ]
            }).then(function () {
                return new promise(function (resolve) {
                    // do any backend communication needed here before moving to next screen.
                    //resolve once all the input is validated and good to move to next screen

                    that.data = {unusedPointsViewData: {isUnusedSkiped: false}};

                    resolve(true);
                });
            })
        };

        /**
         * clean up and save before going to previous view
         *
         */
        unusedPointsView.prototype.back = function () {
            baja.outln("inside: unusedPointsView.prototype.back ...");

            //set footer size more for screen 1
            if(isIncreaseFooterSize)
                $(".PDM-footer").addClass("PDM-footer-increase-margin");
            return new promise(function (resolve) {
                // do any cleanup/backend communication needed here before moving to previous screen.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * cancel operation - cancel button supported cancellable operation in current view
         *
         */
        unusedPointsView.prototype.cancel = function() {
            /*
             * if cancel button is available, the action should be implemented here.
            */
        };

        /**
         * clean up and save before skipping to next view
         *
         */
        unusedPointsView.prototype.skip = function () {
            var that = this;
            baja.outln("inside: unusedPointsView.prototype.skip ...");

            return baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'saveUnusedSearchCriteria',
                args: [
                    {
                        enabled: false,
                        includePxView: false,
                        includeTagBasedPxView: false,
                        includeLinkMark: false,
                        includeAlarmExt: false,
                        includeHistoryExt: false,
                        includeHistoryImport: false,
                        includePointListView: false,
                        includeLinkTrendLog: false,
                        includeEasyTemplate: false
                    }
                ]
            }).then(function () {
                return new promise(function (resolve) {
                    // do any backend communication needed here before moving to next screen.
                    //resolve once all the input is validated and good to move to next screen

                    that.data = {unusedPointsViewData: {isUnusedSkiped: true}};

                    resolve(true);
                });
            })
        };


        //these are prototype functions and needs to be overriden in extended screens.
        unusedPointsView.prototype.updateView = function () {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        // getList
        unusedPointsView.prototype.$getUnusedSearchCriteria = function () {
            var that = this;
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'getUnusedSearchCriteria'
            }).then(function (list) {
                that.$displayCriteria(list);
            })
        };

        var _addEventListeners = function (domobj) {
            //select or unselect individual rows
            $(domobj).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").on('click',
                function (event) {
                    var $target = $(event.target);
                    if ($target.hasClass("ui-chkbox-icon")) {
                        $target.parent().toggleClass("ui-state-active");
                        $target.toggleClass("pi pi-check");
                    } else {
                        $target.toggleClass("ui-state-active");
                        $target.find(".ui-chkbox-icon.ui-clickable").toggleClass("pi pi-check");
                    }
                });

        };

        // getList
        unusedPointsView.prototype.$displayCriteria = function (list) {
            var that = this,
                criteriaList = JSON.parse(list);

            var checkboxContainer = that.dom.find('#PDM-step2-unused-points-checkbox-container');
            var body = checkboxContainer.find('.ui-datatable-data');

            _.each(criteriaList, function (item) {

                if (item.PropertyName !== "enabled") {

                    // Column 1 Text
                    var row = $('<tr class="ui-widget-content"></tr>'),
                        tdText = $('<td></td>'),
                        span = $('<span class=ui-cell-data></span>'),
                        div = $('<div class="cell-data-wrap"></div>');

                    $(div).text(lex.get("pdm.PointDatabaseManager.UnusedPoints.criteria."+item.PropertyName));
                    span.append(div);
                    tdText.append(span);
                    row.append(tdText);

                    //Column 2 Value
                    var tdCheckBox = $('<td class="ui-selection-column ui-selection-column-criteria"></td>'),
                        spanCheckBox = $('<span class=ui-cell-data></span>'),
                        checkboxWidget = $('<div class="ui-chkbox ui-widget"></div>'),
                        inputDiv = $('<div class="ui-helper-hidden-accessible"></div>'),
                        inputCheckbox = $('<input type="checkbox"></input>'),
                        cellCSSCheckBox = $('<div class="ui-chkbox-box ui-widget ui-corner-all ui-state-default"></div>'),
                        cellCSSCheckSpan = $('<span class="ui-chkbox-icon ui-clickable"></span>');
                    if (item.PropertyValue === 'true') {
                        cellCSSCheckBox = $('<div class="ui-chkbox-box ui-widget ui-corner-all ui-state-default ui-state-active"></div>');
                        cellCSSCheckSpan = $('<span class="ui-chkbox-icon ui-clickable pi pi-check"></span>');
                    }

                    $(cellCSSCheckBox).attr('id', item.PropertyName);

                    inputDiv.append(inputCheckbox);
                    checkboxWidget.append(inputDiv);
                    cellCSSCheckBox.append(cellCSSCheckSpan);
                    checkboxWidget.append(cellCSSCheckBox);
                    spanCheckBox.append(checkboxWidget);
                    tdCheckBox.append(spanCheckBox);

                    row.append(tdCheckBox);
                    body.append(row);
                }
            });
            _addEventListeners(checkboxContainer);
        };

        return unusedPointsView;
    });

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/unwantedPointsViewTemplate',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div id=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"vid") || (depth0 != null ? lookupProperty(depth0,"vid") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"vid","hash":{},"data":data,"loc":{"start":{"line":1,"column":9},"end":{"line":1,"column":16}}}) : helper)))
    + "\">\n    <div class=\"PDM-step-details\">\n        <div class=\"PDM-contents-step-summary\">\n            <span class=\"PDM-step-count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepCount") || (depth0 != null ? lookupProperty(depth0,"stepCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepCount","hash":{},"data":data,"loc":{"start":{"line":4,"column":41},"end":{"line":4,"column":54}}}) : helper)))
    + "</span>\n            <span class=\"PDM-step-name\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"summaryMessage") || (depth0 != null ? lookupProperty(depth0,"summaryMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"summaryMessage","hash":{},"data":data,"loc":{"start":{"line":5,"column":40},"end":{"line":5,"column":58}}}) : helper)))
    + "</span>\n        </div>\n        <div class=\"PDM-step-description\"><span>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepDescription") || (depth0 != null ? lookupProperty(depth0,"stepDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepDescription","hash":{},"data":data,"loc":{"start":{"line":7,"column":48},"end":{"line":7,"column":67}}}) : helper)))
    + "</span>&nbsp;<span><u>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"note") || (depth0 != null ? lookupProperty(depth0,"note") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"note","hash":{},"data":data,"loc":{"start":{"line":7,"column":89},"end":{"line":7,"column":97}}}) : helper)))
    + "</u>&nbsp;"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"note1") || (depth0 != null ? lookupProperty(depth0,"note1") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"note1","hash":{},"data":data,"loc":{"start":{"line":7,"column":107},"end":{"line":7,"column":116}}}) : helper)))
    + "</span></div>\n    </div>\n    <div class=\"PDM-contents-step-details\">\n        <div class=\"load-criteria-button\">\n            <input type=\"button\" class=\"ux-btn PDM-nav-button load-criteria\" id=\"load-criteria\" value='"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"loadCriteraButtonText") || (depth0 != null ? lookupProperty(depth0,"loadCriteraButtonText") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"loadCriteraButtonText","hash":{},"data":data,"loc":{"start":{"line":11,"column":103},"end":{"line":11,"column":128}}}) : helper)))
    + "'  disabled='disabled'/>\n        </div>\n        <div class=\"PDM-step2-unused-points-checkbox\">\n            <div class=\"PDM-step3-table-container\">\n                <div class=\"PDM-step3-colum criteria-column\">\n                    <div class=\"step3-content\">\n                        <div id=\"PDM-step3-unwanted-points-checkbox-container\" class=\"deletePointsViewWidget PDM-step2-rectangle\">\n                            <table class=\"ui-datatable\">\n                                <thead class=\"ui-datatable-thead\">\n                                <tr>\n                                    <th>\n                                    </th>\n                                    <th>\n                                    </th>\n                                </tr>\n                                </thead>\n                                <tbody class=\"ui-datatable-data ui-widget-content\">\n                                <tr class=\"ui-widget-content tr-even\" id=\"ui-datatable-data-Include\">\n                                    <td>\n                                        <span class=\"ui-cell-data\">\n                                            <div class=\"cell-data-wrap\"><b>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"include") || (depth0 != null ? lookupProperty(depth0,"include") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"include","hash":{},"data":data,"loc":{"start":{"line":31,"column":75},"end":{"line":31,"column":86}}}) : helper)))
    + ":</b></div>\n                                        </span>\n                                    </td>\n                                    <td class=\"ui-selection-column ui-selection-column-criteria\"></td>\n                                </tr>\n                                </tbody>\n                            </table>\n                        </div>\n                    </div>\n                </div>\n                <div class=\"PDM-step3-colum\">\n                    <div class=\"step3-content\">\n                        <div class=\"deletePointsViewWidget PDM-step2-rectangle\">\n                            <table id=\"PDM-step3-Label-Search-Criteria\" class=\"ui-datatable\">\n                                <thead class=\"ui-datatable-thead\">\n                                <tr>\n                                    <th>\n                                    </th>\n                                    <th>\n                                    </th>\n                                </tr>\n                                </thead>\n                                <tbody class=\"ui-datatable-data ui-widget-content\">\n                                <tr class=\"ui-widget-content\">\n                                    <td>\n                                        <span class=\"ui-cell-data\">\n                                            <div class=\"cell-data-wrap\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"labelSearchCriteriaText") || (depth0 != null ? lookupProperty(depth0,"labelSearchCriteriaText") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"labelSearchCriteriaText","hash":{},"data":data,"loc":{"start":{"line":57,"column":72},"end":{"line":57,"column":99}}}) : helper)))
    + "</div>\n                                        </span>\n                                    </td>\n                                    <td class=\"ui-selection-column ui-selection-column-criteria\">\n                                        <span class=\"ui-cell-data\">\n                                        </span>\n                                    </td>\n                                </tr>\n                                <tr class=\"ui-widget-content\">\n                                    <td>\n                                        <div class=\"ui-cell-data\">\n                                            <div class=\"cell-data-wrap\">\n                                                <input type=\"text\" id=\"PDM-step3-default-label-search\" class=\"PDM-step3-label-search\" maxlength=\"256\" placeholder='"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"textboxLabelPlaceHolder") || (depth0 != null ? lookupProperty(depth0,"textboxLabelPlaceHolder") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"textboxLabelPlaceHolder","hash":{},"data":data,"loc":{"start":{"line":69,"column":163},"end":{"line":69,"column":190}}}) : helper)))
    + "' />\n                                            </div>\n                                        </div>\n                                    </td>\n                                    <td class=\"ui-selection-column ui-selection-column-criteria\">\n                                        <span class=\"ui-cell-data\">\n                                        </span>\n                                    </td>\n                                </tr>\n\n                                </tbody>\n                            </table>\n\n                        </div>\n                        <div class=\"addLabelSearchIcon new-search\">\n                                <span class=\"delete-icon-wrapper\">\n                                    <img class=\"\" src=\"/module/easyDatabaseManager/rc/images/Add-ico.png\">\n                                </span>\n                            <span class=\"new-search-label\">\n                                "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"newLabelSearchText") || (depth0 != null ? lookupProperty(depth0,"newLabelSearchText") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"newLabelSearchText","hash":{},"data":data,"loc":{"start":{"line":88,"column":32},"end":{"line":88,"column":54}}}) : helper)))
    + "\n                            </span>\n\n                        </div>\n                    </div>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/unwantedPointsViewTemplate', t);
return t;
});
/* END_TEMPLATE */
;
/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225 on 7/19/2019
 *
 */

define('nmodule/easyDatabaseManager/rc/js/unwantedPointsView',['baja!',
        'jquery',
        'underscore',
        'Promise',
        'dialogs',
        'nmodule/easyDatabaseManager/rc/js/defaultView',
        'hbs!nmodule/easyDatabaseManager/rc/hbs/unwantedPointsViewTemplate',
        'lex!easyDatabaseManager',
        'css!nmodule/easyDatabaseManager/rc/css/pointDataManager',
        'css!nmodule/easyDatabaseManager/rc/css/datatable'],
    function (baja,
              $,
              _,
              promise,
              dialogs,
              defaultView,
              template,
              lexicons) {

        

        //lexicons
        var lex = lexicons[0],
            labelSearchCount = 1,
            dom,
            domLoadedView,
            textboxLabelPlaceHolder=lex.get("pdm.PointDatabaseManager.stepThree.labelTextBox.placeholder"),
            isUnusedSkiped, savedCriteria, hasSavedCriteria=false;

        // unwantedPointsView step
        // arguments: dom, vname, id, message, summaryMessage, backBttnMsg, nextBttnMsg, cancelBttnMsg
        var unwantedPointsView = function () {
            defaultView.apply(this, arguments);

            //update which buttons will be available
            this.buttonstatus = {
                disabledBack: false,
                disabledNext: false,
                disabledSkip: false
            };
        };
        unwantedPointsView.prototype = Object.create(defaultView.prototype,
            {'constructor': unwantedPointsView}
        );

        //these variables will be updated in loadView with values passed from PointDatabaseManagerWidget
        unwantedPointsView.component = null;
        unwantedPointsView.service = null;
        unwantedPointsView.subscriber = null;
        // call this function anytime you want to update nav action button status to enable/disable them
        unwantedPointsView.updateActionButtonsStatus = null;

        /**
         * Load view of current wizard step - unwantedPointsView
         * @param element: dom element the view will be appended to.
         * @param params: javascript object with widget parameters required to load the view within the widget
         */
        unwantedPointsView.prototype.loadView = function (element, params) {
            var that = this;
            domLoadedView = element;
            unwantedPointsView.component = params.component;
            unwantedPointsView.service = params.service;
            unwantedPointsView.subscriber = params.subscriber;
            unwantedPointsView.updateActionButtonsStatus = params.updateActionButtonsStatus;
            isUnusedSkiped = params.pdmData.unusedPointsViewData.isUnusedSkiped;
            labelSearchCount = 1;

            if (isUnusedSkiped) {

                unwantedPointsView.updateActionButtonsStatus(
                    $(element).parent(),
                    {
                        disabledBack: false,
                        disabledNext: false,
                        disabledSkip: true
                    }
                );

            }
            $(element).append(template({
                    vid: this.params.vid,
                    summaryMessage: this.params.summaryMessage,
                    stepCount: this.params.stepCount,
                    stepDescription: this.params.stepDescription,
                    note:lex.get("pdm.PointDatabaseManager.stepThreeNote"),
                    note1:lex.get("pdm.PointDatabaseManager.stepThreeNote1"),
                    labelSearchCriteriaText: lex.get("pdm.PointDatabaseManager.unwantedPoints.labelSearchCriteria"),
                    newLabelSearchText: lex.get("pdm.PointDatabaseManager.newSearchLabel"),
                    loadCriteraButtonText: lex.get("pdm.PointDatabaseManager.stepThree.loadCriteriaButtonText"),
                    include: lex.get("pdm.PointDatabaseManager.UnwantedPoints.criteria.Include"),
                    textboxLabelPlaceHolder: textboxLabelPlaceHolder
            }
            ));


            $(element).find(".PDM-contents-step-summary").css("border-top-color",params.colorCode);
            $(element).find(".addLabelSearchIcon").unbind('click').click(function () {

                if (labelSearchCount >= 10) {

                    var dialog = dialogs.make({
                        title: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.title"),
                        content: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.default.label.limit"),
                        ok: function (dlg) {
                            var $dialog = dlg.jq();
                            $dialog.find("div.js-dialog.ux-root").removeClass("confirm-js-dialog");
                            dlg.close();
                        }
                    });
                    dialog.show();
                    return;
                }
                var checkboxContainer = $(element).find('#PDM-step3-Label-Search-Criteria');
                var tBody = checkboxContainer.find('.ui-datatable-data');
                var row =getDynamicTextBox('');

                tBody.append(row);
                labelSearchCount = labelSearchCount + 1;
            });
            that.$getUnwantedSearchCriteria();
            getSavedCriteria(element);

            $(element).find(".load-criteria").unbind('click').click(function () {
                loadCriteria(savedCriteria, element);
            });

        };

        unwantedPointsView.prototype.showLoadedView = function () {
            getSavedCriteria(domLoadedView);
            if (isUnusedSkiped) {
                unwantedPointsView.updateActionButtonsStatus(
                    $(domLoadedView).parent(),
                    {
                        disabledBack: false,
                        disabledNext: false,
                        disabledSkip: true
                    }
                );
            }
        };

        /**
         * validate user input before proceeding to next screen.
         * This is called before view.prototype.next is called.
         *
         * @returns {boolean}: return true/false based on validity of user input
         */
        unwantedPointsView.prototype.validate = function () {
            baja.outln("inside: unwantedPointsView.prototype.validate ...");
            return new promise(function (resolve) {
                //do any validations needed here.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * clean up and save before going to next view
         *
         */
        unwantedPointsView.prototype.next = function () {
            var that = this,
                dialog,
                checkboxContainer = that.dom.find('#PDM-step3-unwanted-points-checkbox-container');
            baja.outln("inside: unwantedPointsView.prototype.next ...");
            var isMinimumSelected = false;
            $.each($(checkboxContainer).find(".ui-state-default:lt(3)"), function () {
                if ($(this).hasClass("ui-state-active")) {
                    isMinimumSelected = true;
                }
            });

            var defaultLabelSearch = that.dom.find("#PDM-step3-default-label-search");
            return new Promise(function (resolve) {

                if (!isMinimumSelected) {

                    // Any of the first 3 should be selected
                    dialog = dialogs.make({
                        title: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.title"),
                        content: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.message",
                            lex.get("pdm.PointDatabaseManager.UnwantedPoints.criteria.points"),
                            lex.get("pdm.PointDatabaseManager.UnwantedPoints.criteria.schedules"),
                            lex.get("pdm.PointDatabaseManager.UnwantedPoints.criteria.histories")),
                        ok: function (dlg) {
                            var $dialog = dlg.jq();
                            $dialog.find("div.js-dialog.ux-root").removeClass("confirm-js-dialog");
                            dlg.close();
                        }
                    });
                    dialog.show();
                    resolve(false);
                } else if ($(defaultLabelSearch).val() === "" && $(defaultLabelSearch).hasClass("PDM-step3-label-search")) {
                        // At least one Label should be selected
                        dialog = dialogs.make({
                            title: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.title"),
                            content: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.default.label.search.empty") + ".",
                            ok: function (dlg) {
                                var $dialog = dlg.jq();
                                $dialog.find("div.js-dialog.ux-root").removeClass("confirm-js-dialog");
                                dlg.close();
                            }
                        });
                        dialog.show();
                        resolve(false);
                } else {
                    // All the textboxes should have some value
                    var isTextboxesEmpty = false;
                    // % or $ should not be in textboxes
                    var isSpecialChar = false;
                    var labels = [];
                    var labelSearchCriteria = that.dom.find("#PDM-step3-Label-Search-Criteria");
                    $.each($(labelSearchCriteria).find(":input"), function () {
                        var temp = $(this).val();
                        if (temp === "" && $(this).hasClass("PDM-step3-label-search")) {
                            isTextboxesEmpty = true;
                            return;
                        }
                        else if (
                            !(temp.indexOf("$") === -1
                                && temp.indexOf("%") === -1
                                && temp.indexOf("'") === -1
                                && $(this).hasClass("PDM-step3-label-search"))) {
                            isSpecialChar = true;
                            return;
                        } else {
                            labels.push($(this).val());
                        }
                    });

                    if (isTextboxesEmpty) {
                        dialog = dialogs.make({
                            title: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.title"),
                            content: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.default.label.empty"),
                            ok: function (dlg) {
                                var $dialog = dlg.jq();
                                $dialog.find("div.js-dialog.ux-root").removeClass("confirm-js-dialog");
                                dlg.close();
                            }
                        });
                        dialog.show();
                        resolve(false);
                    } else if (isSpecialChar) {
                        dialog = dialogs.make({
                            title: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.title"),
                            content: lex.get("pdm.PointDatabaseManager.unwantedPoints.error.default.label.specialChar"),
                            ok: function (dlg) {
                                var $dialog = dlg.jq();
                                $dialog.find("div.js-dialog.ux-root").removeClass("confirm-js-dialog");
                                dlg.close();
                            }
                        });
                        dialog.show();
                        resolve(false);
                    }
                    else {
                        // If any checkbox is selected, set Enabled = true;
                        var criteria = {};
                        criteria["enabled"] = "true";
                        $.each($(checkboxContainer).find(".ui-state-default"), function () {
                            var cri = ($(this).attr('id')).replace("chk", "");
                            criteria[cri] = $(this).hasClass("ui-state-active") ? "true" : "false";
                        });

                        dialog = dialogs.make({
                            title: lex.get("pdm.PointDatabaseManager.unwantedPointsViewMsg"),
                            content: lex.get("pdm.PointDatabaseManager.unwantedPoints.save.criteria.save"),
                            yes: function (dlg) {
                                var $dialog = dlg.jq();
                                $dialog.find("div.js-dialog.ux-root").removeClass("confirm-js-dialog");
                                dlg.close();
                                baja.rpc({
                                    typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                                    method: 'saveUnwantedSearchCriteria',
                                    args: [{
                                        enabled: criteria["enabled"],
                                        points:  criteria["points"],
                                        schedules:  criteria["schedules"],
                                        histories:  criteria["histories"],
                                        includeLinkMark:  criteria["includeLinkMark"],
                                        includeAnalytics: criteria["includeAnalytics"],
                                        includePxView:  criteria["includePxView"],
                                        includeTagBasedPxView:  criteria["includeTagBasedPxView"],
                                        includeHistoryImportAnalytics:  criteria["includeHistoryImportAnalytics"],
                                        deleteLinkedHistories: criteria["deleteLinkedHistories"] === undefined ? false : criteria["deleteLinkedHistories"],

                                        saveRequired: true,
                                        labels: labels
                                    }]
                                }).then(function () {
                                    that.data = {
                                        unwantedPointsViewData: {
                                            isUnwantedSkiped: false,
                                            labelSearchCriteriaList: labels
                                        }
                                    };
                                    resolve(true);
                                });
                            },
                            no: function (dlg) {
                                var $dialog = dlg.jq();
                                $dialog.find("div.js-dialog.ux-root").removeClass("confirm-js-dialog");
                                dlg.close();
                                baja.rpc({
                                    typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                                    method: 'saveUnwantedSearchCriteria',
                                    args: [{
                                        enabled: criteria["enabled"],
                                        points:  criteria["points"],
                                        schedules:  criteria["schedules"],
                                        histories:  criteria["histories"],
                                        includeLinkMark:  criteria["includeLinkMark"],
                                        includeAnalytics: criteria["includeAnalytics"],
                                        includePxView:  criteria["includePxView"],
                                        includeTagBasedPxView:  criteria["includeTagBasedPxView"],
                                        includeHistoryImportAnalytics:  criteria["includeHistoryImportAnalytics"],
                                        deleteLinkedHistories: criteria["deleteLinkedHistories"] === undefined ? false : criteria["deleteLinkedHistories"],
                                        saveRequired: false,
                                        labels: labels
                                    }]
                                }).then(function () {
                                    that.data = {
                                        unwantedPointsViewData: {
                                            isUnwantedSkiped: false,
                                            labelSearchCriteriaList: labels
                                        }
                                    };
                                    resolve(true);
                                });
                            }
                        });
                        dialog.show();
                    }
                }
            });
        };

        /**
         * clean up and save before skipping to next view
         *
         */
        unwantedPointsView.prototype.skip = function () {
            var that = this;
            baja.outln("inside: unwantedPointsView.prototype.skip ...");

            if (isUnusedSkiped) {

                unwantedPointsView.updateActionButtonsStatus(
                    $(that.dom).parent(),
                    {
                        disabledBack: false,
                        disabledNext: false,
                        disabledSkip: true
                    }
                );

                return new promise(function (resolve) {
                    //do any validations needed here.
                    //resolve once all the input is validated and good to move to next screen
                    resolve(false);
                });
            }

            var criteria = [];

            // If any checkbox is selected, set Enabled = true;
            var item = {};
            item["PropertyName"] = "enabled";
            item["PropertyValue"] = "false";
            item["labels"]=[];
            criteria.push(item);
            var checkboxContainer = that.dom.find('#PDM-step3-unwanted-points-checkbox-container');
            $.each($(checkboxContainer).find(".ui-state-default"), function () {
                item = {};
                item["PropertyName"] = $(this).attr('id');
                item["PropertyValue"] = "false";
                criteria.push(item);
            });

            return baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'saveUnwantedSearchCriteria',
                args: [{
                    enabled: false,
                    points: false,
                    schedules: false,
                    histories: false,
                    includeLinkMark: false,
                    includePxView: false,
                    includeTagBasedPxView: false,
                    deleteLinkedHistories: false,
                    saveRequired: false,
                    labels: []
                }]
            }).then(function () {
                return new promise(function (resolve) {
                    // do any backend communication needed here before moving to next screen.
                    //resolve once all the input is validated and good to move to next screen

                    that.data = {
                        unwantedPointsViewData: {
                            isUnwantedSkiped: true,
                            labelSearchCriteriaList: []
                        }
                    };

                    resolve(true);
                });
            })
        };
        /**
         * clean up and save before going to previous view
         *
         */
        unwantedPointsView.prototype.back = function () {
            var that = this;
            baja.outln("inside: unwantedPointsView.prototype.back ...");
            return new promise(function (resolve) {
                // do any cleanup/backend communication needed here before moving to previous screen.
                //resolve once all the input is validated and good to move to next screen

                // On Back we must reset skip from Unused Points
                that.data = {unusedPointsViewData: {isUnusedSkiped: false}};

                resolve(true);
            });
        };

        /**
         * cancel operation - cancel button supported cancellable operation in current view
         * This is invoked only if this.params.isCancelAvailable is set to true.
         */
        unwantedPointsView.prototype.cancel = function () {
            /*
             * if cancel button is available, the action should be implemented here.
            */
        };

        //these are prototype functions and needs to be overriden in extended screens.
        unwantedPointsView.prototype.updateView = function () {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        // getList
        unwantedPointsView.prototype.$getUnwantedSearchCriteria = function () {
            var that = this;
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'getUnwantedSearchCriteria'
            }).then(function (list) {
                that.$displayCriteria(list);
            })
        };


        var _addEventListeners = function (domObj) {
            //select or unselect individual rows
            $(domObj).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").on('click',
                function (event) {
                    var $target = $(event.target);
                    if ($target.hasClass("ui-chkbox-icon")) {
                            $target.parent().toggleClass("ui-state-active");
                            $target.toggleClass("pi pi-check");
                            if ($target.parent().hasClass("points")) {
                                domLoadedView.find("#deleteLinkedHistories .cell-data-wrap").css("color", "#808080d9");
                                domLoadedView.find("#deleteLinkedHistories .ui-state-default").removeClass("ui-state-active");
                                domLoadedView.find("#deleteLinkedHistories .ui-chkbox-icon.ui-clickable").removeClass("pi pi-check");
                                domLoadedView.find("#deleteLinkedHistories .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.deleteLinkedHistories").css("border-color","#d0d0d0");
                            }
                    } else {
                        if($target.hasClass("deleteLinkedHistories")){
                            if(domLoadedView.find("#points .ui-state-active").length > 0)
                            {
                                $target.toggleClass("ui-state-active");
                                $target.find(".ui-chkbox-icon.ui-clickable").toggleClass("pi pi-check");
                            }
                        }else {
                            $target.toggleClass("ui-state-active");
                            $target.find(".ui-chkbox-icon.ui-clickable").toggleClass("pi pi-check");
                            if ($target.hasClass("points")) {
                                domLoadedView.find("#deleteLinkedHistories .cell-data-wrap").css("color", "black");
                                domLoadedView.find("#deleteLinkedHistories .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.deleteLinkedHistories").css("border-color","black");
                            }
                        }
                    }

                });
            // select or unselect all rows
        };


        // showList
        unwantedPointsView.prototype.$displayCriteria = function (list) {
            var that = this,
                criteriaList = JSON.parse(list);

            var checkboxContainer = that.dom.find('#PDM-step3-unwanted-points-checkbox-container');
            var body = checkboxContainer.find('.ui-datatable-data');
            var flg = false;

            _.each(criteriaList, function (item) {

                if (item.PropertyName !== "enabled") {

                    // Column 2 Text
                    var row = $('<tr class="ui-widget-content tr-even" id="' + item.PropertyName.replace(/\s/g, '') + '"></tr>'),
                        tdText = $('<td></td>'),
                        span,
                        div = $('<div class="cell-data-wrap"></div>');

                    //make flex container for the sub option
                    if(item.PropertyName == "deleteLinkedHistories" || item.PropertyName == "includeHistoryImportAnalytics")
                    {
                        span = $('<div class=ui-cell-data></div>')
                    }
                    else
                    {
                        span = $('<span class=ui-cell-data></span>')
                    }
                    if(item.PropertyName==="deleteLinkedHistories") {
                        row.addClass("hide-linked-histories");
                    }
                    $(div).text(lex.get("pdm.PointDatabaseManager.UnwantedPoints.criteria."+item.PropertyName));



                    //Column 1 Value
                    var tdCheckBox,
                        emptycell = $('<td></td>'),
                        spanCheckBox = $('<span class=ui-cell-data></span>'),
                        checkboxWidget = $('<div class="ui-chkbox ui-widget"></div>'),
                        inputDiv = $('<div class="ui-helper-hidden-accessible"></div>'),
                        inputCheckbox = $('<input type="checkbox"></input>'),
                        cellCSSCheckBox = $('<div class="ui-chkbox-box ui-widget ui-corner-all ui-state-default"></div>'),
                        cellCSSCheckSpan = $('<span class="ui-chkbox-icon ui-clickable"></span>');


                    if (item.PropertyValue === 'true') {
                        cellCSSCheckBox.addClass("ui-state-active");
                        cellCSSCheckSpan.addClass("pi pi-check");

                        if(item.PropertyName==="points") {
                            flg = true;
                        }
                    }
                    if(item.PropertyName==="points")
                    {
                        cellCSSCheckBox.addClass("points");
                    }
                    if(item.PropertyName==="deleteLinkedHistories")
                    {
                        cellCSSCheckBox.addClass("deleteLinkedHistories");
                    }

                    $(cellCSSCheckBox).attr('id', "chk"+ item.PropertyName);

                    inputDiv.append(inputCheckbox);
                    checkboxWidget.append(inputDiv);
                    cellCSSCheckBox.append(cellCSSCheckSpan);
                    checkboxWidget.append(cellCSSCheckBox);
                    spanCheckBox.append(checkboxWidget);

                    if(item.PropertyName == "deleteLinkedHistories" || item.PropertyName == "includeHistoryImportAnalytics")
                    {
                        tdCheckBox = $('<div class="ui-selection-column ui-selection-column-criteria ui-selection-column-aligncenter ui-selection-column-step3"></div>');
                        tdCheckBox.append(spanCheckBox);
                        row.append(emptycell);
                        span.append(tdCheckBox);

                    }
                    else
                    {
                        tdCheckBox = $('<td class="ui-selection-column ui-selection-column-criteria ui-selection-column-aligncenter ui-selection-column-step3"></td>');
                        tdCheckBox.append(spanCheckBox);
                        row.append(tdCheckBox);
                    }


                    span.append(div);
                    tdText.append(span);

                    row.append(tdText);
                    body.append(row);
                }
            });
            _addEventListeners(checkboxContainer);
            if(flg) {
                domLoadedView.find("#deleteLinkedHistories .cell-data-wrap").css("color","black");
                domLoadedView.find("#deleteLinkedHistories .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.deleteLinkedHistories").css("border-color","black");
            }


        };
        function getSavedCriteria(element) {
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'loadUnwantedSearchCriteria'

            }).then(function (output) {
               if (output !== "{}" )
                {
                    savedCriteria = output;
                    hasSavedCriteria=true;
                }
                else
                {
                    hasSavedCriteria=false;
                }
                if(hasSavedCriteria){
                    $(element).find("#load-criteria").prop('disabled', false);
                }
                else
                {
                    $(element).find("#load-criteria").prop('disabled', true);
                }
            });

        };

        function loadCriteria(data, element) {
            labelSearchCount = 1;
            var jsonObj=JSON.parse(data);
            var savedLabels=jsonObj.unwantedPointSearchCriteria.labelEntities;
            $(element).find(".dynamic-text-box").remove();
            var firstLabel=savedLabels[0].name;
            var isFirstLabel=true;
            var defaultTextBox = $(element).find('#PDM-step3-default-label-search').replaceWith('<input type="text" id="PDM-step3-default-label-search" class="PDM-step3-label-search" maxlength="256" value="'+firstLabel+'" />');
            var textboxContainer = $(element).find('#PDM-step3-Label-Search-Criteria');
            var tBody = textboxContainer.find('.ui-datatable-data');
            _.each(savedLabels, function (label) {
                if(isFirstLabel)
                {
                    isFirstLabel=false;
                    return;
                }
                var row = getDynamicTextBox(label.name);
                tBody.append(row);
                labelSearchCount = labelSearchCount + 1;
            });


            var savedCriteriaJson=jsonObj.unwantedPointSearchCriteria.searchOptionsEntity;
            var checkboxContainer = $(element).find('#PDM-step3-unwanted-points-checkbox-container');

            for (var key in savedCriteriaJson) {
                if (savedCriteriaJson.hasOwnProperty(key)) {
                    var checkbox = $(checkboxContainer).find("#chk"+key);
                    if("Y" === savedCriteriaJson[key])
                    {
                        $(checkbox).addClass("ui-state-active")
                        $(checkbox).children("span").addClass("pi pi-check");

                        // If it is points
                        if(key === "points") {
                            domLoadedView.find("#deleteLinkedHistories .cell-data-wrap").css("color","black");
                            domLoadedView.find("#deleteLinkedHistories .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.deleteLinkedHistories").css("border-color","black");
                        }
                    }
                    else {
                        if(key === "points") {
                            domLoadedView.find("#deleteLinkedHistories .cell-data-wrap").css("color","#808080d9");
                            domLoadedView.find("#deleteLinkedHistories .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.deleteLinkedHistories").css("border-color","#d0d0d0");
                        }
                        $(checkbox).removeClass("ui-state-active")
                        $(checkbox).children("span").removeClass("pi pi-check");
                    }
                }
            }
        };
        // get dynamic text box
        function getDynamicTextBox(label) {

            // Column 1 Text
            var row = $('<tr class="ui-widget-content dynamic-text-box" ></tr>'),
                tdText = $('<td></td>'),
                span = $('<span class=ui-cell-data></span>'),
                div = $('<div class="cell-data-wrap"><input type="text" class="PDM-step3-label-search" maxlength="256" value="'+label+'" placeholder="'+textboxLabelPlaceHolder+'"></input></div>');

            span.append(div);
            tdText.append(span);
            row.append(tdText);

            //Column 2 Value
            var tdTextBox = $('<td class="ui-selection-column ui-selection-column-criteria"></td>'),
                spanTextBox = $('<span class=ui-cell-data></span>'),
                textBoxWidget = $('<div class="ui-chkbox ui-widget"></div>'),
                cellCSSTextBox = $('<div class="ui-chkbox-box ui-widget ui-corner-all ui-state-default"></div>'),
                cellWrapper = $('<div class="delete-icon-wrapper"></div>'),
                cellCSSTextSpan = $('<image class="deleteLabelSearchIcon" src="/module/easyDatabaseManager/rc/images/delete.jpg"></image>');

            cellCSSTextSpan.unbind('click').click(function () {
                $(this).closest('tr').remove();
                labelSearchCount = labelSearchCount - 1;
            });

            cellWrapper.append(cellCSSTextSpan);
            cellCSSTextBox.append(cellWrapper);
            textBoxWidget.append(cellCSSTextBox);
            spanTextBox.append(textBoxWidget);
            tdTextBox.append(spanTextBox);
            row.append(tdTextBox);
            return row;

        };

        return unwantedPointsView;
    });

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/datatable',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var stack1, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<table class=\"ui-datatable\" style=\"border-collapse: collapse;\n                                   border-spacing: 0;\n                                   text-align: left;\n                                   display: flex;\n                                   flex-flow: column;\n                                   height: 100%;\n                                   width: 100%;\">\n<thead class=\"ui-datatable-thead\" style=\"flex: 0 0 auto; width: 100%;\">\n<tr class=\"ui-state-default\" style=\"display: table; table-layout: fixed; width: 100%;\">\n    <th style=\"width:40px; min-width:40px\" class=\"ui-state-default ui-selection-column\">\n        <span class=\"ui-column-title\">\n            <div class=\"ui-chkbox ui-widget\" ><div class=\"ui-helper-hidden-accessible\"><input type=\"checkbox\"></div>\n                <div class=\"ui-chkbox-box ui-widget ui-corner-all ui-state-default checkbox-header\"><span class=\"ui-chkbox-icon ui-clickable\"></span></div>\n            </div>\n        </span>\n    <th style=\"width:150px; min-width:150px;\" class= \"secured-selection-column\">\n        <input type=\"button\" class=\"clear-selected-secure-point button-inactive\" value=\"Clear Selection\" disabled/></th>\n    </th>\n\n"
    + ((stack1 = lookupProperty(helpers,"each").call(depth0 != null ? depth0 : (container.nullContext || {}),(depth0 != null ? lookupProperty(depth0,"columns") : depth0),{"name":"each","hash":{},"fn":container.program(1, data, 0),"inverse":container.noop,"data":data,"loc":{"start":{"line":20,"column":4},"end":{"line":23,"column":13}}})) != null ? stack1 : "")
    + "    <th style=\"width:50%\"></th>\n</tr>\n</thead>\n<tbody class=\"ui-datatable-data ui-widget-content\" style=\"max-height: 150px;\n                                                              width: 100%;\n                                                              flex: 1 1 auto;\n                                                              overflow-y: scroll;\">\n"
    + ((stack1 = lookupProperty(helpers,"each").call(depth0 != null ? depth0 : (container.nullContext || {}),(depth0 != null ? lookupProperty(depth0,"rows") : depth0),{"name":"each","hash":{},"fn":container.program(3, data, 0),"inverse":container.noop,"data":data,"loc":{"start":{"line":31,"column":0},"end":{"line":42,"column":9}}})) != null ? stack1 : "")
    + "</tbody>\n</table>\n<div class=\"datatable-tooltip\">\n    <div class=\"datatable-tooltip-content\"></div>\n</div>\n\n";
},"1":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "        <th class=\"ui-state-default ui-unselectable-text ui-sortable-column\" style=\"width:300px\">\n        <span class=\"ui-column-title\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"name") || (depth0 != null ? lookupProperty(depth0,"name") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"name","hash":{},"data":data,"loc":{"start":{"line":22,"column":38},"end":{"line":22,"column":46}}}) : helper)))
    + "</span><span class=\"ui-sortable-column-icon pi pi-fw pi-sort\" data-name=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"field") || (depth0 != null ? lookupProperty(depth0,"field") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"field","hash":{},"data":data,"loc":{"start":{"line":22,"column":119},"end":{"line":22,"column":128}}}) : helper)))
    + "\"></span></th>\n";
},"3":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "    <tr class=\"ui-widget-content\" style=\"width: 100%;display: table; table-layout: fixed;\">\n        <td style=\"width:40px; min-width:40px\" class=\"ui-selection-column\"><span class=\"ui-cell-data\"><div class=\"ui-chkbox ui-widget\">\n                <div class=\"ui-helper-hidden-accessible\"><input type=\"checkbox\"></div>\n                <div class=\"ui-chkbox-box ui-widget ui-corner-all ui-state-default\" data-handle=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"handle") || (depth0 != null ? lookupProperty(depth0,"handle") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"handle","hash":{},"data":data,"loc":{"start":{"line":35,"column":97},"end":{"line":35,"column":107}}}) : helper)))
    + "\"><span class=\"ui-chkbox-icon ui-clickable\"></span></div>\n            </div></span></td>\n        <td style=\"width:150px; min-width:150px\" class = \"secured-selection-column\"><span class=\"ui-cell-data\"><div class = \"center-secured-selection-column\">\n        <input type = \"radio\" name = \"radioSecuredPoints\" id = "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"path") || (depth0 != null ? lookupProperty(depth0,"path") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"path","hash":{},"data":data,"loc":{"start":{"line":38,"column":63},"end":{"line":38,"column":71}}}) : helper)))
    + "></div></span></td>\n        <td><span class=\"ui-cell-data\"><div style=\"width:300px\" class=\"cell-data-wrap\" data-tooltip=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"name") || (depth0 != null ? lookupProperty(depth0,"name") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"name","hash":{},"data":data,"loc":{"start":{"line":39,"column":101},"end":{"line":39,"column":109}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"name") || (depth0 != null ? lookupProperty(depth0,"name") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"name","hash":{},"data":data,"loc":{"start":{"line":39,"column":111},"end":{"line":39,"column":119}}}) : helper)))
    + "</div></span></td>\n        <td class=\"\"><span class=\"ui-cell-data\"><div class=\"cell-data-wrap\" data-tooltip=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"path") || (depth0 != null ? lookupProperty(depth0,"path") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"path","hash":{},"data":data,"loc":{"start":{"line":40,"column":90},"end":{"line":40,"column":98}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"path") || (depth0 != null ? lookupProperty(depth0,"path") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"path","hash":{},"data":data,"loc":{"start":{"line":40,"column":100},"end":{"line":40,"column":108}}}) : helper)))
    + "</div></span></td>\n    </tr>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/datatable', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/datarows',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var stack1, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return ((stack1 = lookupProperty(helpers,"each").call(depth0 != null ? depth0 : (container.nullContext || {}),(depth0 != null ? lookupProperty(depth0,"rows") : depth0),{"name":"each","hash":{},"fn":container.program(1, data, 0),"inverse":container.noop,"data":data,"loc":{"start":{"line":1,"column":0},"end":{"line":12,"column":9}}})) != null ? stack1 : "");
},"1":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "    <tr class=\"ui-widget-content\">\n        <td class=\"ui-selection-column\"><span class=\"ui-cell-data\"><div class=\"ui-chkbox ui-widget\">\n                <div class=\"ui-helper-hidden-accessible\"><input type=\"checkbox\"></div>\n                <div class=\"ui-chkbox-box ui-widget ui-corner-all ui-state-default\" data-handle=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"handle") || (depth0 != null ? lookupProperty(depth0,"handle") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"handle","hash":{},"data":data,"loc":{"start":{"line":5,"column":97},"end":{"line":5,"column":107}}}) : helper)))
    + "\"><span class=\"ui-chkbox-icon ui-clickable\"></span></div>\n            </div></span></td>\n        <td style=\"width:150px; min-width:150px\" class = \"secured-selection-column\"><span class=\"ui-cell-data\"><div class = \"center-secured-selection-column\">\n        <input type = \"radio\" name = \"radioSecuredPoints\" id = "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"path") || (depth0 != null ? lookupProperty(depth0,"path") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"path","hash":{},"data":data,"loc":{"start":{"line":8,"column":63},"end":{"line":8,"column":71}}}) : helper)))
    + "></div></span></td>\n        <td ><span class=\"ui-cell-data\"><div style=\"width:300px\" class=\"cell-data-wrap\" >"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"name") || (depth0 != null ? lookupProperty(depth0,"name") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"name","hash":{},"data":data,"loc":{"start":{"line":9,"column":89},"end":{"line":9,"column":97}}}) : helper)))
    + "</div></span></td>\n        <td class=\"\"><span class=\"ui-cell-data\"><div class=\"cell-data-wrap\" data-tooltip=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"path") || (depth0 != null ? lookupProperty(depth0,"path") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"path","hash":{},"data":data,"loc":{"start":{"line":10,"column":90},"end":{"line":10,"column":98}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"path") || (depth0 != null ? lookupProperty(depth0,"path") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"path","hash":{},"data":data,"loc":{"start":{"line":10,"column":100},"end":{"line":10,"column":108}}}) : helper)))
    + "</div></span></td>\n    </tr>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/datarows', t);
return t;
});
/* END_TEMPLATE */
;
/*
 * pagination.js 2.1.4
 * A jQuery plugin to provide simple yet fully customisable pagination.
 * https://github.com/superRaytin/paginationjs
 *
 * Homepage: http://pagination.js.org
 *
 * Copyright 2014-2100, superRaytin
 * Released under the MIT license.
 */

(function(global, $) {

  if (typeof $ === 'undefined') {
    throwError('Pagination requires jQuery.');
  }

  var pluginName = 'pagination';

  var pluginHookMethod = 'addHook';

  var eventPrefix = '__pagination-';

  // Conflict, use backup
  if ($.fn.pagination) {
    pluginName = 'pagination2';
  }

  $.fn[pluginName] = function(options) {

    if (typeof options === 'undefined') {
      return this;
    }

    var container = $(this);

    var attributes = $.extend({}, $.fn[pluginName].defaults, options);

    var pagination = {

      initialize: function() {
        var self = this;

        // Cache attributes of current instance
        if (!container.data('pagination')) {
          container.data('pagination', {});
        }

        if (self.callHook('beforeInit') === false) return;

        // Pagination has been initialized, destroy it
        if (container.data('pagination').initialized) {
          $('.paginationjs', container).remove();
        }

        // Whether to disable Pagination at the initialization
        self.disabled = !!attributes.disabled;

        // Model will be passed to the callback function
        var model = self.model = {
          pageRange: attributes.pageRange,
          pageSize: attributes.pageSize
        };

        // dataSource`s type is unknown, parse it to find true data
        self.parseDataSource(attributes.dataSource, function(dataSource) {

          // Currently in asynchronous mode
          self.isAsync = Helpers.isString(dataSource);
          if (Helpers.isArray(dataSource)) {
            model.totalNumber = attributes.totalNumber = dataSource.length;
          }

          // Currently in asynchronous mode and a totalNumberLocator is specified
          self.isDynamicTotalNumber = self.isAsync && attributes.totalNumberLocator;

          // There is only one page
          if (attributes.hideWhenLessThanOnePage) {
            if (self.getTotalPage() <= 1) return;
          }

          var el = self.render(true);

          // Add extra className to the pagination element
            if (attributes.className) {
            el.addClass(attributes.className);
          }

          model.el = el;

          // Append/prepend pagination element to the container
          container[attributes.position === 'bottom' ? 'append' : 'prepend'](el);

          // Bind events
          self.observer();

          // Pagination is currently initialized
          container.data('pagination').initialized = true;

          // Will be invoked after initialized
          self.callHook('afterInit', el);
        });
      },

      render: function(isBoot) {
        var self = this;
        var model = self.model;
        var el = model.el || $('<div class="paginationjs"></div>');
        var isForced = isBoot !== true;

        self.callHook('beforeRender', isForced);

        var currentPage = model.pageNumber || attributes.pageNumber;
        var pageRange = attributes.pageRange;
        var totalPage = self.getTotalPage();

        var rangeStart = currentPage - pageRange;
        var rangeEnd = currentPage + pageRange;

        if (rangeEnd > totalPage) {
          rangeEnd = totalPage;
          rangeStart = totalPage - pageRange * 2;
          rangeStart = rangeStart < 1 ? 1 : rangeStart;
        }

        if (rangeStart <= 1) {
          rangeStart = 1;
          rangeEnd = Math.min(pageRange * 2 + 1, totalPage);
        }

        el.html(self.generateHTML({
          currentPage: currentPage,
          pageRange: pageRange,
          rangeStart: rangeStart,
          rangeEnd: rangeEnd
        }));

        self.callHook('afterRender', isForced);

        return el;
      },

      // Generate HTML content from the template
        generateHTML: function(args) {
        var self = this;
        var currentPage = args.currentPage;
        var totalPage = self.getTotalPage();
        var rangeStart = args.rangeStart;
        var rangeEnd = args.rangeEnd;

        var totalNumber = self.getTotalNumber();

        var showPrevious = attributes.showPrevious;
        var showNext = attributes.showNext;
        var showPageNumbers = attributes.showPageNumbers;
        var showNavigator = attributes.showNavigator;
        var showGoInput = attributes.showGoInput;
        var showGoButton = attributes.showGoButton;

        var pageLink = attributes.pageLink;
        var prevText = attributes.prevText;
        var nextText = attributes.nextText;
        var ellipsisText = attributes.ellipsisText;
        var goButtonText = attributes.goButtonText;

        var classPrefix = attributes.classPrefix;
        var activeClassName = attributes.activeClassName;
        var disableClassName = attributes.disableClassName;
        var ulClassName = attributes.ulClassName;

        var html = '';
        var goInput = '<input type="text" class="J-paginationjs-go-pagenumber">';
        var goButton = '<input type="button" class="J-paginationjs-go-button" value="' + goButtonText + '">';
        var formattedString;
        var i;

        var formatNavigator = $.isFunction(attributes.formatNavigator) ? attributes.formatNavigator(currentPage, totalPage, totalNumber) : attributes.formatNavigator;
        var formatGoInput = $.isFunction(attributes.formatGoInput) ? attributes.formatGoInput(goInput, currentPage, totalPage, totalNumber) : attributes.formatGoInput;
        var formatGoButton = $.isFunction(attributes.formatGoButton) ? attributes.formatGoButton(goButton, currentPage, totalPage, totalNumber) : attributes.formatGoButton;

        var autoHidePrevious = $.isFunction(attributes.autoHidePrevious) ? attributes.autoHidePrevious() : attributes.autoHidePrevious;
        var autoHideNext = $.isFunction(attributes.autoHideNext) ? attributes.autoHideNext() : attributes.autoHideNext;

        var header = $.isFunction(attributes.header) ? attributes.header(currentPage, totalPage, totalNumber) : attributes.header;
        var footer = $.isFunction(attributes.footer) ? attributes.footer(currentPage, totalPage, totalNumber) : attributes.footer;

        // Whether to display header
        if (header) {
          formattedString = self.replaceVariables(header, {
            currentPage: currentPage,
            totalPage: totalPage,
            totalNumber: totalNumber
          });
          html += formattedString;
        }

        if (showPrevious || showPageNumbers || showNext) {
          html += '<div class="paginationjs-pages">';

          if (ulClassName) {
            html += '<ul class="' + ulClassName + '">';
          } else {
            html += '<ul>';
          }

          // Whether to display the Previous button
          if (showPrevious) {
            if (currentPage <= 1) {
              if (!autoHidePrevious) {
                html += '<li class="' + classPrefix + '-prev ' + disableClassName + '"><a>' + prevText + '<\/a><\/li>';
              }
            } else {
              html += '<li class="' + classPrefix + '-prev J-paginationjs-previous" data-num="' + (currentPage - 1) + '" title="Previous page"><a href="' + pageLink + '">' + prevText + '<\/a><\/li>';
            }
          }

          // Whether to display the pages
          if (showPageNumbers) {
            if (rangeStart <= 3) {
              for (i = 1; i < rangeStart; i++) {
                if (i == currentPage) {
                  html += '<li class="' + classPrefix + '-page J-paginationjs-page ' + activeClassName + '" data-num="' + i + '"><a>' + i + '<\/a><\/li>';
                } else {
                  html += '<li class="' + classPrefix + '-page J-paginationjs-page" data-num="' + i + '"><a href="' + pageLink + '">' + i + '<\/a><\/li>';
                }
              }
            } else {
              if (attributes.showFirstOnEllipsisShow) {
                html += '<li class="' + classPrefix + '-page ' + classPrefix + '-first J-paginationjs-page" data-num="1"><a href="' + pageLink + '">1<\/a><\/li>';
              }
              html += '<li class="' + classPrefix + '-ellipsis ' + disableClassName + '"><a>' + ellipsisText + '<\/a><\/li>';
            }

            for (i = rangeStart; i <= rangeEnd; i++) {
              if (i == currentPage) {
                html += '<li class="' + classPrefix + '-page J-paginationjs-page ' + activeClassName + '" data-num="' + i + '"><a>' + i + '<\/a><\/li>';
              } else {
                html += '<li class="' + classPrefix + '-page J-paginationjs-page" data-num="' + i + '"><a href="' + pageLink + '">' + i + '<\/a><\/li>';
              }
            }

            if (rangeEnd >= totalPage - 2) {
              for (i = rangeEnd + 1; i <= totalPage; i++) {
                html += '<li class="' + classPrefix + '-page J-paginationjs-page" data-num="' + i + '"><a href="' + pageLink + '">' + i + '<\/a><\/li>';
              }
            } else {
              html += '<li class="' + classPrefix + '-ellipsis ' + disableClassName + '"><a>' + ellipsisText + '<\/a><\/li>';

              if (attributes.showLastOnEllipsisShow) {
                html += '<li class="' + classPrefix + '-page ' + classPrefix + '-last J-paginationjs-page" data-num="' + totalPage + '"><a href="' + pageLink + '">' + totalPage + '<\/a><\/li>';
              }
            }
          }

          // Whether to display the Next button
          if (showNext) {
            if (currentPage >= totalPage) {
              if (!autoHideNext) {
                html += '<li class="' + classPrefix + '-next ' + disableClassName + '"><a>' + nextText + '<\/a><\/li>';
              }
            } else {
              html += '<li class="' + classPrefix + '-next J-paginationjs-next" data-num="' + (currentPage + 1) + '" title="Next page"><a href="' + pageLink + '">' + nextText + '<\/a><\/li>';
            }
          }
          html += '<\/ul><\/div>';
        }

        // Whether to display the navigator
        if (showNavigator) {
          if (formatNavigator) {
            formattedString = self.replaceVariables(formatNavigator, {
              currentPage: currentPage,
              totalPage: totalPage,
              totalNumber: totalNumber
            });
            html += '<div class="' + classPrefix + '-nav J-paginationjs-nav">' + formattedString + '<\/div>';
          }
        }

        // Whether to display the Go input
        if (showGoInput) {
          if (formatGoInput) {
            formattedString = self.replaceVariables(formatGoInput, {
              currentPage: currentPage,
              totalPage: totalPage,
              totalNumber: totalNumber,
              input: goInput
            });
            html += '<div class="' + classPrefix + '-go-input">' + formattedString + '</div>';
          }
        }

        // Whether to display the Go button
        if (showGoButton) {
          if (formatGoButton) {
            formattedString = self.replaceVariables(formatGoButton, {
              currentPage: currentPage,
              totalPage: totalPage,
              totalNumber: totalNumber,
              button: goButton
            });
            html += '<div class="' + classPrefix + '-go-button">' + formattedString + '</div>';
          }
        }

        // Whether to display footer
        if (footer) {
          formattedString = self.replaceVariables(footer, {
            currentPage: currentPage,
            totalPage: totalPage,
            totalNumber: totalNumber
          });
          html += formattedString;
        }

        return html;
      },

      // Find totalNumber from the remote response
      // Only available in asynchronous mode
      findTotalNumberFromRemoteResponse: function(response) {
        var self = this;
        self.model.totalNumber = attributes.totalNumberLocator(response);
      },

      // Go to the specified page
      go: function(number, callback) {
        var self = this;
        var model = self.model;

        if (self.disabled) return;

        var pageNumber = number;
        pageNumber = parseInt(pageNumber);

        // Page number is out of bounds
        if (!pageNumber || pageNumber < 1) return;

        var pageSize = attributes.pageSize;
        var totalNumber = self.getTotalNumber();
        var totalPage = self.getTotalPage();

        // Page number is out of bounds
        if (totalNumber > 0) {
          if (pageNumber > totalPage) return;
        }

        // Pick data fragment in synchronous mode
        if (!self.isAsync) {
          render(self.getDataFragment(pageNumber));
          return;
        }

        var postData = {};
        var alias = attributes.alias || {};
        postData[alias.pageSize ? alias.pageSize : 'pageSize'] = pageSize;
        postData[alias.pageNumber ? alias.pageNumber : 'pageNumber'] = pageNumber;

        var ajaxParams = $.isFunction(attributes.ajax) ? attributes.ajax() : attributes.ajax;
        var formatAjaxParams = {
          type: 'get',
          cache: false,
          data: {},
          contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
          dataType: 'json',
          async: true
        };

        $.extend(true, formatAjaxParams, ajaxParams);
        $.extend(formatAjaxParams.data, postData);

        formatAjaxParams.url = attributes.dataSource;
        formatAjaxParams.success = function(response) {
          if (self.isDynamicTotalNumber) {
            self.findTotalNumberFromRemoteResponse(response);
          } else {
            self.model.totalNumber = attributes.totalNumber;
          }
          render(self.filterDataByLocator(response));
        };
        formatAjaxParams.error = function(jqXHR, textStatus, errorThrown) {
          attributes.formatAjaxError && attributes.formatAjaxError(jqXHR, textStatus, errorThrown);
          self.enable();
        };

        self.disable();

        $.ajax(formatAjaxParams);

        function render(data) {
          // Will be invoked before paging
          if (self.callHook('beforePaging', pageNumber) === false) return false;

          // Pagination direction
          model.direction = typeof model.pageNumber === 'undefined' ? 0 : (pageNumber > model.pageNumber ? 1 : -1);

          model.pageNumber = pageNumber;

          self.render();

          if (self.disabled && self.isAsync) {
            // enable pagination
            self.enable();
          }

          // cache model data
          container.data('pagination').model = model;

          // format result data before callback invoked
          if (attributes.formatResult) {
            var cloneData = $.extend(true, [], data);
            if (!Helpers.isArray(data = attributes.formatResult(cloneData))) {
              data = cloneData;
            }
          }

          container.data('pagination').currentPageData = data;

          // invoke callback
          self.doCallback(data, callback);

          self.callHook('afterPaging', pageNumber);

          // pageNumber now is the first page
          if (pageNumber == 1) {
            self.callHook('afterIsFirstPage');
          }

          // pageNumber now is the last page
          if (pageNumber == self.getTotalPage()) {
            self.callHook('afterIsLastPage');
          }
        }
      },

      doCallback: function(data, customCallback) {
        var self = this;
        var model = self.model;

        if ($.isFunction(customCallback)) {
          customCallback(data, model);
        } else if ($.isFunction(attributes.callback)) {
          attributes.callback(data, model);
        }
      },

      destroy: function() {
        // Before destroy
        if (this.callHook('beforeDestroy') === false) return;

        this.model.el.remove();
        container.off();

        // Remove style element
        $('#paginationjs-style').remove();

        // After destroyed
        this.callHook('afterDestroy');
      },

      previous: function(callback) {
        this.go(this.model.pageNumber - 1, callback);
      },

      next: function(callback) {
        this.go(this.model.pageNumber + 1, callback);
      },

      disable: function() {
        var self = this;
        var source = self.isAsync ? 'async' : 'sync';

        // Before disabled
        if (self.callHook('beforeDisable', source) === false) return;

        self.disabled = true;
        self.model.disabled = true;

        // After disabled
        self.callHook('afterDisable', source);
      },

      enable: function() {
        var self = this;
        var source = self.isAsync ? 'async' : 'sync';

        // Before enabled
        if (self.callHook('beforeEnable', source) === false) return;

        self.disabled = false;
        self.model.disabled = false;

        // After enabled
        self.callHook('afterEnable', source);
      },

      refresh: function(callback) {
        this.go(this.model.pageNumber, callback);
      },

      show: function() {
        var self = this;

        if (self.model.el.is(':visible')) return;

        self.model.el.show();
      },

      hide: function() {
        var self = this;

        if (!self.model.el.is(':visible')) return;

        self.model.el.hide();
      },

      // Parse variables in the template
      replaceVariables: function(template, variables) {
        var formattedString;

        for (var key in variables) {
          var value = variables[key];
          var regexp = new RegExp('<%=\\s*' + key + '\\s*%>', 'img');

          formattedString = (formattedString || template).replace(regexp, value);
        }

        return formattedString;
      },

      // Get data fragment
      getDataFragment: function(number) {
        var pageSize = attributes.pageSize;
        var dataSource = attributes.dataSource;
        var totalNumber = this.getTotalNumber();

        var start = pageSize * (number - 1) + 1;
        var end = Math.min(number * pageSize, totalNumber);

        return dataSource.slice(start - 1, end);
      },

      // Get total number
      getTotalNumber: function() {
        return this.model.totalNumber || attributes.totalNumber || 0;
      },

      // Get total page
      getTotalPage: function() {
        return Math.ceil(this.getTotalNumber() / attributes.pageSize);
      },

      // Get locator
      getLocator: function(locator) {
        var result;

        if (typeof locator === 'string') {
          result = locator;
        } else if ($.isFunction(locator)) {
          result = locator();
        } else {
          throwError('"locator" is incorrect. (String | Function)');
        }

        return result;
      },

      // Filter data by "locator"
      filterDataByLocator: function(dataSource) {
        var locator = this.getLocator(attributes.locator);
        var filteredData;

        // Datasource is an Object, use "locator" to locate the true data
        if (Helpers.isObject(dataSource)) {
          try {
            $.each(locator.split('.'), function(index, item) {
              filteredData = (filteredData ? filteredData : dataSource)[item];
            });
          }
          catch (e) {
          }

          if (!filteredData) {
            throwError('dataSource.' + locator + ' is undefined.');
          } else if (!Helpers.isArray(filteredData)) {
            throwError('dataSource.' + locator + ' must be an Array.');
          }
        }

        return filteredData || dataSource;
      },

      // Parse dataSource
      parseDataSource: function(dataSource, callback) {
        var self = this;

        if (Helpers.isObject(dataSource)) {
          callback(attributes.dataSource = self.filterDataByLocator(dataSource));
        } else if (Helpers.isArray(dataSource)) {
          callback(attributes.dataSource = dataSource);
        } else if ($.isFunction(dataSource)) {
          attributes.dataSource(function(data) {
            if (!Helpers.isArray(data)) {
              throwError('The parameter of "done" Function should be an Array.');
            }
            self.parseDataSource.call(self, data, callback);
          });
        } else if (typeof dataSource === 'string') {
          if (/^https?|file:/.test(dataSource)) {
            attributes.ajaxDataType = 'jsonp';
          }
          callback(dataSource);
        } else {
          throwError('Unexpected type of "dataSource".');
        }
      },

      callHook: function(hook) {
        var paginationData = container.data('pagination');
        var result;

        var args = Array.prototype.slice.apply(arguments);
        args.shift();

        if (attributes[hook] && $.isFunction(attributes[hook])) {
          if (attributes[hook].apply(global, args) === false) {
            result = false;
          }
        }

        if (paginationData.hooks && paginationData.hooks[hook]) {
          $.each(paginationData.hooks[hook], function(index, item) {
            if (item.apply(global, args) === false) {
              result = false;
            }
          });
        }

        return result !== false;
      },

      observer: function() {
        var self = this;
        var el = self.model.el;

        // Go to specified page number
        container.on(eventPrefix + 'go', function(event, pageNumber, done) {
          pageNumber = parseInt($.trim(pageNumber));

          if (!pageNumber) return;

          if (!$.isNumeric(pageNumber)) {
            throwError('"pageNumber" is incorrect. (Number)');
          }

          self.go(pageNumber, done);
        });

        // Page number button click
        el.delegate('.J-paginationjs-page', 'click', function(event) {
          var current = $(event.currentTarget);
          var pageNumber = $.trim(current.attr('data-num'));

          if (!pageNumber || current.hasClass(attributes.disableClassName) || current.hasClass(attributes.activeClassName)) return;

          // Before page button clicked
          if (self.callHook('beforePageOnClick', event, pageNumber) === false) return false;

          self.go(pageNumber);

          // After page button clicked
          self.callHook('afterPageOnClick', event, pageNumber);

          if (!attributes.pageLink) return false;
        });

        // Previous button click
        el.delegate('.J-paginationjs-previous', 'click', function(event) {
          var current = $(event.currentTarget);
          var pageNumber = $.trim(current.attr('data-num'));

          if (!pageNumber || current.hasClass(attributes.disableClassName)) return;

          // Before previous clicked
          if (self.callHook('beforePreviousOnClick', event, pageNumber) === false) return false;

          self.go(pageNumber);

          // After previous clicked
          self.callHook('afterPreviousOnClick', event, pageNumber);

          if (!attributes.pageLink) return false;
        });

        // Next button click
        el.delegate('.J-paginationjs-next', 'click', function(event) {
          var current = $(event.currentTarget);
          var pageNumber = $.trim(current.attr('data-num'));

          if (!pageNumber || current.hasClass(attributes.disableClassName)) return;

          // Before next clicked
          if (self.callHook('beforeNextOnClick', event, pageNumber) === false) return false;

          self.go(pageNumber);

          // After next clicked
          self.callHook('afterNextOnClick', event, pageNumber);

          if (!attributes.pageLink) return false;
        });

        // Go button click
        el.delegate('.J-paginationjs-go-button', 'click', function(event) {
          var pageNumber = $('.J-paginationjs-go-pagenumber', el).val();

          // Before Go button clicked
          if (self.callHook('beforeGoButtonOnClick', event, pageNumber) === false) return false;

          container.trigger(eventPrefix + 'go', pageNumber);

          // After Go button clicked
          self.callHook('afterGoButtonOnClick', event, pageNumber);
        });

        // go input enter
        el.delegate('.J-paginationjs-go-pagenumber', 'keyup', function(event) {
          if (event.which === 13) {
            var pageNumber = $(event.currentTarget).val();

            // Before Go input enter
            if (self.callHook('beforeGoInputOnEnter', event, pageNumber) === false) return false;

            container.trigger(eventPrefix + 'go', pageNumber);

            // Regains focus
            $('.J-paginationjs-go-pagenumber', el).focus();

            // After Go input enter
            self.callHook('afterGoInputOnEnter', event, pageNumber);
          }
        });

        // Previous page
        container.on(eventPrefix + 'previous', function(event, done) {
          self.previous(done);
        });

        // Next page
        container.on(eventPrefix + 'next', function(event, done) {
          self.next(done);
        });

        // Disable
        container.on(eventPrefix + 'disable', function() {
          self.disable();
        });

        // Enable
        container.on(eventPrefix + 'enable', function() {
          self.enable();
        });

        // Refresh
        container.on(eventPrefix + 'refresh', function(event, done) {
          self.refresh(done);
        });

        // Show
        container.on(eventPrefix + 'show', function() {
          self.show();
        });

        // Hide
        container.on(eventPrefix + 'hide', function() {
          self.hide();
        });

        // Destroy
        container.on(eventPrefix + 'destroy', function() {
          self.destroy();
        });

        // Whether to load the default page
        var validTotalPage = Math.max(self.getTotalPage(), 1)
        var defaultPageNumber = attributes.pageNumber;
        // Default pageNumber should be 1 when totalNumber is dynamic
        if (self.isDynamicTotalNumber) {
          defaultPageNumber = 1;
        }
        if (attributes.triggerPagingOnInit) {
          container.trigger(eventPrefix + 'go', Math.min(defaultPageNumber, validTotalPage));
        }
      }
    };

    // Pagination has been initialized
    if (container.data('pagination') && container.data('pagination').initialized === true) {
      // Handle events
      if ($.isNumeric(options)) {
        // eg: container.pagination(5)
        container.trigger.call(this, eventPrefix + 'go', options, arguments[1]);
        return this;
      } else if (typeof options === 'string') {
        var args = Array.prototype.slice.apply(arguments);
        args[0] = eventPrefix + args[0];

        switch (options) {
          case 'previous':
          case 'next':
          case 'go':
          case 'disable':
          case 'enable':
          case 'refresh':
          case 'show':
          case 'hide':
          case 'destroy':
            container.trigger.apply(this, args);
            break;
          // Get selected page number
          case 'getSelectedPageNum':
            if (container.data('pagination').model) {
              return container.data('pagination').model.pageNumber;
            } else {
              return container.data('pagination').attributes.pageNumber;
            }
          // Get total page
          case 'getTotalPage':
            return Math.ceil(container.data('pagination').model.totalNumber / container.data('pagination').model.pageSize);
          // Get data of selected page
          case 'getSelectedPageData':
            return container.data('pagination').currentPageData;
          // Whether pagination has been disabled
          case 'isDisabled':
            return container.data('pagination').model.disabled === true;
          default:
            throwError('Unknown action: ' + options);
        }
        return this;
      } else {
        // Uninstall the old instance before initializing a new one
        uninstallPlugin(container);
      }
    } else {
      if (!Helpers.isObject(options)) throwError('Illegal options');
    }

    // Check parameters
    parameterChecker(attributes);

    pagination.initialize();

    return this;
  };

  // Instance defaults
  $.fn[pluginName].defaults = {

    // Data source
    // Array | String | Function | Object
    //dataSource: '',

    // String | Function
    //locator: 'data',

    // Find totalNumber from remote response, the totalNumber will be ignored when totalNumberLocator is specified
    // Function
    //totalNumberLocator: function() {},

    // Total entries
    totalNumber: 0,

    // Default page
    pageNumber: 1,

    // entries of per page
    pageSize: 10,

    // Page range (pages on both sides of the current page)
    pageRange: 2,

    // Whether to display the 'Previous' button
    showPrevious: true,

    // Whether to display the 'Next' button
    showNext: true,

    // Whether to display the page buttons
    showPageNumbers: true,

    showNavigator: false,

    // Whether to display the 'Go' input
    showGoInput: false,

    // Whether to display the 'Go' button
    showGoButton: false,

    // Page link
    pageLink: '',

    // 'Previous' text
    prevText: '&laquo;',

    // 'Next' text
    nextText: '&raquo;',

    // Ellipsis text
    ellipsisText: '...',

    // 'Go' button text
    goButtonText: 'Go',

    // Additional className for Pagination element
    //className: '',

    classPrefix: 'paginationjs',

    // Default active class
    activeClassName: 'active',

    // Default disable class
    disableClassName: 'disabled',

    //ulClassName: '',

    // Whether to insert inline style
    inlineStyle: true,

    formatNavigator: '<%= currentPage %> / <%= totalPage %>',

    formatGoInput: '<%= input %>',

    formatGoButton: '<%= button %>',

    // Pagination element's position in the container
    position: 'bottom',

    // Auto hide previous button when current page is the first page
    autoHidePrevious: false,

    // Auto hide next button when current page is the last page
    autoHideNext: false,

    //header: '',

    //footer: '',

    // Aliases for custom pagination parameters
    //alias: {},

    // Whether to trigger pagination at initialization
    triggerPagingOnInit: true,

    // Whether to hide pagination when less than one page
    hideWhenLessThanOnePage: false,

    showFirstOnEllipsisShow: true,

    showLastOnEllipsisShow: true,

    // Pagination callback
    callback: function() {}
  };

  // Hook register
  $.fn[pluginHookMethod] = function(hook, callback) {
    if (arguments.length < 2) {
      throwError('Missing argument.');
    }

    if (!$.isFunction(callback)) {
      throwError('callback must be a function.');
    }

    var container = $(this);
    var paginationData = container.data('pagination');

    if (!paginationData) {
      container.data('pagination', {});
      paginationData = container.data('pagination');
    }

    !paginationData.hooks && (paginationData.hooks = {});

    //paginationData.hooks[hook] = callback;
    paginationData.hooks[hook] = paginationData.hooks[hook] || [];
    paginationData.hooks[hook].push(callback);

  };

  // Static method
  $[pluginName] = function(selector, options) {
    if (arguments.length < 2) {
      throwError('Requires two parameters.');
    }

    var container;

    // 'selector' is a jQuery object
    if (typeof selector !== 'string' && selector instanceof jQuery) {
      container = selector;
    } else {
      container = $(selector);
    }

    if (!container.length) return;

    container.pagination(options);

    return container;
  };

  // ============================================================
  // helpers
  // ============================================================

  var Helpers = {};

  // Throw error
  function throwError(content) {
    throw new Error('Pagination: ' + content);
  }

  // Check parameters
  function parameterChecker(args) {
    if (!args.dataSource) {
      throwError('"dataSource" is required.');
    }

    if (typeof args.dataSource === 'string') {
      if (args.totalNumberLocator === undefined) {
        if (args.totalNumber === undefined) {
          throwError('"totalNumber" is required.');
        } else if (!$.isNumeric(args.totalNumber)) {
          throwError('"totalNumber" is incorrect. (Number)');
        }
      } else {
        if (!$.isFunction(args.totalNumberLocator)) {
          throwError('"totalNumberLocator" should be a Function.');
        }
      }
    } else if (Helpers.isObject(args.dataSource)) {
      if (typeof args.locator === 'undefined') {
        throwError('"dataSource" is an Object, please specify "locator".');
      } else if (typeof args.locator !== 'string' && !$.isFunction(args.locator)) {
        throwError('' + args.locator + ' is incorrect. (String | Function)');
      }
    }

    if (args.formatResult !== undefined && !$.isFunction(args.formatResult)) {
      throwError('"formatResult" should be a Function.');
    }
  }

  // uninstall plugin
  function uninstallPlugin(target) {
    var events = ['go', 'previous', 'next', 'disable', 'enable', 'refresh', 'show', 'hide', 'destroy'];

    // off events of old instance
    $.each(events, function(index, value) {
      target.off(eventPrefix + value);
    });

    // reset pagination data
    target.data('pagination', {});

    // remove old
    $('.paginationjs', target).remove();
  }

  // Object type detection
  function getObjectType(object, tmp) {
    return ( (tmp = typeof(object)) == "object" ? object == null && "null" || Object.prototype.toString.call(object).slice(8, -1) : tmp ).toLowerCase();
  }

  $.each(['Object', 'Array', 'String'], function(index, name) {
    Helpers['is' + name] = function(object) {
      return getObjectType(object) === name.toLowerCase();
    };
  });

  /*
   * export via AMD or CommonJS
   * */
  if (typeof define === 'function' && define.amd) {
    define('nmodule/easyDatabaseManager/rc/js/pagination/pagination',[],function() {
      return $;
    });
  }

})(this, window.jQuery);

/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225 on 7/16/2019
 *
 */

/**
 * A module defining `deletePointsViewWidget`.
 *
 * @module nmodule/easyDatabaseManager/rc/js/datatable
 */
define('nmodule/easyDatabaseManager/rc/js/datatable',['baja!',
        'jquery',
        'underscore',
        'hbs!nmodule/easyDatabaseManager/rc/hbs/datatable',
        'hbs!nmodule/easyDatabaseManager/rc/hbs/datarows',
        'nmodule/easyDatabaseManager/rc/js/pagination/pagination',
        'css!nmodule/easyDatabaseManager/rc/js/pagination/pagination',
        'css!nmodule/easyDatabaseManager/rc/css/datatable'
    ],
    function (baja, $, _, template, rowsTemplate) {

        

        var datatable = function(options) {
           /* var _self = $(this);*/

            var $parent
/*
                , _options = {
                parent:null,
                rowSelectionCallback : null
            }
*/
            ;
            var _paginationOptions = {
                pageSize: 20,
                pageRange:2
            };

            var _isdataAvailable = function(datatable_options) {
                if(datatable_options) {
                    var tableData = datatable_options.tableData;
                    if(tableData && tableData.columns && tableData.columns.length > 0 && tableData.rows) {
                        return true;
                    }
                }
              return false;
            };

            var makeDataPointsSelectable = function(event){
                var $target = $(event.target);
                var dom = event.data.dom;
                //identify if header is selected!!
                var parent = $target.parents("span.ui-column-title");
                var isHeaderColumnClicked = (parent.length > 0);
                if(isHeaderColumnClicked) {
                    if($target.hasClass("ui-chkbox-icon")) {
                        $(dom).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default")
                            .removeClass("ui-state-active");
                        $(dom).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default .ui-chkbox-icon.ui-clickable")
                            .removeClass("pi pi-check");
                    } else {
                        $(dom).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default")
                            .addClass("ui-state-active");
                        $(dom).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default .ui-chkbox-icon.ui-clickable")
                            .addClass("pi pi-check");
                    }
                } else {
                    var $header;
                    if($target.hasClass("ui-chkbox-icon")) {
                        $target.parent().toggleClass("ui-state-active");
                        $target.toggleClass("pi pi-check");

                        //if header is selected - uncheck it
                        $header = $(dom).find("span.ui-column-title div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default");
                        $header.removeClass("ui-state-active");
                        $header.find(".ui-chkbox-icon.ui-clickable").removeClass("pi pi-check");
                    } else {
                        $target.toggleClass("ui-state-active");
                        $target.find(".ui-chkbox-icon.ui-clickable").toggleClass("pi pi-check");

                        // if all rows are selected - check header as well.
                        var tbody  = $(dom).find(".ui-datatable tbody");
                        if(tbody.find(".ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").length > 0 &&
                            (tbody.find(".ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").length ===
                                tbody.find(".ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.ui-state-active").length)) {
                            $header = $(dom).find("span.ui-column-title div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default");
                            $header.addClass("ui-state-active");
                            $header.find(".ui-chkbox-icon.ui-clickable").addClass("pi pi-check");
                        }
                    }
                }
                //return if row is selected or un-selected
                if(options.rowSelectionCallback) {
                    options.rowSelectionCallback(($target.hasClass("ui-chkbox-icon") ? $target.parent() : $target));
                }
            };

            var _addEventListeners = function(dom) {
                var isWorkBench = JSON.parse(document.getElementById("hiddenFieldIsWorkBench").value);
                //select or unselect individual rows
                $(dom).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").off('click', makeDataPointsSelectable);
                $(dom).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").on('click',{dom: dom} , makeDataPointsSelectable);
                var stepsFour = document.getElementById("PDM-contents-step4-details");
                var allElements = stepsFour!=null?stepsFour.getElementsByClassName("cell-data-wrap"):[];
                for(var i=0;i<allElements.length;i++){
                  var itemEle=allElements[i];
                    itemEle.addEventListener("mouseover",function (event){
                        var xyRect = event.currentTarget.getBoundingClientRect();
                        var $tooltip = $(dom).find(".datatable-tooltip");
                        $tooltip.find(".datatable-tooltip-content").text($(event.target).attr("data-tooltip"));
                        var yPos = xyRect.y;
                        var xPos = xyRect.x- xyRect.width;
                        if(isWorkBench){
                            yPos = xyRect.y+35;
                            xPos = xyRect.x;
                        }
                        $tooltip.css("left", xPos + "px");
                        $tooltip.css("top",yPos + "px");
                        $tooltip.addClass("datatable-tooltip-show");
                    });
                    itemEle.addEventListener("mouseout",function (event){
                        var $tooltip = $(dom).find(".datatable-tooltip");
                        $tooltip.removeClass("datatable-tooltip-show");
                    });
                }
                if(dom.hasClass("points-table-wrapper"))
                {
                    $(".points-table-wrapper").find(".secured-selection-column").hide();
                    $(".points-table-wrapper .clear-selected-secure-point").remove();
                }else if(dom.hasClass("secure-points-table-wrapper"))
                {
                    $(".secure-points-table-wrapper").find("thead .ui-state-default .ui-selection-column").hide();
                    $(".secure-points-table-wrapper").find("tbody .ui-selection-column").hide();
                    $(".secure-points-table-wrapper").find("thead .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.checkbox-header").hide();
                    $(".secure-points-table-wrapper thead .ui-selection-column .ui-column-title").remove();
                }
            };

            var _displayPage = function(data, pagination) {
                var start = (pagination.pageNumber - 1) * pagination.pageSize;
                var end = pagination.pageNumber * pagination.pageSize;
                end = (end > pagination.totalNumber) ? pagination.totalNumber : end;
                $parent.find("tbody.ui-datatable-data tr").css('display', 'none');
                $parent.find("tbody.ui-datatable-data tr").slice(start, end).css('display', 'table-row');
            };

            var _addPagination = function() {
                $parent.pagination({
                        dataSource: options.tableData.rows,
                        callback: function(data, pagination) {
                            _displayPage(data, pagination);
                        },
                        pageSize: _paginationOptions.pageSize,
                        totalNumber: options.tableData.rows.length,
                        pageRange:_paginationOptions.pageRange
                    }
                );
            };

            var _restore_selection = function($datatable_parent) {
                if(options.updateselectedData && options.updateselectedData.length > 0) {
                    var tbody  = $datatable_parent.find(".ui-datatable tbody");
                    $.each($(tbody).find(".ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default"),
                        function(index, elem) {
                            if(options.updateselectedData.includes($(elem).attr('data-handle'))) {
                                $(elem).toggleClass("ui-state-active");
                                $(elem).find(".ui-chkbox-icon.ui-clickable").toggleClass("pi pi-check");
                            }});
                    tbody  = $datatable_parent.find(".ui-datatable tbody");
                    if(tbody.find(".ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").length > 0 &&
                        (tbody.find(".ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").length ===
                            tbody.find(".ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.ui-state-active").length)) {
                        var $header = $datatable_parent.find("span.ui-column-title div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default");
                        $header.addClass("ui-state-active");
                        $header.find(".ui-chkbox-icon.ui-clickable").addClass("pi pi-check");
                    }
                }
                if($datatable_parent.hasClass("secure-points-table-wrapper"))
                {
                    if(options.updateselectedData !== null)
                    {
                        $($datatable_parent).find("input[id='"+options.updateselectedData+"']").attr('checked',true);
                        $($datatable_parent).find(".clear-selected-secure-point").prop('disabled',false);
                        $($datatable_parent).find(".clear-selected-secure-point").removeClass("button-inactive");
                    }
                    if(options.rowSelectionCallback) {
                        options.rowSelectionCallback();
                    }
                }
            };

            var _replaceRows = function(rows) {
                if($parent.hasClass("secure-points-table-wrapper") && $parent.find("input[name='radioSecuredPoints']:checked").length > 0){
                    options.updateselectedData = $parent.find("input[name='radioSecuredPoints']:checked").prop("id");
                }
                $parent.find("tbody.ui-datatable-data").html(rowsTemplate({rows:rows}));
                _addPagination();
                _addEventListeners($parent);

                // restore selection
                _restore_selection($parent);

            };

            var _makeTableSortable = function(dom) {
                $(dom).find(".ui-sortable-column span").click(function(event) {
                    var $target = $(event.target);
                    if(!$target.hasClass("ui-sortable-column-icon")) {
                        $target = $target.next("span.ui-sortable-column-icon");
                    }
                    var tempData = options.tableData.rows.slice();
                    var field = $target.attr("data-name");
                    if($target.hasClass("pi-sort-up")) {
                        //sorted in ascending order. sort in descending order now
                        $target.removeClass("pi-sort-up");
                        $target.addClass("pi-sort-down");
                        tempData = _.sortBy(tempData, field).reverse();
                    } else if($target.hasClass("pi-sort-down")) {
                        //sorted in descending order. restore default order
                        $target.removeClass("pi-sort-down");
                        //do nothing just replace rows with original order
                    } else {
                        // reset sorting done on other columns - we only support single column sorting
                        $(dom).find("span.ui-sortable-column-icon").removeClass("pi-sort-up");
                        $(dom).find("span.ui-sortable-column-icon").removeClass("pi-sort-down");

                        // no sorting performed so far. Sort in ascending order
                        $target.addClass("pi-sort-up");
                        tempData = _.sortBy(tempData, field);
                    }
                     _replaceRows(tempData);
                });
            };

            var _initialise = function() {
                if(_isdataAvailable(options)) {
                    $parent = (options.parent) ? $(options.parent) :  $('<div class="table-wrapper"></div>');
                    $parent.html(template(options.tableData));
                    if(options.tableData.rows.length > 0) {
                        _addPagination();
                        _addEventListeners($parent);
                        _makeTableSortable($parent);
                    }
                    else {
                        var $tr = $('<tr><td colspan="3" class="ui-datatable-no-data"></td></tr>');
                        $tr.find(".ui-datatable-no-data").html(options.noDataMesage);
                        $parent.find("tbody.ui-datatable-data").html($tr);
                        $(".secure-points-table-wrapper").find("thead .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.checkbox-header").hide();
                        $(".points-table-wrapper .clear-selected-secure-point").remove();
                        $(".secure-points-table-wrapper thead .ui-selection-column .ui-column-title").remove();
                    }
                    // restore selection
                    _restore_selection($parent);
                }
                else {
                    throw(new Error("Unable to create table, invalid table data."));
                }
            };


            _initialise();
            return {
                create : function() {
                    _initialise();
                },
                replace : function(tableData) {
                    $parent.html(template(tableData));
                    _addEventListeners($parent);
                },
                replaceRows: function(rows) {
                    _replaceRows(rows);
                },
                destroy : function() {
                    /* Add logic to destroy (remove) datatable and clean up resources*/
                },
                addRows : function(/*start, end*/) {
                    /*Add logic to add more rows to the datatable*/
                },
                deleteRows : function(/*start, end*/) {
                    /*Add logic to delete rows from the datatable*/
                },
                showRows : function(/*start, end*/) {
                    /*Add logic to show specific rows within datatable*/
                },
                hideRows: function(/*start, end*/) {
                    /*Add logic to hide specific rows within datatable*/
                },
                updateOptions: function(opt) {
                    $.extend(options, opt);
                }
            };
        };
        return datatable;
    });

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/reviewPointsViewTemplate',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div id=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"vid") || (depth0 != null ? lookupProperty(depth0,"vid") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"vid","hash":{},"data":data,"loc":{"start":{"line":1,"column":9},"end":{"line":1,"column":16}}}) : helper)))
    + "\">\n    <div class=\"PDM-step-details\">\n        <div class=\"PDM-contents-step-summary\">\n            <span class=\"PDM-step-count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepCount") || (depth0 != null ? lookupProperty(depth0,"stepCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepCount","hash":{},"data":data,"loc":{"start":{"line":4,"column":41},"end":{"line":4,"column":54}}}) : helper)))
    + "</span>\n            <span class=\"PDM-step-name\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"summaryMessage") || (depth0 != null ? lookupProperty(depth0,"summaryMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"summaryMessage","hash":{},"data":data,"loc":{"start":{"line":5,"column":40},"end":{"line":5,"column":58}}}) : helper)))
    + "</span>\n        </div>\n        <div class=\"PDM-step-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepDescription") || (depth0 != null ? lookupProperty(depth0,"stepDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepDescription","hash":{},"data":data,"loc":{"start":{"line":7,"column":42},"end":{"line":7,"column":61}}}) : helper)))
    + "</div>\n    </div>\n    <div id=\"PDM-contents-step4-details\" class=\"PDM-contents-step-details\">\n        <div class=\"PDM-progress-container\" id=\"wizard-progress-bar-container\">\n            <span class=\"PDM-progress-bar\" id=\"wizard-progress-bar\"></span>\n        </div>\n        <div class=\"tabs\">\n            <button data-toggle=\"unsecuredPoints\" class=\"tabLinks active\" id=\"button-tab-unsecured-points\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsWithoutEsignature") || (depth0 != null ? lookupProperty(depth0,"pointsWithoutEsignature") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsWithoutEsignature","hash":{},"data":data,"loc":{"start":{"line":14,"column":107},"end":{"line":14,"column":134}}}) : helper)))
    + "</button>\n            <button data-toggle=\"securedPoints\" class=\"tabLinks\" id=\"button-tab-secured-points\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsWithEsignature") || (depth0 != null ? lookupProperty(depth0,"pointsWithEsignature") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsWithEsignature","hash":{},"data":data,"loc":{"start":{"line":15,"column":96},"end":{"line":15,"column":120}}}) : helper)))
    + "</button>\n        </div>\n        <div class=\"deletePointsViewWidget\">\n            <div class=\"points-header\">\n                <div class=\"points-meta-data\">\n                   "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"selectedCheckboxCountText1") || (depth0 != null ? lookupProperty(depth0,"selectedCheckboxCountText1") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"selectedCheckboxCountText1","hash":{},"data":data,"loc":{"start":{"line":20,"column":19},"end":{"line":20,"column":49}}}) : helper)))
    + " <span id=\"selected-checkbox-count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"selectedCheckboxCount") || (depth0 != null ? lookupProperty(depth0,"selectedCheckboxCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"selectedCheckboxCount","hash":{},"data":data,"loc":{"start":{"line":20,"column":85},"end":{"line":20,"column":110}}}) : helper)))
    + "</span>  "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"selectedCheckboxCountText2") || (depth0 != null ? lookupProperty(depth0,"selectedCheckboxCountText2") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"selectedCheckboxCountText2","hash":{},"data":data,"loc":{"start":{"line":20,"column":119},"end":{"line":20,"column":149}}}) : helper)))
    + " <span class=\"total-count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsSize") || (depth0 != null ? lookupProperty(depth0,"pointsSize") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsSize","hash":{},"data":data,"loc":{"start":{"line":20,"column":176},"end":{"line":20,"column":190}}}) : helper)))
    + " </span> <span> "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalCountLabel") || (depth0 != null ? lookupProperty(depth0,"totalCountLabel") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalCountLabel","hash":{},"data":data,"loc":{"start":{"line":20,"column":206},"end":{"line":20,"column":225}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n            <div class=\"content-section rectangle\">\n                <div class=\"top-bar\">\n                    <div class=\"ui search-wrap\">\n                        <div class=\"ui search ui-search\">\n                            <div class=\"ui icon input\">\n                                <div class=\"search-icon\" ></div>\n                                <input placeholder=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"searchText") || (depth0 != null ? lookupProperty(depth0,"searchText") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"searchText","hash":{},"data":data,"loc":{"start":{"line":29,"column":52},"end":{"line":29,"column":66}}}) : helper)))
    + "\" id=\"pdm-search-input\" type=\"text\" tabindex=\"0\" class=\"prompt\" autocomplete=\"off\" value=\"\" style=\"height:30px\">\n                                <input placeholder=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"searchText") || (depth0 != null ? lookupProperty(depth0,"searchText") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"searchText","hash":{},"data":data,"loc":{"start":{"line":30,"column":52},"end":{"line":30,"column":66}}}) : helper)))
    + "\" id=\"pdm-secure-search-input\" type=\"text\" tabindex=\"0\" class=\"prompt\" autocomplete=\"off\" value=\"\" style=\"height:30px\">\n                            </div>\n                        </div>\n                    </div>\n                </div>\n                <div class=\"points-section\">\n                    <div class=\"points-table-wrapper\">\n                    </div>\n                    <div class=\"secure-points-table-wrapper\">\n                    </div>\n                    <div class=\"pagination-wrapper\">\n\n                    </div>\n                </div>\n            </div>\n            <div class=\"operation-progress\">\n                <div class=\"progress-wrapper\">\n                    <svg class=\"progress-circle indefinite\" width=\"100\" height=\"100\">\n                        <g transform=\"rotate(-90,50,50)\">\n                            <circle class=\"bg\" r=\"40\" cx=\"50\" cy=\"50\" fill=\"none\"></circle>\n                            <circle class=\"progress\" r=\"40\" cx=\"50\" cy=\"50\" fill=\"none\"></circle>\n                        </g>\n                    </svg>\n                </div>\n                <div class=\"welcome-message\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"welcomeMessage") || (depth0 != null ? lookupProperty(depth0,"welcomeMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"welcomeMessage","hash":{},"data":data,"loc":{"start":{"line":54,"column":45},"end":{"line":54,"column":63}}}) : helper)))
    + "</div>\n                <div class=\"progress-message-label\">\n                    "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"progressMessage") || (depth0 != null ? lookupProperty(depth0,"progressMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"progressMessage","hash":{},"data":data,"loc":{"start":{"line":56,"column":20},"end":{"line":56,"column":39}}}) : helper)))
    + "\n                </div>\n            </div>\n            <div class=\"error-message\">\n            </div>\n        </div>\n    </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/reviewPointsViewTemplate', t);
return t;
});
/* END_TEMPLATE */
;
/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225 on 7/19/2019
 *
 */

define('nmodule/easyDatabaseManager/rc/js/reviewPointsView',['baja!',
        'bajaux/Widget',
        'bajaux/mixin/subscriberMixIn',
        'jquery',
        'underscore',
        'Promise',
        'dialogs',
        'nmodule/js/rc/csrf/csrfUtil',
        'nmodule/easyDatabaseManager/rc/js/datatable',
        'nmodule/easyDatabaseManager/rc/js/defaultView',
        'hbs!nmodule/easyDatabaseManager/rc/hbs/reviewPointsViewTemplate',
        'lex!easyDatabaseManager',
        'css!nmodule/easyDatabaseManager/rc/css/styles'],
    function (baja,
              Widget,
              subscriberMixIn,
              $,
              _,
              promise,
              dialogs,
              csrfUtil,
              datatable,
              defaultView,
              template,
              lexicons) {

        

        //lexicons
        var lex = lexicons[0];

        var columns = [], pointsSize = 0,securePointsSize = 0, dom, pointsData,securePointsData, labelSearchCriteriaList = [],
            selectedPointsData = new Array(),selectedSecurePoint = null,
            pointsDataTable,securePointsDataTable,
            userTypingTimeout,
            MIN_PROGRESS = 0,
            MAX_PROGRESS = 100,
            selectedCheckBoxCount=0,
            PROGRESS_BAR_SUCCESS_CSS_CLASS = 'wizard-progress-bar-success',
            PROGRESS_BAR_FAIL_CSS_CLASS = 'wizard-progress-bar-fail',
            PROGRESS_BAR_RUNNING_CSS_CLASS = 'wizard-progress-bar-running';

        // reviewPointsView step
        // arguments: dom, vname, id, message, summaryMessage, backBttnMsg, nextBttnMsg, cancelBttnMsg
        var reviewPointsView = function () {
            defaultView.apply(this, arguments);

            //update which buttons will be available
            this.buttonstatus = {
                disabledBack : false,
                disabledNext : false };
        };
        reviewPointsView.prototype = Object.create(defaultView.prototype,
            { 'constructor': reviewPointsView }
            );

        //these variables will be updated in loadView with values passed from PointDatabaseManagerWidget
        reviewPointsView.component = null;
        reviewPointsView.service = null;
        reviewPointsView.subscriber = null;
        // call this function anytime you want to update nav action button status to enable/disable them
        reviewPointsView.updateActionButtonsStatus = null;

        /**
         * Load view of current wizard step - reviewPointsView
         * @param element: dom element the view will be appended to.
         * @param params: javascript object with widget parameters required to load the view within the widget
         */
        reviewPointsView.prototype.loadView = function(element, params) {
            pointsSize = 0;
            selectedCheckBoxCount=0;
            reviewPointsView.component = params.component;
            reviewPointsView.service = params.service;
            reviewPointsView.subscriber = params.subscriber;
            reviewPointsView.updateActionButtonsStatus = params.updateActionButtonsStatus;
            labelSearchCriteriaList = params.pdmData.unwantedPointsViewData.labelSearchCriteriaList;

            selectedPointsData = new Array();
            selectedSecurePoint = null;
            columns = [{
                name:lex.get("pdm.PointDatabaseManager.deletePointsView.column.name.label"),
                field:"name"
            }, {
                name:lex.get("pdm.PointDatabaseManager.deletePointsView.column.path.label"),
                field:"path"
            }
            ];

            dom = element;
            $(element).append(template({
                vid: this.params.vid,
                summaryMessage: this.params.summaryMessage,
                stepCount: this.params.stepCount,
                stepDescription: this.params.stepDescription,
                searchText:lex.get("pdm.PointDatabaseManager.reviewPointsView.searchMsg"),
                pointsSize: pointsSize,
                totalCountLabel: lex.get("pdm.PointDatabaseManager.deletePointsView.display.delete.points"),
                    selectedCheckboxCountText1: lex.get("pdm.PointDatabaseManager.stepFour.selectedCheckBoxCount.text1"),
                    selectedCheckboxCountText2: lex.get("pdm.PointDatabaseManager.stepFour.selectedCheckBoxCount.text2"),
                    pointsWithoutEsignature: lex.get("pdm.PointDatabaseManager.stepFour.pointsWithoutEsignature"),
                    pointsWithEsignature: lex.get("pdm.PointDatabaseManager.stepFour.pointsWithEsignature"),
                selectedCheckboxCount: selectedCheckBoxCount}
                ));
            $(element).find(".PDM-contents-step-summary").css("border-top-color",params.colorCode);
            this.attachButtonEvents();
            reviewPointsView.prototype.attachButtonEvents();
            displayPoints();
            changeNextButtonState();
        };

        reviewPointsView.prototype.attachButtonEvents = function(){
            $("#button-tab-unsecured-points").ready(function(event){
                $(".secure-points-table-wrapper").hide();
                $("#button-tab-unsecured-points").addClass("active");
                $("#button-tab-secured-points").removeClass("active");
                $(".points-table-wrapper .clear-selected-secure-point").remove();
                $(".points-table-wrapper").show();
                $(".points-meta-data").show();
                $("#pdm-secure-search-input").hide();
                updatePointsMetaData();
                event.preventDefault();
            });
            $("#button-tab-secured-points").on('click',
                function(event){
                    //hide the secured points tab and add active class to the button
                    $(".points-table-wrapper").hide();
                    $("#button-tab-secured-points").addClass("active");
                    $("#button-tab-unsecured-points").removeClass("active");
                    $(".secure-points-table-wrapper").show();
                    $(".secure-points-table-wrapper").find("tbody .ui-selection-column").hide();
                    $(".secure-points-table-wrapper").find("thead .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.checkbox-header").hide();
                    $(".secure-points-table-wrapper thead .ui-selection-column .ui-column-title").remove();
                    $("#pdm-search-input").hide();
                    $("#pdm-secure-search-input").show();
                    updatePointsMetaData();
                    event.preventDefault();
                });
            $("#button-tab-unsecured-points").on('click',
                function(event){
                    $(".secure-points-table-wrapper").hide();
                    $("#button-tab-unsecured-points").addClass("active");
                    $("#button-tab-secured-points").removeClass("active");
                    $(".points-table-wrapper").show();
                    $(".points-meta-data").show();
                    $(".points-table-wrapper").find(".secured-selection-column").hide();
                    $("#pdm-search-input").show();
                    $("#pdm-secure-search-input").hide();
                    updatePointsMetaData();
                    event.preventDefault();
                });
            attachRadioButtonEvent();

    };
        function attachRadioButtonEvent(){
            $(dom).find(".clear-selected-secure-point").on('click',
                function(event) {
                    $(".secure-points-table-wrapper").find("input[id='"+selectedSecurePoint+"']").prop('checked',false);
                    $(dom).find(".clear-selected-secure-point").prop('disabled',true);
                    $(dom).find(".clear-selected-secure-point").addClass("button-inactive");
                    selectedSecurePoint = null;
                    changeNextButtonState();
                });
            $(".secure-points-table-wrapper input[name='radioSecuredPoints']").click(function() {
                if ($(this).is(':checked')) {
                    selectedSecurePoint = this.getAttribute("id");
                    $(dom).find(".clear-selected-secure-point").prop('disabled',false);
                    $(dom).find(".clear-selected-secure-point").removeClass("button-inactive");
                    changeNextButtonState();
                }});
        };

        reviewPointsView.prototype.showLoadedView = function () {
            // If we come back
        };
        /**
         * validate user input before proceeding to next screen.
         * This is called before view.prototype.next is called.
         *
         * @returns {boolean}: return true/false based on validity of user input
         */
        reviewPointsView.prototype.validate = function() {
            baja.outln("inside: reviewPointsView.prototype.validate ...");
            return new promise(function(resolve) {
                //do any validations needed here.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * clean up and save before going to next view
         *
         */
        reviewPointsView.prototype.next = function() {
            baja.outln("inside: reviewPointsView.prototype.next ...");

            reviewPointsView.updateActionButtonsStatus(
                $(dom).parent(),
                {
                    disabledBack: false,
                    disabledNext: true
                }
            );

            return new promise(function(resolve) {
                // do any backend communication needed here before moving to next screen.
                //resolve once all the input is validated and good to move to next screen

                if(changeNextButtonState()) {
                    updateSelectedPoints(resolve);
                }
            });
        };

        /**
         * clean up and save before going to previous view
         *
         */
        reviewPointsView.prototype.back = function() {
            var that = this;
            baja.outln("inside: reviewPointsView.prototype.back ...");
            return new promise(function(resolve) {
                // do any cleanup/backend communication needed here before moving to previous screen.
                //resolve once all the input is validated and good to move to next screen.
                that.data = {
                    unwantedPointsViewData: {
                        labelSearchCriteriaList: []
                    }
                };
                resolve(true);
            });
        };

        /**
         * cancel operation - cancel button supported cancellable operation in current view
         * This is invoked only if this.params.isCancelAvailable is set to true.
         */
        reviewPointsView.prototype.cancel = function() {
            /*
             * if cancel button is available, the action should be implemented here.
            */
        };

        //these are prototype functions and needs to be overriden in extended screens.
        reviewPointsView.prototype.updateView = function() {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        function displayPoints() {
            var criteria = [],
                isTextboxesEmpty = false;

            // read xml file
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'findAllItems',
                args: [{
                    nodeOrd: "station:|" + reviewPointsView.component.getSlotPath().toString(),
                    labels: labelSearchCriteriaList
                }]
            }).then(function (ord) {
                var job = baja.Ord.make("station:|" + ord).get({lease: true});
                return job;
            }).then(completeJob)
                .then(function () {
                        updateData();
                        makeDataSearchable();
                    },
                    function () {
                        //notify user.
                        //notifyUser('failed station backup.')
                    }
                );

        }


        function completeJob(job) {
            return new Promise(function (resolve, reject) {
                function checkIfJobIsComplete() {
                    switch (job.get('jobState').getTag()) {
                        case 'success':
                            updateProgressBar(MAX_PROGRESS, true);
                            $(dom).parent(),
                                {
                                    disabledBack: false,
                                    disabledNext: false,
                                }
                            return resolve();
                        case 'failed' :
                            updateProgressBar(MAX_PROGRESS, false);
                            reviewPointsView.updateActionButtonsStatus(
                                $(dom).parent(),
                                {
                                    disabledBack: false,
                                    disabledNext: true,
                                }
                            );
                            return reject();
                        case 'cancelled':
                            updateProgressBar(MAX_PROGRESS, false);
                            reviewPointsView.updateActionButtonsStatus(
                                $(dom).parent(),
                                {
                                    disabledBack: false,
                                    disabledNext: true,
                                }
                            );
                            return reject();
                        case 'running':
                            updateProgressBar(job.get('progress'));
                            break;
                        default :
                            break;
                    }
                }
                var sub = new baja.Subscriber();
                sub.attach('changed', checkIfJobIsComplete);
                sub.subscribe(job).then(checkIfJobIsComplete);
            });
        }

        function getSelectedData(elem) {
            if($(elem).hasClass("checkbox-header")) {
                //header selected/unselected
                var tmpCount = 0;
                if($(elem).hasClass("ui-state-active")) {
                    $.each($(dom).find(".points-table-wrapper .ui-datatable tbody .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default.ui-state-active"),
                        function(index, element) {
                            if($(element).attr('data-handle') !== undefined){
                                tmpCount++;
                                selectedPointsData.push($(element).attr('data-handle'));}}
                    );
                    selectedCheckBoxCount = tmpCount === pointsSize ? tmpCount : tmpCount + selectedCheckBoxCount;

                } else {
                    var addRows = new Array(), removeRows = new Array();
                    $.each($(dom).find(".points-table-wrapper .ui-datatable tbody .ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default"),
                        function(index, element) {
                            if($(element).attr('data-handle') !== undefined) {
                                tmpCount++;
                                if ($(element).hasClass("ui-state-active")) {
                                    addRows.push($(element).attr('data-handle'));
                                } else if (!$(element).hasClass("ui-state-active")) {
                                    removeRows.push($(element).attr('data-handle'));
                                }
                            }
                        }
                    );
                    if( tmpCount === pointsSize ) {
                        selectedCheckBoxCount = 0;
                    }else {
                        if (selectedCheckBoxCount > tmpCount) {
                            selectedCheckBoxCount = selectedCheckBoxCount - tmpCount;
                        } else {
                            selectedCheckBoxCount = tmpCount - selectedCheckBoxCount;
                        }
                    }
                    selectedPointsData =  _.union(selectedPointsData, addRows);
                    selectedPointsData = _.difference(selectedPointsData, removeRows);
                }
            } else {
                if($(elem).hasClass("ui-state-active")) {
                    selectedCheckBoxCount++;
                    selectedPointsData.push($(elem).attr('data-handle'));
                } else {
                    selectedCheckBoxCount--;
                    var handle = $(elem).attr('data-handle');
                    selectedPointsData = selectedPointsData.filter(function (value) {
                        return value !== handle;
                    });
                }
            }
            $(dom).find('#selected-checkbox-count').text(selectedCheckBoxCount);
            pointsDataTable.updateOptions({updateselectedData: selectedPointsData})
            changeNextButtonState();
        }

        function updatePointsMetaData()
        {
            if($(dom).find("#button-tab-unsecured-points").hasClass("active")){
                $(dom).find(".points-meta-data").show();
            }
            else{
                $(dom).find(".points-meta-data").hide();
            }
        }

        function searchUserInput() {
            //clear timeout when you decide to search
            userTypingTimeout = null;

            var tableWrapper,searchInput;
            if($(dom).find("#button-tab-unsecured-points").hasClass("active")){
                searchInput  = $(dom).find("#pdm-search-input").val().trim();
                tableWrapper = $(dom).find(".points-table-wrapper");
                if(searchInput && searchInput.length > 0) {
                    var regex = RegExp(searchInput, 'i');
                    var tempData = {};
                    tempData["columns"] = pointsData.columns.slice();
                    tempData["rows"] = pointsData.rows.slice();
                    tempData.rows = tempData.rows.filter(function (point) {
                        return regex.test(point["name"]);
                    });
                    pointsDataTable = datatable({
                        parent: tableWrapper[0],
                        tableData: tempData,
                        rowSelectionCallback: getSelectedData,
                        updateselectedData: selectedPointsData,
                        noDataMesage:lex.get("pdm.PointDatabaseManager.deletePointsView.nopoints.message")
                    });
                } else {
                    pointsDataTable = datatable({
                        parent: tableWrapper[0],
                        tableData: pointsData,
                        rowSelectionCallback: getSelectedData,
                        updateselectedData: selectedPointsData,
                        noDataMesage:lex.get("pdm.PointDatabaseManager.deletePointsView.nopoints.message")
                    });
                }
            }
            else{
                searchInput  = $(dom).find("#pdm-secure-search-input").val().trim();
                tableWrapper = $(dom).find(".secure-points-table-wrapper");
                if(searchInput && searchInput.length > 0) {
                    var regex = RegExp(searchInput, 'i');
                    var tempData = {};
                    tempData["columns"] = securePointsData.columns.slice();
                    tempData["rows"] = securePointsData.rows.slice();
                    tempData.rows = tempData.rows.filter(function (point) {
                        return regex.test(point["name"]);
                    });
                    securePointsDataTable = datatable({
                        parent: tableWrapper[0],
                        tableData: tempData,
                        rowSelectionCallback: attachRadioButtonEvent,
                        updateselectedData: selectedSecurePoint,
                        noDataMesage:lex.get("pdm.PointDatabaseManager.deletePointsView.nopoints.message")
                    });
                } else {
                    securePointsDataTable = datatable({
                        parent: tableWrapper[0],
                        tableData: securePointsData,
                        rowSelectionCallback: attachRadioButtonEvent,
                        updateselectedData: selectedSecurePoint,
                        noDataMesage:lex.get("pdm.PointDatabaseManager.deletePointsView.nopoints.message")
                    });
                }
            }
            attachRadioButtonEvent();
            updatePointsMetaData();
        }

        function makeDataSearchable() {
            $(dom).find("#pdm-search-input,#pdm-secure-search-input").on("keyup", function () {
                if (userTypingTimeout != null) {
                    clearTimeout(userTypingTimeout);
                }
                userTypingTimeout = setTimeout(searchUserInput, 150);
            });
        }

        function updateData(){
            baja.Ord.make("file:^edm/edm.xml").get({lease:true})
                .then(function(response){
                    var i, point, pointList, pointData = {"columns":columns, "rows":[]};
                    var securePointData = {"columns":columns, "rows":[]};
                    $.get(response.getReadUri()).then(function(points) {
                        pointList = $(points).find('Item');
                        if(pointList !== null && pointList.length > 0) {
                            for(i=0; i< pointList.length; i++) {
                                point = pointList[i];
                                if($(point).attr("status") && $(point).attr("status") === "1") {
                                    continue;
                                }
                                if($(point).attr("secure") && $(point).attr("secure") === "1") {
                                    securePointData.rows.push({
                                    name:$(point).attr("name"),
                                    path:$(point).attr("path"),
                                    handle:$(point).attr("handle"),
                                    delete:$(point).attr("delete")
                                 });
                                }
                                else{
                                   pointData.rows.push({
                                    name:$(point).attr("name"),
                                    path:$(point).attr("path"),
                                    handle:$(point).attr("handle"),
                                    delete:$(point).attr("delete")
                                   });
                              }
                            }
                        }
                        //once points data is ready - hide progress bar and display the table
                        //$(dom).find(".operation-progress").removeClass("show-progress");
                        var tableWrapper = $(dom).find(".points-table-wrapper");
                        pointsDataTable = datatable({
                            parent: tableWrapper[0],
                            tableData: pointData,
                            rowSelectionCallback: getSelectedData,
                            updateselectedData: selectedPointsData,
                            noDataMesage:lex.get("pdm.PointDatabaseManager.deletePointsView.nopoints.message")
                        });
                        pointsData = {};
                        pointsData["columns"] = pointData.columns.slice();
                        pointsData["rows"] = pointData.rows.slice();
                        $(dom).find(".total-count").html(pointData.rows.length);
                        pointsSize = pointData.rows.length;

                        var secureTableWrapper = $(dom).find(".secure-points-table-wrapper");
                        securePointsDataTable = datatable({
                            parent: secureTableWrapper[0],
                            tableData: securePointData,
                            rowSelectionCallback: attachRadioButtonEvent,
                            updateselectedData: selectedSecurePoint,
                            noDataMesage:lex.get("pdm.PointDatabaseManager.deletePointsView.nopoints.message")
                        });
                        securePointsData = {};
                        securePointsData["columns"] = securePointData.columns.slice();
                        securePointsData["rows"] = securePointData.rows.slice();

                        securePointsSize = securePointData.rows.length;
                        if(securePointsSize <= 0){
                            $(dom).find(".tabs").hide()
                            $(dom).find("#button-tab-secured-points").hide()}
                        else {
                            $(dom).find("#button-tab-secured-points").show()}
                        updatePointsMetaData();
                        reviewPointsView.prototype.attachButtonEvents();
                    });
                });
        }

        function changeNextButtonState() {
            //if at least one point is selected show action slider
            var step4 = ("#PDM-contents-step4-details");
            if((selectedPointsData && selectedPointsData.length > 0) || ($(step4).find("tr > td .ui-state-active").length > 0) || selectedSecurePoint !== null) {
                reviewPointsView.updateActionButtonsStatus(
                    $(dom).parent(),
                    {
                        disabledBack: false,
                        disabledNext: false
                    }
                );
                return true;
            } else {
                reviewPointsView.updateActionButtonsStatus(
                    $(dom).parent(),
                    {
                        disabledBack: false,
                        disabledNext: true
                    }
                );
                return false;
            }
        }

        function updateProgressBar (progress, success) {

            var bar;

            if (!dom) {
                return; // If an event comes in when we aren't ready for it, ignore it.
            }

            bar = dom.find('#wizard-progress-bar');

            if (progress > MIN_PROGRESS && progress < MAX_PROGRESS) {
                bar.animate({ width: progress + '%' });
            }
            else {
                bar.width(progress + '%'); // Don't animate when setting it back to zero, as it looks weird.
            }

            if (success !== undefined) {
                if (success) {
                    bar.removeClass(PROGRESS_BAR_RUNNING_CSS_CLASS + ' ' + PROGRESS_BAR_FAIL_CSS_CLASS)
                       .addClass(PROGRESS_BAR_SUCCESS_CSS_CLASS);
                }
                else {
                    bar.removeClass(PROGRESS_BAR_RUNNING_CSS_CLASS + ' ' + PROGRESS_BAR_SUCCESS_CSS_CLASS)
                       .addClass(PROGRESS_BAR_FAIL_CSS_CLASS);
                }
            }
            else {
                bar.removeClass(PROGRESS_BAR_FAIL_CSS_CLASS + ' ' + PROGRESS_BAR_SUCCESS_CSS_CLASS)
                   .addClass(PROGRESS_BAR_RUNNING_CSS_CLASS);
            }
        }

        function updateSelectedPoints(resolve) {
            baja.Ord.make("file:^edm/edm.xml").get({lease:true,
                ok: function(response) {
                    var i, z, point, pointList, networkList, xmlDoc = $.parseXML("<Items/>");
                    var xmlElements = xmlDoc.getElementsByTagName("Items")[0];

                    $.get(response.getReadUri(), function(points) {
                        networkList = $(points).find('Network');

                        if (networkList !== null && networkList.length > 0) {
                            for (z = 0; z < networkList.length; z++) {
                                pointList = $(networkList[z]).find('Item');
                                if (pointList !== null && pointList.length > 0) {
                                    for (i = 0; i < pointList.length; i++) {
                                        point = pointList[i];
                                        if($(point).attr("secure") && $(point).attr("secure") === "1") {
                                            if(selectedSecurePoint === $(point).attr('path')){
                                                $(point).attr("delete", "1");
                                            }
                                            else{
                                                $(point).attr("delete", "0");
                                            }
                                        }else {
                                            $(point).attr("delete", isSelectedPoint($(point).attr("handle"), selectedPointsData));
                                        }
                                        networkList[z].appendChild(point);
                                    }
                                }
                                xmlElements.appendChild(networkList[z]);
                            }
                            baja.Ord.make("file:^edm/edm.xml").get({
                                ok: function (res) {
                                    $.ajax({
                                        url: res.getWriteUri(),
                                        type: 'PUT',
                                        data: xmlElements.outerHTML,
                                        headers: {
                                            "x-niagara-csrfToken": csrfUtil.getCsrfToken()
                                        },
                                        success: function () {
                                            resolve(true);
                                        }
                                    });
                                }
                            });
                        }
                    });
                },
                fail: function(response) {
                // Failed
                }
            });
        }

        function isSelectedPoint(pointHandle, selectedPoints) {
            if(selectedPoints !== null && selectedPoints.length > 0 && pointHandle !== null) {
                var output = selectedPoints.includes(pointHandle);
                return output ? "1" : "0";
            }
            return "0";
        }

        return reviewPointsView;
    });

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/fe/template/SecuredDeleteComponentTemplate',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var stack1, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div>\n    <div class=\"row\">\n        <label class=\"col-sm-3\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"selectedPoint") : stack1), depth0))
    + "</label>\n    </div>\n    <div class=\"row\">\n        <label class=\"col-sm-3\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"pointName") : stack1), depth0))
    + "</label>\n    </div>\n    <div class=\"row\">\n        <label class=\"col-sm-3\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"pointOrd") : stack1), depth0))
    + "</label>\n    </div>\n    <div id=\"easSignatureTabs\">\n        <ul class=\"nav nav-tabs\">\n            <li class=\"active\">\n                <a class=\"primaryTab\" href=\"#easPrimarySignature\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"authLevel1") : stack1), depth0))
    + "</a>\n            </li>\n            <li>\n                <a class=\"secondaryTab\" href=\"#easSecondarySignature\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"authLevel2") : stack1), depth0))
    + "</a>\n            </li>\n        </ul>\n        <br>\n    </div>\n    <div class=\"tab-content\">\n        <div id=\"easPrimarySignature\" class=\"tab-pane fade in active\">\n            <div class=\"primarySignatureProperty\">\n                <div class=\"row\">\n                    <label class=\"col-sm-3\"> "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"userName") : stack1), depth0))
    + "</label>\n                    <input type=\"text\" class=\"fixControlWidth\" name=\"username\" id=\"username\" disabled/>\n                </div>\n                <div class=\"row\">\n                    <label class=\"col-sm-3\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"password") : stack1), depth0))
    + "</label>\n                    <input type=\"password\" class=\"fixControlWidth\" name=\"password\" id=\"password\"/>\n                </div>\n                <div class=\"row\">\n                    <label class=\"col-sm-3\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"comment") : stack1), depth0))
    + "</label>\n                    <textarea id=\"primaryComment\" rows=\"2\" cols=\"20\" class=\"fixControlWidth\"></textarea>\n                </div>\n                <br>\n                <button type=\"button\" id=\"btnPrimarySign\" >"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"sign") : stack1), depth0))
    + "</button>\n            </div>\n        </div>\n\n        <div id=\"easSecondarySignature\" class=\"tab-pane fade\">\n            <div class=\"secondarySignatureProperty\">\n                <div class=\"row\"><label class=\"col-sm-3\"> "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"userName") : stack1), depth0))
    + "</label>\n                    <select class=\"fixControlWidth\" id=\"secondaryUsername\"></select>\n                </div>\n                <div class=\"row\"><label class=\"col-sm-3\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"password") : stack1), depth0))
    + "</label>\n                    <input type=\"password\" class=\"fixControlWidth\" name=\"password1\" id=\"secondaryPassword\"/>\n                </div>\n                <div class=\"row\">\n                    <label class=\"col-sm-3\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"comment") : stack1), depth0))
    + "</label>\n                    <textarea id=\"secondaryComments\" rows=\"2\" class=\"fixControlWidth\" cols=\"20\"></textarea>\n                </div>\n                <div class=\"btn-toolbar\"><br>\n                    <button type=\"button\" class=\"btnSecondarySign\" id=\"btn btn-secondary btn-sm\">"
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"sign2") : stack1), depth0))
    + "</button>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n<br/>\n<div>\n    <p id=\"legaltext\"  style=\"border:1px; border-style:solid;padding:6px;\">\n         <b> "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"acknowledgement") : stack1), depth0))
    + "</b><br/>\n         "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"label1") : stack1), depth0))
    + " [userAccountName]  "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"label2") : stack1), depth0))
    + " <br/>\n         "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"label3") : stack1), depth0))
    + " [customerName] "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"label4") : stack1), depth0))
    + " <br/>\n         "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"label5") : stack1), depth0))
    + " <br/>\n         "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"label6") : stack1), depth0))
    + " <br/>\n         "
    + container.escapeExpression(container.lambda(((stack1 = (depth0 != null ? lookupProperty(depth0,"jsonObject") : depth0)) != null ? lookupProperty(stack1,"label7") : stack1), depth0))
    + "\n    </p>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/fe/template/SecuredDeleteComponentTemplate', t);
return t;
});
/* END_TEMPLATE */
;
/**
 * @copyright 2017 Tridium, Inc. All Rights Reserved.
 * @author Swapnil Dhamal
 */

define('nmodule/easyDatabaseManager/rc/fe/baja/SecuredDeleteCommand',['baja!',
        'baja!electronicSignature:SecuredNumericWritable,electronicSignature:SecuredBooleanWritable,electronicSignature:SecuredEnumWritable,' +
        'electronicSignature:SecuredStringWritable,electronicSignature:SecuredNumericPoint,electronicSignature:SecuredBooleanPoint,' +
        'electronicSignature:SecuredEnumPoint,electronicSignature:SecuredStringPoint',
        'lex!webEditors',
        'jquery',
        'dialogs',
        'lex!electronicSignature',
        'Promise',
        'underscore',
        'nmodule/webEditors/rc/wb/commands/ComponentEditorCommand',
        'nmodule/electronicSignature/rc/fe/baja/loader',
        'nmodule/electronicSignature/rc/fe/baja/Util',
        'hbs!nmodule/easyDatabaseManager/rc/fe/template/SecuredDeleteComponentTemplate',
        'css!nmodule/electronicSignature/rc/css/widgets'], function (
         baja,
         types,
         lexs,
         $,
         dialogs,
         electronicSignatureLex,
         promise,
         _,
         ComponentEditorCommand,
         loader,
         Util,
         template) {

  
  var webEditorsLex = lexs[0];
    var lex = electronicSignatureLex[0];
 /* var webEditorsLex = lexs[0],
  _SecondaryAuthenticatorRoles="",
  isValidUserSecondary=false;*/

////////////////////////////////////////////////////////////////
// Support functions
////////////////////////////////////////////////////////////////

  /**
   * Remove all the given slots from the component, batching into one network
   * call.
   *
   * @inner
   * @param {baja.Component} comp
   * @param {Array.<baja.Slot|String>} slots
   * @returns {Promise}
   */
    function removeAll(comp, slots) {
    var batch = new baja.comm.Batch(),
        removes = _.map(slots, function (slot) {
          return comp.remove({ slot: slot, batch: batch });
        });

    batch.commit();
    return Promise.all(removes);
  }

  //TODO: optional confirmation dialog
  //TODO: found bug: add slot, rename, and delete all without refreshing multisheet. wrong slot goes away

  /**
   * A command for deleting slots from an editor's `Component` value.
   *
   * @private
   * @class
   * @extends module:nmodule/webEditors/rc/wb/commands/ComponentEditorCommand
   * @alias module:nmodule/webEditors/rc/wb/commands/DeleteCommand
   * @param {module:bajaux/Widget} ed the `Widget` to bind this `Command` to
   * @param {baja.Component} the component from which to delete slots
   * @throws {Error} if no `Widget` provided
   */
  var SecuredDeleteCommand = function (ed, component) {
    ComponentEditorCommand.call(this, {
      module: 'webEditors',
      lex: 'commands.delete'
    }, ed, component);
  };

  SecuredDeleteCommand.prototype = Object.create(ComponentEditorCommand.prototype);
  SecuredDeleteCommand.prototype.constructor = SecuredDeleteCommand;
  SecuredDeleteCommand.isAuthenticatedUser = false;

  /**
   * Make sure we have admin write permissions and we're not deleting a frozen
   * slot.
   *
   * @param {baja.Component} comp
   * @param {baja.Slot} slot
   * @returns {Boolean} true if I can delete this slot
   */
  SecuredDeleteCommand.prototype.canPerformCommand = function (comp, slot, resolve) {
      return comp.getPermissions().hasAdminWrite() && !slot.isFrozen();
  };

  /**
   * Deletes the selected slots from the editor's loaded Component.
   *
   * @param {baja.Component} comp
   * @param {Array.<baja.Slot>} slots the slots to delete
   * @returns {Promise}
   */
  SecuredDeleteCommand.prototype.performCommand = function (comp, slots, params,resolve) {
    var slot=slots[0];
    if (!slot) {
      return Promise.reject(lex.get('delete.slot.required'));
    }
    if(slot.getType().is(baja.$("electronicSignature:SecuredNumericWritable").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredBooleanWritable").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredEnumWritable").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredStringWritable").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredNumericPoint").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredBooleanPoint").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredEnumPoint").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredStringPoint").getType())){
     slots[0].$val.getActionParameterDefault(slots[0].$val.getSlot("call")).then(function(actionPoint){
         var primarySignLabel = lex.get('fe.sign1.button');
         if(actionPoint.getSecureSlotFacets().$map.$map.isSecuredPrimary==true)
         {
             primarySignLabel = lex.get('fe.sign.button');
         }
         var jsonObject={
             pointName:slot.$displayName,
             pointOrd:params,
             authLevel1:lex.get('fe.authorization.level1.label'),
             authLevel2:lex.get('fe.authorization.level2.label'),
             userName:lex.get('fe.userName.label'),
             password:lex.get('fe.password.label'),
             comment:lex.get('fe.comment.label'),
             sign:primarySignLabel,
             sign2:lex.get('fe.sign2.button'),
             acknowledgement:lex.get('eSignature.ack.label'),
             label1:lex.get('eSignature.ack.label1'),
             label2:lex.get('eSignature.ack.label2'),
             label3:lex.get('eSignature.ack.label3'),
             label4:lex.get('eSignature.ack.label4'),
             label5:lex.get('eSignature.ack.label5'),
             label6:lex.get('eSignature.ack.label6'),
             label7:lex.get('eSignature.ack.label7')
         };
         dialogs.showOkCancel({title:lex.get('authenticate.user.title'),content:template({jsonObject:jsonObject})})
             .cancel(function(val){
                 resolve("cancel");
              })
             .ok(function(val){
                resolve("ok");
                return removeAll(comp, slots).then(function(){
                var dashboardHandle=actionPoint.getSecureSlotFacets().$map.$map.dashboardHandle;
                getDashBoardComponent(dashboardHandle).then(function(dashBoardComponent){
                var primaryComments=val.jq().find("#primaryComment").val();
                actionPoint.setActionName("delete");
                if(actionPoint.getSecureSlotFacets().$map.$map.isSecuredPrimary==true)
                {
                     actionPoint.setPrimaryComments(primaryComments);

                }else
                {
                      var secondaryComments=val.jq().find("#secondaryComments").val();
                      var managerName= val.jq().find("#secondaryUsername").val();
                      actionPoint.setPrimaryComments(primaryComments);
                      actionPoint.setSecondaryComments(secondaryComments);
                      actionPoint.setManager(managerName);

                }
                 //actionPoint.setNewValue(newName);
                 var comp= baja.$("baja:Component", {
                    actionPoint: actionPoint,
                 });
                 dashBoardComponent.invoke({slot:"updateHistory", value: comp});
                });
                });
          });
         Util.loadInitialEventsAndData(actionPoint,"delete");
     }).catch(function (err) {
        return dialogs.showOk({
           title: lex.get("error.title"),
           content:lex.get('editor.primary.user.validation')
        });
     });
    }
    else{
      return dialogs.showOkCancel({
        title: webEditorsLex.get('commands.delete.confirm.title'),
        content: webEditorsLex.get('commands.delete.confirm.content')
      })
        .ok(function () {
          return removeAll(comp, slots);
        })
        .promise();
    }
  };
  function getDashBoardComponent(handle) {
    var ord="station:|h:"+handle;
    return baja.Ord.make(ord).get({lease: true});
  }

  return SecuredDeleteCommand;
});

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/deletePointsViewTemplate',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div id=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"vid") || (depth0 != null ? lookupProperty(depth0,"vid") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"vid","hash":{},"data":data,"loc":{"start":{"line":1,"column":9},"end":{"line":1,"column":16}}}) : helper)))
    + "\">\n    <div class=\"PDM-step-details\">\n        <div class=\"PDM-contents-step-summary\">\n            <span class=\"PDM-step-count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepCount") || (depth0 != null ? lookupProperty(depth0,"stepCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepCount","hash":{},"data":data,"loc":{"start":{"line":4,"column":41},"end":{"line":4,"column":54}}}) : helper)))
    + "</span>\n            <span class=\"PDM-step-name\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"summaryMessage") || (depth0 != null ? lookupProperty(depth0,"summaryMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"summaryMessage","hash":{},"data":data,"loc":{"start":{"line":5,"column":40},"end":{"line":5,"column":58}}}) : helper)))
    + "</span>\n        </div>\n        <div class=\"PDM-step-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepDescription") || (depth0 != null ? lookupProperty(depth0,"stepDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepDescription","hash":{},"data":data,"loc":{"start":{"line":7,"column":42},"end":{"line":7,"column":61}}}) : helper)))
    + "</div>\n    </div>\n    <div class=\"PDM-contents-step-details\">\n        <div id=\"PDM-step5-stationbackup-logs-checkbox-container\" class=\"deletePointsViewWidget PDM-step2-rectangle\">\n            <table class=\"ui-datatable\">\n                <thead class=\"ui-datatable-thead\">\n                <tr>\n                    <th>\n                    </th>\n                    <th>\n                    </th>\n                </tr>\n                </thead>\n                <tbody class=\"ui-datatable-data ui-widget-content\">\n                <tr class=\"ui-widget-content\">\n                    <td>\n                        <span class=\"ui-cell-data\">\n                            <div class=\"cell-data-wrap\"><span class=\"PDM-step-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stationBackupConfirmationMessage") || (depth0 != null ? lookupProperty(depth0,"stationBackupConfirmationMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stationBackupConfirmationMessage","hash":{},"data":data,"loc":{"start":{"line":24,"column":91},"end":{"line":24,"column":127}}}) : helper)))
    + "</span></div>\n                        </span>\n                    </td>\n                    <td class=\"ui-selection-column ui-selection-column-criteria\">\n                        <span class=\"ui-cell-data\">\n                            <div class=\"ui-chkbox ui-widget\">\n                                <div class=\"ui-helper-hidden-accessible\"><input type=\"checkbox\"></div>\n                                <div id=\"stationBackup\" class=\"ui-chkbox-box ui-widget ui-corner-all ui-state-default ui-state-active\">\n                                    <span class=\"ui-chkbox-icon ui-clickable pi pi-check\">\n                                    </span>\n                                </div>\n                            </div>\n                        </span>\n                    </td>\n                </tr>\n                <tr class=\"ui-widget-content\">\n                    <td>\n                        <span class=\"ui-cell-data\">\n                            <div class=\"cell-data-wrap\"><span class=\"PDM-step-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"selectedDeletedRecordsLogConfirmationMessage") || (depth0 != null ? lookupProperty(depth0,"selectedDeletedRecordsLogConfirmationMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"selectedDeletedRecordsLogConfirmationMessage","hash":{},"data":data,"loc":{"start":{"line":42,"column":91},"end":{"line":42,"column":139}}}) : helper)))
    + "</span></div>\n                        </span>\n                    </td>\n                    <td class=\"ui-selection-column ui-selection-column-criteria\">\n                        <span class=\"ui-cell-data\">\n                            <div class=\"ui-chkbox ui-widget\">\n                                <div class=\"ui-helper-hidden-accessible\"><input type=\"checkbox\"></div>\n                                <div id=\"selectedDeletedRecordsLog\" class=\"ui-chkbox-box ui-widget ui-corner-all ui-state-default ui-state-active\">\n                                    <span class=\"ui-chkbox-icon ui-clickable pi pi-check\">\n                                    </span>\n                                </div>\n                            </div>\n                        </span>\n                    </td>\n                </tr>\n                </tbody>\n            </table>\n        </div>\n        <div class=\"PDM-contents-deletion-summary-container\">\n        </div>\n        <div class=\"operation-progress\">\n            <div class=\"progress-wrapper\">\n                <svg class=\"progress-circle indefinite\" width=\"100\" height=\"100\">\n                    <g transform=\"rotate(-90,50,50)\">\n                        <circle class=\"bg\" r=\"40\" cx=\"50\" cy=\"50\" fill=\"none\"></circle>\n                        <circle class=\"progress\" r=\"40\" cx=\"50\" cy=\"50\" fill=\"none\"></circle>\n                    </g>\n                </svg>\n            </div>\n            <div class=\"progress-message-label\">\n                "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"progressMessage") || (depth0 != null ? lookupProperty(depth0,"progressMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"progressMessage","hash":{},"data":data,"loc":{"start":{"line":72,"column":16},"end":{"line":72,"column":35}}}) : helper)))
    + "\n            </div>\n        </div>\n        <div class=\"error-message\"></div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/deletePointsViewTemplate', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/deletePointsSummary',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"PDM-contents-points-deletion-summary-table\">\n    <div class=\"Table\">\n        <div class=\"Heading\">\n            <div class=\"Cell\">\n                <P>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"networkName") || (depth0 != null ? lookupProperty(depth0,"networkName") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"networkName","hash":{},"data":data,"loc":{"start":{"line":5,"column":19},"end":{"line":5,"column":34}}}) : helper)))
    + "</P>\n\n            </div>\n        </div>\n        <div class=\"Row:1\">\n             <div class=\"Cell\">\n                <span class=\"PDM-step-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"deleteText") || (depth0 != null ? lookupProperty(depth0,"deleteText") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"deleteText","hash":{},"data":data,"loc":{"start":{"line":11,"column":51},"end":{"line":11,"column":65}}}) : helper)))
    + "</span>\n             </div>\n        </div>\n        <div class=\"Row:2\">\n            <div class=\"Cell\">\n                <span>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"deletingPoints") || (depth0 != null ? lookupProperty(depth0,"deletingPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"deletingPoints","hash":{},"data":data,"loc":{"start":{"line":16,"column":22},"end":{"line":16,"column":40}}}) : helper)))
    + ": "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalPointsToDelete") || (depth0 != null ? lookupProperty(depth0,"totalPointsToDelete") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalPointsToDelete","hash":{},"data":data,"loc":{"start":{"line":16,"column":42},"end":{"line":16,"column":65}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"of") || (depth0 != null ? lookupProperty(depth0,"of") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"of","hash":{},"data":data,"loc":{"start":{"line":16,"column":66},"end":{"line":16,"column":72}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalUnusedAndUnwantedPoints") || (depth0 != null ? lookupProperty(depth0,"totalUnusedAndUnwantedPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalUnusedAndUnwantedPoints","hash":{},"data":data,"loc":{"start":{"line":16,"column":73},"end":{"line":16,"column":105}}}) : helper)))
    + "</span>\n                <span> <img id=\"showpointdetails\" class=\"\" src=\"/module/easyDatabaseManager/rc/images/expand.png\"> </span>\n            </div>\n        </div>\n        <span id=\"pointDetails\">\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <span>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"trendPoints") || (depth0 != null ? lookupProperty(depth0,"trendPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"trendPoints","hash":{},"data":data,"loc":{"start":{"line":23,"column":26},"end":{"line":23,"column":41}}}) : helper)))
    + ": "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalTrendPointsToDelete") || (depth0 != null ? lookupProperty(depth0,"totalTrendPointsToDelete") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalTrendPointsToDelete","hash":{},"data":data,"loc":{"start":{"line":23,"column":43},"end":{"line":23,"column":71}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"of") || (depth0 != null ? lookupProperty(depth0,"of") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"of","hash":{},"data":data,"loc":{"start":{"line":23,"column":72},"end":{"line":23,"column":78}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalUnusedAndUnwantedTrendPoints") || (depth0 != null ? lookupProperty(depth0,"totalUnusedAndUnwantedTrendPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalUnusedAndUnwantedTrendPoints","hash":{},"data":data,"loc":{"start":{"line":23,"column":79},"end":{"line":23,"column":116}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <span>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"niagaraPoints") || (depth0 != null ? lookupProperty(depth0,"niagaraPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"niagaraPoints","hash":{},"data":data,"loc":{"start":{"line":28,"column":26},"end":{"line":28,"column":43}}}) : helper)))
    + ": "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalNiagaraPointsToDelete") || (depth0 != null ? lookupProperty(depth0,"totalNiagaraPointsToDelete") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalNiagaraPointsToDelete","hash":{},"data":data,"loc":{"start":{"line":28,"column":45},"end":{"line":28,"column":75}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"of") || (depth0 != null ? lookupProperty(depth0,"of") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"of","hash":{},"data":data,"loc":{"start":{"line":28,"column":76},"end":{"line":28,"column":82}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalUnusedAndUnwantedNiagaraPoints") || (depth0 != null ? lookupProperty(depth0,"totalUnusedAndUnwantedNiagaraPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalUnusedAndUnwantedNiagaraPoints","hash":{},"data":data,"loc":{"start":{"line":28,"column":83},"end":{"line":28,"column":122}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n        </span>\n        <div class=\"Row selectedSecurePoint\">\n            <div class=\"Cell\">\n                <span>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"selectedSecurePoint") || (depth0 != null ? lookupProperty(depth0,"selectedSecurePoint") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"selectedSecurePoint","hash":{},"data":data,"loc":{"start":{"line":34,"column":22},"end":{"line":34,"column":45}}}) : helper)))
    + " : "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"securePointPath") || (depth0 != null ? lookupProperty(depth0,"securePointPath") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"securePointPath","hash":{},"data":data,"loc":{"start":{"line":34,"column":48},"end":{"line":34,"column":67}}}) : helper)))
    + "</span>\n            </div>\n        </div>\n        <div class=\"Row\">\n            <div class=\"Cell\">\n                <span>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"histories") || (depth0 != null ? lookupProperty(depth0,"histories") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"histories","hash":{},"data":data,"loc":{"start":{"line":39,"column":22},"end":{"line":39,"column":35}}}) : helper)))
    + ": "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalHistoriesToDelete") || (depth0 != null ? lookupProperty(depth0,"totalHistoriesToDelete") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalHistoriesToDelete","hash":{},"data":data,"loc":{"start":{"line":39,"column":37},"end":{"line":39,"column":63}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"of") || (depth0 != null ? lookupProperty(depth0,"of") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"of","hash":{},"data":data,"loc":{"start":{"line":39,"column":64},"end":{"line":39,"column":70}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalHistories") || (depth0 != null ? lookupProperty(depth0,"totalHistories") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalHistories","hash":{},"data":data,"loc":{"start":{"line":39,"column":71},"end":{"line":39,"column":89}}}) : helper)))
    + "</span>\n            </div>\n        </div>\n        <div class=\"Row\">\n            <div class=\"Cell\">\n                <span>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"schedules") || (depth0 != null ? lookupProperty(depth0,"schedules") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"schedules","hash":{},"data":data,"loc":{"start":{"line":44,"column":22},"end":{"line":44,"column":35}}}) : helper)))
    + ": "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalSchedulesToDelete") || (depth0 != null ? lookupProperty(depth0,"totalSchedulesToDelete") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalSchedulesToDelete","hash":{},"data":data,"loc":{"start":{"line":44,"column":37},"end":{"line":44,"column":63}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"of") || (depth0 != null ? lookupProperty(depth0,"of") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"of","hash":{},"data":data,"loc":{"start":{"line":44,"column":64},"end":{"line":44,"column":70}}}) : helper)))
    + " "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"totalSchedules") || (depth0 != null ? lookupProperty(depth0,"totalSchedules") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"totalSchedules","hash":{},"data":data,"loc":{"start":{"line":44,"column":71},"end":{"line":44,"column":89}}}) : helper)))
    + "</span>\n            </div>\n        </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/deletePointsSummary', t);
return t;
});
/* END_TEMPLATE */
;
/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225 on 7/19/2019
 *
 */

define('nmodule/easyDatabaseManager/rc/js/deletePointsView',['baja!',
        'jquery',
        'underscore',
        'Promise',
        'dialogs',
        'nmodule/easyDatabaseManager/rc/js/defaultView',
        'nmodule/easyDatabaseManager/rc/fe/baja/SecuredDeleteCommand',
        'lex!easyDatabaseManager',
        'hbs!nmodule/easyDatabaseManager/rc/hbs/deletePointsViewTemplate',
        'hbs!nmodule/easyDatabaseManager/rc/hbs/deletePointsSummary',
        'css!nmodule/easyDatabaseManager/rc/css/datatable',
        'css!nmodule/easyDatabaseManager/rc/css/styles'],
    function (baja,
              $,
              _,
              promise,
              dialogs,
              defaultView,
              SecuredDeleteCommand,
              lexicons,
              template,
              dpSummary) {

        
        var lex = lexicons[0];
        var dom;
        // deletePointsView step
        // arguments: dom, vname, id, message, summaryMessage, backBttnMsg, nextBttnMsg, cancelBttnMsg
        var deletePointsView = function () {
            defaultView.apply(this, arguments);

            //update which buttons will be available
            this.buttonstatus = {
                disabledBack: false,
                disabledNext: false
            };
        };
        deletePointsView.prototype = Object.create(defaultView.prototype,
            {'constructor': deletePointsView}
        );

        //these variables will be updated in loadView with values passed from PointDatabaseManagerWidget
        deletePointsView.component = null;
        deletePointsView.service = null;
        deletePointsView.subscriber = null;
        deletePointsView.isStationBackupChecked = true;
        deletePointsView.isSelectedDeletedRecordsLogChecked = true;
        //deletePointsView.isSecurePointAuthenticated = false;

        // call this function anytime you want to update nav action button status to enable/disable them
        deletePointsView.updateActionButtonsStatus = null;

        var _addEventListeners = function (element) {
            //select or unselect individual rows
            $(element).find("div.ui-chkbox-box.ui-widget.ui-corner-all.ui-state-default").on('click',
                function (event) {
                    var $target = $(event.target),
                        checkboxState,
                        targetID;
                    if ($target.hasClass("ui-chkbox-icon")) {
                        $target.parent().toggleClass("ui-state-active");
                        $target.toggleClass("pi pi-check");
                        checkboxState = false;
                        targetID = $target.parent().attr('id');
                    } else {
                        $target.toggleClass("ui-state-active");
                        $target.find(".ui-chkbox-icon.ui-clickable").toggleClass("pi pi-check");
                        checkboxState = true;
                        targetID = $target.attr('id');
                    }

                    if ("stationBackup" === targetID) {
                        deletePointsView.isStationBackupChecked = checkboxState;
                    }
                    if ("selectedDeletedRecordsLog" === targetID) {
                        deletePointsView.isSelectedDeletedRecordsLogChecked = checkboxState;
                    }
                });
            /**
             * show/hide points details on click of + event
             */
            $(element).find('#showpointdetails').on('click',
                function (event) {
                    if (this.src.includes("expand.png")) {
                        this.setAttribute("src", "/module/easyDatabaseManager/rc/images/collapse.png");
                    } else {
                        this.setAttribute("src", "/module/easyDatabaseManager/rc/images/expand.png");
                    }
                    var pointDetails = $(element).find('#pointDetails');
                    pointDetails.toggleClass("PDM-hide-element");
                });
        };

        /**
         * Load view of current wizard step - deletePointsView
         * @param element: dom element the view will be appended to.
         * @param params: javascript object with widget parameters required to load the view within the widget
         */
        deletePointsView.prototype.loadView = function (element, params) {
            dom = element;
            deletePointsView.component = params.component;
            deletePointsView.service = params.service;
            deletePointsView.subscriber = params.subscriber;
            deletePointsView.updateActionButtonsStatus = params.updateActionButtonsStatus;
            deletePointsView.isStationBackupChecked = true;
            deletePointsView.isSelectedDeletedRecordsLogChecked = true;
            //deletePointsView.isSecurePointAuthenticated = false;
            this.$pointDeletionSummary();

            $(element).append(template({
                    vid: this.params.vid,
                    summaryMessage: this.params.summaryMessage,
                    stepCount: this.params.stepCount,
                    stepDescription: this.params.stepDescription,
                    stationBackupConfirmationMessage: lex.get("pdm.PointDatabaseManager.stationBackupConfirmationMsg"),
                    selectedDeletedRecordsLogConfirmationMessage: lex.get("pdm.PointDatabaseManager.selectedDeletedRecordsLogConfirmationMsg")
                }
            ));
            $(element).find(".PDM-contents-step-summary").css("border-top-color", params.colorCode);
            var checkboxContainer = dom.find('#PDM-step5-stationbackup-logs-checkbox-container');
            _addEventListeners(checkboxContainer);
        };

        deletePointsView.prototype.showLoadedView = function () {
            //Update variables on back
            deletePointsView.updateActionButtonsStatus(
                $(dom).parent(),
                {
                    disabledBack: false,
                    disabledNext: false
                }
            );
        };

        deletePointsView.prototype.$pointDeletionSummary = function () {
            var that = this;
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'getDeletePointsSummary'
            })
                .then(function (list) {
                    that.$updateSummaryTable(list);
                })

        };
        deletePointsView.prototype.$updateSummaryTable = function (deletePointsList) {
            var networkList = JSON.parse(deletePointsList);
            var that = this;
            var deletePointsSummaryStage = that.dom.find('.PDM-contents-deletion-summary-container');
            var count = 0;
            var rowElem = $('<div class="PDM-contents-deletion-summary-container-row"></div>');
            _.each(networkList, function (network) {
                deletePointsSummaryStage.append(rowElem);
                var elem = $(dpSummary({
                    networkName: network.networkName,
                    totalPointsToDelete: network.totalPointsToDelete,
                    totalTrendPointsToDelete: network.totalTrendPointsToDelete,
                    totalNiagaraPointsToDelete: network.totalNiagaraPointsToDelete,
                    totalUnusedAndUnwantedTrendPoints: network.totalUnusedAndUnwantedTrendPoints,
                    totalUnusedAndUnwantedNiagaraPoints: network.totalUnusedAndUnwantedNiagaraPoints,
                    totalUnusedAndUnwantedPoints: network.totalUsedAndUnusedPoints,
                    totalHistories: network.totalHistories,
                    totalHistoriesToDelete: network.totalHistoriesToDelete,
                    totalSchedules: network.totalSchedules,
                    totalSchedulesToDelete: network.totalSchedulesToDelete,
                    deletingPoints: lex.get("pdm.PointDatabaseManager.deletePointsView.deletingPoints"),
                    deleteText: lex.get("pdm.PointDatabaseManager.deletePointsView.deleteText"),
                    histories: lex.get("pdm.PointDatabaseManager.deletePointsView.histories"),
                    schedules: lex.get("pdm.PointDatabaseManager.deletePointsView.schedules"),
                    of: lex.get("pdm.PointDatabaseManager.deletePointsView.of"),
                    trendPoints: lex.get("pdm.PointDatabaseManager.deletePointsView.trendPoints"),
                    niagaraPoints: lex.get("pdm.PointDatabaseManager.deletePointsView.niagaraPoints"),
                    selectedSecurePoint: lex.get("pdm.PointDatabaseManager.deletePointsView.selectedSecurePoint"),
                    securePointPath: network.securePointSelected
                }));

                /**
                 * addeventlisteners onclick of + icon
                 */
                rowElem.append(elem);

                var elemShowPointDetails = elem.find('#showpointdetails');
                var pointDetails = elem.find('#pointDetails');
                pointDetails.addClass("PDM-hide-element");
                if (network.networkType !== undefined) {
                    if (network.networkType === "TrendN4:TrendNetwork") {
                        elemShowPointDetails.removeClass("PDM-hide-element");
                        _addEventListeners(elem);
                    } else {
                        elemShowPointDetails.addClass("PDM-hide-element");
                    }
                }
                if (network.securePointSelected !== undefined) {
                    if (network.securePointSelected == "null"){
                        elem.find('.selectedSecurePoint').hide()
                    }
                }

            });

        };

        /**
         * validate user input before proceeding to next screen.
         * This is called before view.prototype.next is called.
         *
         * @returns {boolean}: return true/false based on validity of user input
         */
        deletePointsView.prototype.validate = function () {
            baja.outln("inside: deletePointsView.prototype.validate ...");
            return new promise(function (resolve) {
                //do any validations needed here.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        var startDeletingPoints = function (resolve) {
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'deleteSelectedItems',
                args: [{
                    isMaintainLog: deletePointsView.isSelectedDeletedRecordsLogChecked,
                    isSecurePointAuthenticated: false,
                    pointTobeDeleted: null
                }]
            }).then(function (ord) {
                var job = baja.Ord.make("station:|" + ord).get({lease: true});
                return job;
            }).then(completeJob)
                .then(function () {
                        resolve(true);
                    },
                    function () {
                        //notify user.
                        notifyUser(lex.get("pdm.PointDatabaseManager.deletePointsView.delete.error"));
                    }
                );
        };

        var startDeletingSecurePoints = function (param, resolve) {
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'deleteSelectedItems',
                args: [{
                    isMaintainLog: deletePointsView.isSelectedDeletedRecordsLogChecked,
                    isSecurePointAuthenticated: true,
                    pointTobeDeleted: param
                }]
            }).then(function (ord) {
                var job = baja.Ord.make("station:|" + ord).get({lease: true});
                return job;
            }).then(completeJob)
                .then(function () {
                        resolve(true);
                    },
                    function () {
                        //notify user.
                        notifyUser(lex.get("pdm.PointDatabaseManager.deletePointsView.delete.error"));
                    }
                );
        };

        var doElectronicSignature = function (pointOrdStr, resolve) {
            baja.Ord.make(pointOrdStr).get({lease: true}).then(function (point) {
                var strArray = pointOrdStr.split("/")
                var pointName = strArray[strArray.length - 1];
                var securedDeleteCommand = new SecuredDeleteCommand();
                var securedPointDeletePromise = new promise(function (resolve) {
                    securedDeleteCommand.performCommand(point.getParent(), [point.getParent().getSlot(pointName)], pointOrdStr, resolve)
                })
                securedPointDeletePromise.then(function (successMessage) {
                    if (successMessage == "ok") {
                        startDeletingSecurePoints(pointOrdStr, resolve);
                        startDeletingPoints(resolve);
                    } else {
                        deletePointsView.updateActionButtonsStatus(
                            $(dom).parent(),
                            {
                                disabledBack: false,
                                disabledNext: false
                            }
                        );
                        resolve(false);
                    }
                });
            });
        }

        var checkDeletingPoints = function (resolve) {
            var pointOrdStr;
            var checkDeletingPointsPromise = new promise(function (resolve) {
                baja.Ord.make("file:^edm/edm.xml").get({lease: true})
                    .then(function (response) {
                        var i, point, pointList;
                        $.get(response.getReadUri()).then(function (points) {
                            pointList = $(points).find('Item');
                            if (pointList !== null && pointList.length > 0) {
                                for (i = 0; i < pointList.length; i++) {
                                    point = pointList[i];
                                    if ($(point).attr("secure") && $(point).attr("secure") === "1" && $(point).attr("delete") === "1") {
                                        pointOrdStr = "station:|" + $(point).attr("path");
                                        resolve("SecurePoint");
                                        break;
                                    }
                                }
                            }
                            resolve("NonSecurePoint");
                        });
                    });
                })
                checkDeletingPointsPromise.then(function (successMessage) {
                if (successMessage == "SecurePoint") {
                    doElectronicSignature(pointOrdStr, resolve);
                }
                if (successMessage == "NonSecurePoint") {
                    startDeletingPoints(resolve);
                }
            });
        }

        var startProcess = function (resolve) {
            $(Element).find("#stationBackup").unbind();
            $(Element).find("#selectedDeletedRecordsLog").unbind();
            if (deletePointsView.isStationBackupChecked) {
                baja.rpc({
                    typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                    method: 'stationBackup',
                    args: [{}]
                }).then(function (ord) {
                    var job = baja.Ord.make("station:|" + ord).get({lease: true});
                    return job;
                }).then(completeJob)
                    .then(function () {
                            checkDeletingPoints(resolve);
                        },
                        function () {
                            //notify user.
                            notifyUser(lex.get('pdm.PointDatabaseManager.deletePointsView.backup.error'));

                            deletePointsView.updateActionButtonsStatus(
                                $(dom).parent(),
                                {
                                    disabledBack: false,
                                    disabledNext: false
                                }
                            );

                        }
                    );
            } else {
                checkDeletingPoints(resolve);
            }
        }

        /**
         * clean up and save before going to next view
         *
         */
        deletePointsView.prototype.next = function () {
            var confirmationDialog;
            baja.outln("inside: deletePointsView.prototype.next ...");

            deletePointsView.updateActionButtonsStatus(
                $(dom).parent(),
                {
                    disabledBack: true,
                    disabledNext: true
                }
            );

            return new promise(function (resolve) {
                // do any backend communication needed here before moving to next screen.
                //resolve once all the input is validated and good to move to next screen
                confirmationDialog = dialogs.make({
                        title: lex.get("pdm.PointDatabaseManager.stepFive.confirm.dialog.title"),
                        content: lex.get("pdm.PointDatabaseManager.stepFive.confirm.dialog.content"),
                        layout: function (dlg) {
                            var $dialog = dlg.jq();
                            $dialog.find("div.js-dialog.ux-root").css({"width": "30%"});
                            $dialog.find("div.js-dialog-content").css({
                                "padding-top": "15%",
                                "padding-bottom": "10%",
                                "padding-left": "10px",
                                "font-weight": "800"
                            });
                            $dialog.find("button.ux-btn.js-dialog-button.js-dialog-button-cancel").css({"color": "grey"});
                            $dialog.find("ul.js-dialog-button-content").css({"padding-bottom": "35px"});
                        },
                        buttons: [{
                            name: "cancel",
                            displayName: lex.get("pdm.PointDatabaseManager.button.cancel"),
                            handler: function (dlg) {
                                deletePointsView.updateActionButtonsStatus(
                                    $(dom).parent(),
                                    {
                                        disabledBack: false,
                                        disabledNext: false
                                    }
                                );
                                resolve(false);
                            }
                        },
                            {
                                name: "remove",
                                displayName: lex.get("pdm.PointDatabaseManager.button.remove"),
                                handler: function (dlg) {
                                    startProcess(resolve);
                                    dlg.close();
                                }
                            }]
                    }
                );
                confirmationDialog.show();
            });
        };

        /**
         * clean up and save before going to previous view
         *
         */
        deletePointsView.prototype.back = function () {
            baja.outln("inside: deletePointsView.prototype.back ...");
            return new promise(function (resolve) {
                // do any cleanup/backend communication needed here before moving to previous screen.
                //resolve once all the input is validated and good to move to next screen
                $(dom).find(".content-section").css("display", "block");
                resolve(true);
            });
        };

        /**
         * cancel operation - cancel button supported cancellable operation in current view
         */
        deletePointsView.prototype.cancel = function () {
            /*
             * if cancel button is available, the action should be implemented here.
            */
        };

        //these are prototype functions and needs to be overriden in extended screens.
        deletePointsView.prototype.updateView = function () {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        function completeJob(job) {
            return new Promise(function (resolve, reject) {
                function checkIfJobIsComplete() {
                    switch (job.get('jobState').getTag()) {
                        case 'success':
                            return resolve();
                        case 'failed':
                            deletePointsView.updateActionButtonsStatus(
                                $(dom).parent(),
                                {
                                    disabledBack: false,
                                    disabledNext: false
                                }
                            );
                            return reject();

                        default :
                            break;
                    }
                }

                var sub = new baja.Subscriber();
                sub.attach('changed', checkIfJobIsComplete);
                sub.subscribe(job).then(checkIfJobIsComplete);
            });
        }

        function notifyUser(message) {
            baja.outln(message);
            //hide progress.
            $(dom).find(".operation-progress").removeClass("show-progress");
            $(dom).find(".content-section").css("display", "none");
            $(dom).find("#PDM-step5-deletePointsView .error-message").html(message);
        }

        return deletePointsView;
    });

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/postDeleteStatusViewTemplate',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div id=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"vid") || (depth0 != null ? lookupProperty(depth0,"vid") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"vid","hash":{},"data":data,"loc":{"start":{"line":1,"column":9},"end":{"line":1,"column":16}}}) : helper)))
    + "\" class=\"\">\n    <div class=\"PDM-step-details\">\n        <div class=\"PDM-contents-step-summary\">\n            <span class=\"PDM-step-count\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepCount") || (depth0 != null ? lookupProperty(depth0,"stepCount") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepCount","hash":{},"data":data,"loc":{"start":{"line":4,"column":41},"end":{"line":4,"column":54}}}) : helper)))
    + "</span>\n            <span class=\"PDM-step-name\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"summaryMessage") || (depth0 != null ? lookupProperty(depth0,"summaryMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"summaryMessage","hash":{},"data":data,"loc":{"start":{"line":5,"column":40},"end":{"line":5,"column":58}}}) : helper)))
    + "</span>\n        </div>\n        <div class=\"PDM-step-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepDescription") || (depth0 != null ? lookupProperty(depth0,"stepDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepDescription","hash":{},"data":data,"loc":{"start":{"line":7,"column":42},"end":{"line":7,"column":61}}}) : helper)))
    + "\n            <span id=\"PDM-postDelete-stepDescription\"></span>\n        </div>\n    </div>\n    <div class=\"PDM-contents-step4-details\">\n        <div class=\"PDM-network-capacity-available-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"networkCapacityDescription") || (depth0 != null ? lookupProperty(depth0,"networkCapacityDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"networkCapacityDescription","hash":{},"data":data,"loc":{"start":{"line":12,"column":64},"end":{"line":12,"column":94}}}) : helper)))
    + "\n            <span class=\"PDM-network-capacity-count\" id=\"PDM-network-available-count\"></span>\n        </div>\n        <div id=\"PDM-license-status-after-delete-stage\">\n        </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/postDeleteStatusViewTemplate', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/postDeleteLicenseStatusTable',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"PDM-license-status-counter-container-col\">\n    <div class=\"PDM-license-status-counter-table-container\">\n        <div class=\"Table\">\n            <div class=\"Heading\">\n                <div class=\"Cell\">\n                    <p>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"driver") || (depth0 != null ? lookupProperty(depth0,"driver") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"driver","hash":{},"data":data,"loc":{"start":{"line":6,"column":23},"end":{"line":6,"column":33}}}) : helper)))
    + "</p>\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"licensePoints") || (depth0 != null ? lookupProperty(depth0,"licensePoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"licensePoints","hash":{},"data":data,"loc":{"start":{"line":11,"column":27},"end":{"line":11,"column":44}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"target-points\" id=\"targetPoints\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"target") || (depth0 != null ? lookupProperty(depth0,"target") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"target","hash":{},"data":data,"loc":{"start":{"line":14,"column":66},"end":{"line":14,"column":76}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUse") || (depth0 != null ? lookupProperty(depth0,"pointsInUse") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUse","hash":{},"data":data,"loc":{"start":{"line":19,"column":27},"end":{"line":19,"column":42}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"points-in-use numeric-value\" data-value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValue") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValue","hash":{},"data":data,"loc":{"start":{"line":22,"column":74},"end":{"line":22,"column":94}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValueFormatted") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValueFormatted") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValueFormatted","hash":{},"data":data,"loc":{"start":{"line":22,"column":96},"end":{"line":22,"column":125}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPoints") || (depth0 != null ? lookupProperty(depth0,"remainingPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPoints","hash":{},"data":data,"loc":{"start":{"line":27,"column":27},"end":{"line":27,"column":46}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"remaining-points numeric-value "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPointsClass") || (depth0 != null ? lookupProperty(depth0,"remainingPointsClass") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPointsClass","hash":{},"data":data,"loc":{"start":{"line":30,"column":64},"end":{"line":30,"column":88}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPointsValue") || (depth0 != null ? lookupProperty(depth0,"remainingPointsValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPointsValue","hash":{},"data":data,"loc":{"start":{"line":30,"column":90},"end":{"line":30,"column":114}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n        </div>\n   </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/postDeleteLicenseStatusTable', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/GlobalPostDeleteNetworkTable',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"PDM-license-status-counter-container-col\">\n    <div class=\"PDM-license-status-counter-table-container\">\n        <div class=\"Table\">\n            <div class=\"Heading\">\n                <div class=\"Cell\">\n                    <p>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"driver") || (depth0 != null ? lookupProperty(depth0,"driver") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"driver","hash":{},"data":data,"loc":{"start":{"line":6,"column":23},"end":{"line":6,"column":33}}}) : helper)))
    + "</p>\n                </div>\n            </div>\n            <div class=\"Row\" >\n                <div class=\"Cell\" >\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUse") || (depth0 != null ? lookupProperty(depth0,"pointsInUse") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUse","hash":{},"data":data,"loc":{"start":{"line":11,"column":27},"end":{"line":11,"column":42}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"points-in-use numeric-value\" data-value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValue") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValue","hash":{},"data":data,"loc":{"start":{"line":14,"column":74},"end":{"line":14,"column":94}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValueFormatted") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValueFormatted") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValueFormatted","hash":{},"data":data,"loc":{"start":{"line":14,"column":96},"end":{"line":14,"column":125}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/GlobalPostDeleteNetworkTable', t);
return t;
});
/* END_TEMPLATE */
;
/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/GlobalPostDeleteSummaryTable',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<div class=\"PDM-global-contents-step1-details\">\n    <div class=\"PDM-global-summary-container\">\n        <div class=\"PDM-global-capacity-available-description\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"globalCapacityDescription") || (depth0 != null ? lookupProperty(depth0,"globalCapacityDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"globalCapacityDescription","hash":{},"data":data,"loc":{"start":{"line":3,"column":63},"end":{"line":3,"column":92}}}) : helper)))
    + "\n        </div>\n        <div class=\"Table Global-points-summary\">\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"licensePoints") || (depth0 != null ? lookupProperty(depth0,"licensePoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"licensePoints","hash":{},"data":data,"loc":{"start":{"line":8,"column":27},"end":{"line":8,"column":44}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"Global-Licensed-Points numeric-value\"\n                        data-value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"target") || (depth0 != null ? lookupProperty(depth0,"target") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"target","hash":{},"data":data,"loc":{"start":{"line":12,"column":36},"end":{"line":12,"column":46}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"target") || (depth0 != null ? lookupProperty(depth0,"target") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"target","hash":{},"data":data,"loc":{"start":{"line":12,"column":48},"end":{"line":12,"column":58}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUse") || (depth0 != null ? lookupProperty(depth0,"pointsInUse") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUse","hash":{},"data":data,"loc":{"start":{"line":17,"column":27},"end":{"line":17,"column":42}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span class=\"points-in-use numeric-value\"\n                        data-value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValue") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValue","hash":{},"data":data,"loc":{"start":{"line":21,"column":36},"end":{"line":21,"column":56}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"pointsInUseValueFormatted") || (depth0 != null ? lookupProperty(depth0,"pointsInUseValueFormatted") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"pointsInUseValueFormatted","hash":{},"data":data,"loc":{"start":{"line":21,"column":58},"end":{"line":21,"column":87}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n            <div class=\"Row\">\n                <div class=\"Cell\">\n                    <label>"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPoints") || (depth0 != null ? lookupProperty(depth0,"remainingPoints") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPoints","hash":{},"data":data,"loc":{"start":{"line":26,"column":27},"end":{"line":26,"column":46}}}) : helper)))
    + "</label>\n                </div>\n                <div class=\"Cell spanwidth\">\n                    <span\n                        class=\"remaining-points numeric-value "
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPointsClass") || (depth0 != null ? lookupProperty(depth0,"remainingPointsClass") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPointsClass","hash":{},"data":data,"loc":{"start":{"line":30,"column":62},"end":{"line":30,"column":86}}}) : helper)))
    + "\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"remainingPointsValue") || (depth0 != null ? lookupProperty(depth0,"remainingPointsValue") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"remainingPointsValue","hash":{},"data":data,"loc":{"start":{"line":30,"column":88},"end":{"line":30,"column":112}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n\n        </div>\n    </div>\n\n    <div id=\"PDM-global-license-status-view-stage\">\n    </div>\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/GlobalPostDeleteSummaryTable', t);
return t;
});
/* END_TEMPLATE */
;
/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225 on 7/19/2019
 *
 */

define('nmodule/easyDatabaseManager/rc/js/postDeleteStatusView',['baja!',
    'jquery',
    'underscore',
    'lex!easyDatabaseManager',
    'bajaux/Widget',
    'nmodule/webEditors/rc/fe/fe',
    'nmodule/webEditors/rc/wb/table/Table',
    'nmodule/webEditors/rc/wb/table/model/columns/JsonObjectPropertyColumn',
    'nmodule/webEditors/rc/wb/table/model/TableModel',
    'nmodule/webEditors/rc/wb/table/model/Row',
    'nmodule/easyDatabaseManager/rc/js/defaultView',
    'hbs!nmodule/easyDatabaseManager/rc/hbs/postDeleteStatusViewTemplate',
    'hbs!nmodule/easyDatabaseManager/rc/hbs/postDeleteLicenseStatusTable',
    'hbs!nmodule/easyDatabaseManager/rc/hbs/GlobalPostDeleteNetworkTable',
    'hbs!nmodule/easyDatabaseManager/rc/hbs/GlobalPostDeleteSummaryTable'
],
    function (baja,
        $,
        _,
        lexicons,
        Widget,
        fe,
        Table,
        JsonObjectPropertyColumn,
        TableModel,
        Row,
        defaultView,
        template,
        tplPDMSummaryTable,
        tplPDMGlobalNetworkTable,
        tplPDMGlobalSummaryTable) {
        

        var lex = lexicons[0];
        var globalCapacityNetworksSet;
        var setOfNwNotConsumingGlobalCapacity;
        var availableGlobalCapacity = 0;
        var globalcapcitylimit = 0;
        var totalGlobalCapcityUsed = 0;
        var brandCode = null;
        var dom;
        function isUnlimited(limit) {
            if (isNaN(limit)) {
                return true;
            }
            return limit === -1;
        }


        var targetLicenseData = null;


        // postDeleteStatusView step
        // arguments: dom, vname, id, message, summaryMessage, backBttnMsg, nextBttnMsg, cancelBttnMsg
        var postDeleteStatusView = function () {
            defaultView.apply(this, arguments);

            //update which buttons will be available
            this.buttonstatus = {
                disabledNext: false
            };
        };
        postDeleteStatusView.prototype = Object.create(defaultView.prototype,
            { 'constructor': postDeleteStatusView }
        );

        //these variables will be updated in loadView with values passed from PointDatabaseManagerWidget
        postDeleteStatusView.component = null;
        postDeleteStatusView.service = null;
        postDeleteStatusView.subscriber = null;
        // call this function anytime you want to update nav action button status to enable/disable them
        postDeleteStatusView.updateActionButtonsStatus = null;

        /**
         * Load view of current wizard step - postDeleteStatusView
         * @param element: dom element the view will be appended to.
         * @param params: javascript object with widget parameters required to load the view within the widget
         */
        postDeleteStatusView.prototype.loadView = function (element, params) {
            postDeleteStatusView.component = params.component;
            postDeleteStatusView.service = params.service;
            postDeleteStatusView.subscriber = params.subscriber;
            postDeleteStatusView.updateActionButtonsStatus = params.updateActionButtonsStatus;
            targetLicenseData = params.pdmData.licenseViewData.targetLicense;


            $(element).append(template({
                vid: this.params.vid,
                summaryMessage: this.params.summaryMessage,
                stepCount: this.params.stepCount,
                stepDescription: this.params.stepDescription,
                networkCapacityDescription: lex.get("pdm.PointDatabaseManager.licenseStatusView.available.network.points.description")
            }));
            $(element).find(".PDM-contents-step-summary").css("border-top-color", params.colorCode);
            var that = this;
            dom = element;
            brandCode = params.colorCode;
            that.$startDiscoveryJob("station:|" + params.component.getSlotPath().toString());
        };

        postDeleteStatusView.prototype.showLoadedView = function () {
            // If We come back to this view
        };
        /**
         * validate user input before proceeding to next screen.
         * This is called before view.prototype.next is called.
         *
         * @returns {boolean}: return true/false based on validity of user input
         */
        postDeleteStatusView.prototype.validate = function () {
            baja.outln("inside: postDeleteStatusView.prototype.validate ...");
            return new Promise(function (resolve) {
                //do any validations needed here.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * clean up and save before going to next view
         *
         */
        postDeleteStatusView.prototype.next = function () {
            baja.outln("inside: postDeleteStatusView.prototype.next ...");
            return new Promise(function (resolve) {
                // do any backend communication needed here before moving to next screen.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * clean up and save before going to previous view
         *
         */
        postDeleteStatusView.prototype.back = function () {
            baja.outln("inside: postDeleteStatusView.prototype.back ...");
            return new Promise(function (resolve) {
                // do any cleanup/backend communication needed here before moving to previous screen.
                //resolve once all the input is validated and good to move to next screen
                resolve(true);
            });
        };

        /**
         * cancel operation - cancel button supported cancellable operation in current view
         * This is invoked only if this.params.isCancelAvailable is set to true.
         */
        postDeleteStatusView.prototype.cancel = function () {
            /*
             * if cancel button is available, the action should be implemented here.
            */
        };

        //these are prototype functions and needs to be overriden in extended screens.
        postDeleteStatusView.prototype.updateView = function () {
            throw new Error('Cannot call abstract method, please overwrite in current view');
        };

        /**
         * Kick off the discovery job using the component handles of the items selected in the previous
         * screen, and the values of the checkboxes from the options screen.
         *
         * @param {Arrary.<String>} handles - an array of handles for the components selected in the previous screen.
         * @private
         */
        postDeleteStatusView.prototype.$startDiscoveryJob = function (nodeVal) {
            var that = this;
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'findLicenseDetails',
                args: [{ nodeOrd: nodeVal }]
            })
                .then(function (list) {
                    baja.rpc({
                        typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                        method: 'findGlobalCapacityDetails'
                    }).then(function (globalCapacityDetails) {
                        that.$updateDeviceTable(list, globalCapacityDetails);
                    })
                })
        };


        /**
         * Update the table with the summaries of devices currently being discovered.
         *
         * @private
         * @param {baja.Component} job - the discovery job.
         */
        function removeSpaceAndSpecialChars(networkName) {
            return networkName.trim().replace(/[^A-Z0-9]+/ig, "_");
        }
        postDeleteStatusView.prototype.$updateDeviceTable = function (list, globalCapacityDetails) {
            var networkList = JSON.parse(list);

            var that = this,
                dom = that.dom,
                networkStage = dom.find('#PDM-license-status-after-delete-stage');

            if (!dom) {
                return;
            }
            var tempGlobalCapacityDetails = JSON.parse(globalCapacityDetails);
            globalcapcitylimit = tempGlobalCapacityDetails.globalPointCapacityLimit;
            var GlobalPointsSummaryElem = $(tplPDMGlobalSummaryTable({
                globalCapacityDescription: lex.get("pdm.PointDatabaseManager.licenseStatusView.available.global.points.description"),
                licensePoints: lex.get("pdm.PointDatabaseManager.licenseStatusView.license.points"),
                unlimited: "none",
                remainingPoints: lex.get("pdm.PointDatabaseManager.licenseStatusView.remaining.points"),
                pointsInUse: lex.get("pdm.PointDatabaseManager.licenseStatusView.points.in.use"),
                target: (tempGlobalCapacityDetails.globalPointCapacityLimit > 0) ? tempGlobalCapacityDetails.globalPointCapacityLimit : "0"
            }))

            //Display Global Points summary table only if the Global points count is available and do not add border when globalCapacity not available
            var isGlobalPointCapacityAvailable = false;
            if (tempGlobalCapacityDetails.globalPointCapacityLimit) {
                isGlobalPointCapacityAvailable = true;
                $("#PDM-step6-postDeleteStatusView > div.PDM-step-details").after($(GlobalPointsSummaryElem));
                $(".PDM-footer").addClass("PDM-footer-increase-margin");
            }

            //set brand color as border for the table when both the elements are created
            if (isGlobalPointCapacityAvailable) {
                $(dom).find(".PDM-global-contents-step1-details,.PDM-contents-step4-details").css("border-color", brandCode);
            }

            if (!tempGlobalCapacityDetails || tempGlobalCapacityDetails.length === 0) {
                setOfNwNotConsumingGlobalCapacity = new Set();
            } else {
                var networksNotConsumingGlobalPointCapacity = tempGlobalCapacityDetails.networksNotConsumingGlobalPointCapacity;
                setOfNwNotConsumingGlobalCapacity = new Set(networksNotConsumingGlobalPointCapacity);
            }

            //get respective stage element to fill it with each network
            var networkStage = $(dom).find('#PDM-step6-postDeleteStatusView #PDM-license-status-after-delete-stage');
            var networkGlobalStage = $(dom).find('#PDM-step6-postDeleteStatusView #PDM-global-license-status-view-stage');
            globalCapacityNetworksSet = new Set();
            var networkCount = 0;

            _.each(networkList, function (network) {
                var val;

                $.each(targetLicenseData, function (key, value) {
                    if(value == null)
                        return;
                    if (value.Network === "txt" + removeSpaceAndSpecialChars(network.name) + "_" + networkCount) {
                        val = value.Target;
                    }else if(value.Network === "txtGlobalLicensedPoints"){
                        availableGlobalCapacity = value.Target;
                    }  
                    return;
                });

                if (network.visible) {
                    var remainingPointsClass = "";
                    var elem = null;
                    var rowElem = $('<div class="PDM-license-status-container-row"></div>');

                    var remainingPoints = parseInt(val, 10) - network.existing;
                    var remainingPointsClass = (val == 0 || (remainingPoints >= -1 && network.limit == -1) || 
                    (network.limit != -1 && (parseInt(val, 10) - parseInt(network.limit) <= 0))) ? "positive" : "negative";
                    $(rowElem).attr('id', "Summary" + removeSpaceAndSpecialChars(network.name) + "_" + networkCount);


                    if (!$excludedFromGlobalCapacity(network.type) && tempGlobalCapacityDetails.globalPointCapacityLimit != 0) {
                        globalCapacityNetworksSet.add("Summary" + removeSpaceAndSpecialChars(network.name) + "_" + networkCount);
                        networkGlobalStage.append(rowElem);
                        elem = $(tplPDMGlobalNetworkTable({
                            driver: network.name,
                            pointsInUse: lex.get("pdm.PointDatabaseManager.licenseStatusView.points.in.use"),
                            pointsInUseValue: network.existing,
                            pointsInUseValueFormatted: network.existing.toLocaleString(),
                        }));
                    }
                    else {
                        networkStage.append(rowElem);
                        var elem = $(tplPDMSummaryTable({
                            driver: network.name,
                            target: val == 0 ? "none" : val,
                            licensePoints: lex.get("pdm.PointDatabaseManager.licenseStatusView.license.points"),
                            globalPointsCapacity: lex.get("pdm.PointDatabaseManager.licenseStatusView.global.points.capacity"),
                            pointsInUse: lex.get("pdm.PointDatabaseManager.licenseStatusView.points.in.use"),
                            remainingPoints: lex.get("pdm.PointDatabaseManager.licenseStatusView.remaining.points"),
                            pointsInUseValue: network.existing,
                            pointsInUseValueFormatted: network.existing.toLocaleString(),
                            remainingPointsValue: val ==0 ? 0 : remainingPoints.toLocaleString(),
                            remainingPointsClass: remainingPointsClass
                        }));
                    networkCount++;
                    }
                    rowElem.append(elem);
                }
            });
            updatePlaceholder(tempGlobalCapacityDetails);

            //do not display block if there are no networks in drivers with individual licensing and drivers with global licensing respectively.
            if (!($(dom).find('#PDM-step6-postDeleteStatusView #PDM-license-status-after-delete-stage .PDM-license-status-container-row').length)) {
                $(dom).find(".PDM-contents-step4-details").css("display", "none");
                $(dom).find(".PDM-global-contents-step1-details").addClass("PDM-hide-element-set-margin");
            }
            if (!($(dom).find('#PDM-step6-postDeleteStatusView #PDM-global-license-status-view-stage .PDM-license-status-container-row').length)) {
                $(dom).find(".PDM-global-contents-step1-details").css("display", "none");
                $(dom).find(".PDM-contents-step4-details").addClass("PDM-hide-element-set-margin");
            }

        };

        function updatePlaceholder(tempGlobalCapacityDetails) {
            //set GLobal points summary including licensedPoints, used and remaining count
            //get all network details under Drivers which are using global capacity then calculate remaining Points in use
            var globalCapacityPointsInUse = 0;
            totalGlobalCapcityUsed = 0;
            var tmpGlobalRemainingPointsClass = "";
            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'findLicenseDetails',
                args: [{ nodeOrd: "station:|slot:/Drivers" }]
            }).then(function (list) {
                var networkList = JSON.parse(list);
                _.each(networkList, function (network) {
                    if (!$excludedFromGlobalCapacity(network.type)) {
                        globalCapacityPointsInUse = network.existing == -1 ? globalCapacityPointsInUse : parseInt(network.existing, 10) + globalCapacityPointsInUse;
                    }
                });
                //set user entered value for the global capacity limit
                $("#PDM-step6-postDeleteStatusView .Global-Licensed-Points").html(availableGlobalCapacity);
                $(".PDM-global-summary-container .points-in-use").html(globalCapacityPointsInUse);
                totalGlobalCapcityUsed = globalCapacityPointsInUse;
                var tmpTotalGlobalCapacityRemaining = (parseInt(availableGlobalCapacity, 10) - parseInt(globalCapacityPointsInUse, 10));
                $(dom).find(".PDM-global-summary-container .remaining-points").text(tmpTotalGlobalCapacityRemaining);
                if (tmpTotalGlobalCapacityRemaining >= 0 && (parseInt(availableGlobalCapacity, 10) - parseInt(tempGlobalCapacityDetails.globalPointCapacityLimit, 10)) <= 0)
                    tmpGlobalRemainingPointsClass = "positive";
                else
                    tmpGlobalRemainingPointsClass = "negative"
                $(dom).find(".PDM-global-summary-container .remaining-points").addClass(tmpGlobalRemainingPointsClass);
            });
        };


        /**
         * Tells whether this network can consume global point capacity
         */
        function $excludedFromGlobalCapacity(networkType) {
            var driverName = networkType.substring(0, networkType.indexOf(':'));
            return setOfNwNotConsumingGlobalCapacity.has(driverName);
        }
        return postDeleteStatusView;
    });

/* START_TEMPLATE */
define('hbs!nmodule/easyDatabaseManager/rc/hbs/PointDataManagerLayout',['Handlebars'], function( Handlebars ){ 
var t = Handlebars.template({"compiler":[8,">= 4.3.0"],"main":function(container,depth0,helpers,partials,data) {
    var helper, lookupProperty = container.lookupProperty || function(parent, propertyName) {
        if (Object.prototype.hasOwnProperty.call(parent, propertyName)) {
          return parent[propertyName];
        }
        return undefined
    };

  return "<!--\n\nPDM - PointDatabaseManager\n\n-->\n<div class=\"PointDataManager-wizard\" xmlns=\"http://www.w3.org/1999/html\">\n    <div class=\"PDM-wizard-container\">\n        <div class=\"PDM-header\">\n            <div class=\"PDM-header-step\">\n                <div class=\"PDM-step-title\">\n                    <span class=\"PDM-step-message\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"stepMessage") || (depth0 != null ? lookupProperty(depth0,"stepMessage") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"stepMessage","hash":{},"data":data,"loc":{"start":{"line":11,"column":51},"end":{"line":11,"column":66}}}) : helper)))
    + "</span>\n                </div>\n                <div class=\"PDM-feature-description\">\n                    <span class=\"PDM-feature-description-message\">"
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"featureDescription") || (depth0 != null ? lookupProperty(depth0,"featureDescription") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"featureDescription","hash":{},"data":data,"loc":{"start":{"line":14,"column":66},"end":{"line":14,"column":88}}}) : helper)))
    + "</span>\n                </div>\n            </div>\n        </div>\n\n        <div class=\"PDM-contents\">\n        </div>\n        <div class=\"PDM-footer\">\n            <div class=\"PDM-nav-buttons\">\n                <input type=\"button\" class=\"ux-btn PDM-nav-button\" id=\"PDM-nav-button-back\" value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"backButtonMsg") || (depth0 != null ? lookupProperty(depth0,"backButtonMsg") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"backButtonMsg","hash":{},"data":data,"loc":{"start":{"line":23,"column":99},"end":{"line":23,"column":116}}}) : helper)))
    + "\" />\n                <input type=\"button\" class=\"ux-btn PDM-nav-button\" id=\"PDM-nav-button-next\" value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"nextButtonMsg") || (depth0 != null ? lookupProperty(depth0,"nextButtonMsg") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"nextButtonMsg","hash":{},"data":data,"loc":{"start":{"line":24,"column":99},"end":{"line":24,"column":116}}}) : helper)))
    + "\" />\n                <input type=\"button\" class=\"ux-btn PDM-nav-button\" id=\"PDM-nav-button-cancel\" value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"cancelButtonMsg") || (depth0 != null ? lookupProperty(depth0,"cancelButtonMsg") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"cancelButtonMsg","hash":{},"data":data,"loc":{"start":{"line":25,"column":101},"end":{"line":25,"column":120}}}) : helper)))
    + "\" />\n                <input type=\"button\" class=\"ux-btn PDM-nav-button\" id=\"PDM-nav-button-skip\" value=\""
    + container.escapeExpression(((helper = (helper = lookupProperty(helpers,"skipButtonMsg") || (depth0 != null ? lookupProperty(depth0,"skipButtonMsg") : depth0)) != null ? helper : container.hooks.helperMissing),(typeof helper === "function" ? helper.call(depth0 != null ? depth0 : (container.nullContext || {}),{"name":"skipButtonMsg","hash":{},"data":data,"loc":{"start":{"line":26,"column":99},"end":{"line":26,"column":116}}}) : helper)))
    + "\" />\n            </div>\n        </div>\n    </div>\n    <div class=\"PDM-error-notification PDM-hide-element\">\n        <div class=\"PDM-error-message\"></div>\n    </div>\n    <input type=\"hidden\" id=\"hiddenFieldIsWorkBench\" name=\"custId\" value=\"0\">\n</div>\n";
},"useData":true});
Handlebars.registerPartial('nmodule/easyDatabaseManager/rc/hbs/PointDataManagerLayout', t);
return t;
});
/* END_TEMPLATE */
;
/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *    created by H148225
 *
 */

/**
 * A module defining `EasyDatabaseManagerWidget`.
 *
 * @module nmodule/easyDatabaseManager/rc/js/EasyDatabaseManagerWidget
 */
define('nmodule/easyDatabaseManager/rc/js/EasyDatabaseManagerWidget',['baja!',
        'bajaux/Widget',
        'bajaux/mixin/subscriberMixIn',
        'jquery',
        'Promise',
        'nmodule/webEditors/rc/fe/baja/util/DepthSubscriber',
        'nmodule/easyDatabaseManager/rc/js/licenseStatusView',
        'nmodule/easyDatabaseManager/rc/js/unusedPointsView',
        'nmodule/easyDatabaseManager/rc/js/unwantedPointsView',
        'nmodule/easyDatabaseManager/rc/js/reviewPointsView',
        'nmodule/easyDatabaseManager/rc/js/deletePointsView',
        'nmodule/easyDatabaseManager/rc/js/postDeleteStatusView',
        'hbs!nmodule/easyDatabaseManager/rc/hbs/PointDataManagerLayout',
        'lex!easyDatabaseManager',
        'css!nmodule/easyDatabaseManager/rc/css/pointDataManager'],
    function (baja,
              Widget,
              subscriberMixin,
              $,
              promise,
              DepthSubscriber,
              licenseStatusView,
              unusedPointsView,
              unwantedPointsView,
              reviewPointsView,
              deletePointsView,
              postDeleteStatusView,
              layout,
              lexicons) {

  

      var lex = lexicons[0];
      var pointDataManagerService = null;
      var brandColorCode;
      function updateHeaderAndFooter(dom, currentView) {
            var params = currentView.getViewHeaders();
            //update headers
            $(dom).find(".PDM-step-message").text(params.message);
            $(dom).find(".PDM-feature-description-message").text(params.featureDescription);
            // update nav buttons
            $(dom).find("#PDM-nav-button-back").val(params.backBttnMsg);
            $(dom).find("#PDM-nav-button-next").val(params.nextBttnMsg);
            $(dom).find("#PDM-nav-button-cancel").val(params.cancelBttnMsg);
            $(dom).find("#PDM-nav-button-skip").val(params.skipBttnMsg);
            // unhide all buttons previously hidden by different view
            $(dom).find(".PDM-nav-button").removeClass("PDM-hide-element");
            var actionBttnStatus = currentView.getActionBttnsStatus();
            updateActionButtonsStatus(dom, actionBttnStatus);

            $(dom).find("#" + params.vid).removeClass("step-done PDM-hide-element");
            $(dom).find("#" + params.vid).addClass("step-active");
      }

  function addEventListeners() {
            var _self = this;
            var dom = _self.jq();
            $(dom).find("#PDM-nav-button-next").click({_self: _self},_self.addNextBtnListener);
            $(dom).find("#PDM-nav-button-back").click({_self: _self},_self.addBackBtnListener);
            $(dom).find("#PDM-nav-button-cancel").click({_self: _self},_self.addCancelBtnListener);
            $(dom).find("#PDM-nav-button-skip").click({_self: _self},_self.addSkipBtnListener);
  }

  function addNextBtnListener(event) {
      var _self = event.data._self;
      var currentView = _self.currentView;
      var actionBttnStatus = currentView.getActionBttnsStatus();
      var dom = _self.jq();

      // Update #PDM-nav-button-next status
      actionBttnStatus.disabledNext = $($(dom).find("#PDM-nav-button-next")).prop('disabled');


            if(currentView && (actionBttnStatus && !actionBttnStatus.disabledNext)) {
                currentView.validate()
                    .then(function(validInputs) {
                        if(validInputs) {
                            currentView.next()
                                .then(function(status) {
                                    if(status) {
                                        var viewData = currentView.getData();
                                        for (var key in viewData) {
                                            _self.pdmData[key] = viewData[key];
                                        }
                                        _self.currentView = _self.getUIView(currentView, "next");
                                        _self.updateView(currentView, "next");
                                        _self.loadView();
                                    }
                                });
                        }
                    });
            }
   }

  function addBackBtnListener(event) {
            var _self = event.data._self;
            var currentView = _self.currentView;
            var actionBttnStatus = currentView.getActionBttnsStatus();

            // Update #PDM-nav-button-next status
            // actionBttnStatus.disabledNext = $($(dom).find("#PDM-nav-button-next")).prop('disabled');

            if(currentView && (actionBttnStatus && !actionBttnStatus.disabledBack)) {
                currentView.back()
                    .then(function(status) {
                        if(status) {
                            _self.currentView = _self.getUIView(currentView, "prev");
                            _self.updateView(currentView, "prev");
                            _self.showLoadedView();
                        }
                    });
            }
  }

  function addCancelBtnListener(event) {
            var _self = event.data._self;
            var currentView = _self.currentView;
            var actionBttnStatus = currentView.getActionBttnsStatus();
            if(currentView && (actionBttnStatus && !actionBttnStatus.disabledCancel)) {
                _self.currentView.cancel();
            }
  }


        function addSkipBtnListener(event) {
            var _self = event.data._self;
            var currentView = _self.currentView;
            var actionBttnStatus = currentView.getActionBttnsStatus();
            var dom = _self.jq();

            // Update #PDM-nav-button-next status
            actionBttnStatus.disabledSkip = $($(dom).find("#PDM-nav-button-skip")).prop('disabled');


            if (currentView && (actionBttnStatus && !actionBttnStatus.disabledSkip)) {
                currentView.validate()
                    .then(function (validInputs) {
                        if (validInputs) {
                            currentView.skip()
                                .then(function (status) {
                                    if (status) {
                                        var viewData = currentView.getData();
                                        for (var key in viewData) {
                                            _self.pdmData[key] = viewData[key];
                                        }
                                        _self.currentView = _self.getUIView(currentView, "next");
                                        _self.updateView(currentView, "next");
                                        _self.loadView();
                                    }
                                });
                        }
                    });
            }
        }

  function initializeWizardSteps(dom) {
            var _self = this;
            // initializing first (license status view) screen.
            _self.wizardOrder.push(new licenseStatusView(dom, "licenseStatusView", "PDM-step1-licenseStatusView",
                //lex.get("pdm.PointDatabaseManager.licenseStatusViewMsg"),
                //lex.get("pdm.PointDatabaseManager.licenseStatusViewSummaryMsg"),
                lex.get("pdm.PointDatabaseManager.featureHeading"),
                lex.get("pdm.PointDatabaseManager.featureDescription"),
                lex.get("pdm.PointDatabaseManager.stepOneName"),
                lex.get("pdm.PointDatabaseManager.stepOneDescription"),
                lex.get("pdm.PointDatabaseManager.stepOneOfSix"),
                lex.get("pdm.PointDatabaseManager.button.back"),
                lex.get("pdm.PointDatabaseManager.button.next"),
                lex.get("pdm.PointDatabaseManager.button.cancel")));

            // initializing second (unused points view) screen.
            _self.wizardOrder.push(new unusedPointsView(dom, "unusedPointsView", "PDM-step2-unusedPointsView",
                //lex.get("pdm.PointDatabaseManager.unusedPointsViewMsg"),
                //lex.get("pdm.PointDatabaseManager.unusedPointsViewSummaryMsg"),
                lex.get("pdm.PointDatabaseManager.featureHeading"),
                lex.get("pdm.PointDatabaseManager.featureDescription"),
                lex.get("pdm.PointDatabaseManager.stepTwoName"),
                lex.get("pdm.PointDatabaseManager.stepTwoDescription"),
                lex.get("pdm.PointDatabaseManager.stepTwoOfSix"),
                lex.get("pdm.PointDatabaseManager.button.back"),
                lex.get("pdm.PointDatabaseManager.button.next"),
                lex.get("pdm.PointDatabaseManager.button.cancel"),
                lex.get("pdm.PointDatabaseManager.button.skip")));

            // initializing third (unwanted points view) screen.
            _self.wizardOrder.push(new unwantedPointsView(dom, "unwantedPointsView", "PDM-step3-unwantedPointsView",
                //lex.get("pdm.PointDatabaseManager.unwantedPointsViewMsg"),
                //lex.get("pdm.PointDatabaseManager.unwantedPointsViewSummaryMsg"),
                lex.get("pdm.PointDatabaseManager.featureHeading"),
                lex.get("pdm.PointDatabaseManager.featureDescription"),
                lex.get("pdm.PointDatabaseManager.stepThreeName"),
                lex.get("pdm.PointDatabaseManager.stepThreeDescription"),
                lex.get("pdm.PointDatabaseManager.stepThreeOfSix"),
                lex.get("pdm.PointDatabaseManager.button.back"),
                lex.get("pdm.PointDatabaseManager.button.next"),
                lex.get("pdm.PointDatabaseManager.button.cancel"),
                lex.get("pdm.PointDatabaseManager.button.skip")));

            // initializing fourth (review points view) screen.
            _self.wizardOrder.push(new reviewPointsView(dom, "reviewPointsView", "PDM-step4-reviewPointsView",
                //lex.get("pdm.PointDatabaseManager.reviewPointsViewMsg"),
                //lex.get("pdm.PointDatabaseManager.reviewPointsViewSummaryMsg"),
                lex.get("pdm.PointDatabaseManager.featureHeading"),
                lex.get("pdm.PointDatabaseManager.featureDescription"),
                lex.get("pdm.PointDatabaseManager.stepFourName"),
                lex.get("pdm.PointDatabaseManager.stepFourDescription"),
                lex.get("pdm.PointDatabaseManager.stepFourOfSix"),
                lex.get("pdm.PointDatabaseManager.button.back"),
                lex.get("pdm.PointDatabaseManager.button.next"),
                lex.get("pdm.PointDatabaseManager.button.cancel")));

            // initializing fifth (delete points view) screen.
            _self.wizardOrder.push(new deletePointsView(dom, "deletePointsView", "PDM-step5-deletePointsView",
                //lex.get("pdm.PointDatabaseManager.deletePointsViewMsg"),
                //lex.get("pdm.PointDatabaseManager.deletePointsViewSummaryMsg"),
                lex.get("pdm.PointDatabaseManager.featureHeading"),
                lex.get("pdm.PointDatabaseManager.featureDescription"),
                lex.get("pdm.PointDatabaseManager.stepFiveName"),
                lex.get("pdm.PointDatabaseManager.stepFiveDescription"),
                lex.get("pdm.PointDatabaseManager.stepFiveOfSix"),
                lex.get("pdm.PointDatabaseManager.button.back"),
                lex.get("pdm.PointDatabaseManager.button.next"),
                lex.get("pdm.PointDatabaseManager.button.cancel")));

            // initializing fifth (delete points view) screen.
            _self.wizardOrder.push(new postDeleteStatusView(dom, "postDeleteStatusView", "PDM-step6-postDeleteStatusView",
                //lex.get("pdm.PointDatabaseManager.postDeleteStatusViewMsg"),
                //lex.get("pdm.PointDatabaseManager.postDeleteStatusViewSummaryMsg"),
                lex.get("pdm.PointDatabaseManager.featureHeading"),
                lex.get("pdm.PointDatabaseManager.featureDescription"),
                lex.get("pdm.PointDatabaseManager.stepSixName"),
                lex.get("pdm.PointDatabaseManager.stepSixDescription"),
                lex.get("pdm.PointDatabaseManager.stepSixOfSix"),
                lex.get("pdm.PointDatabaseManager.button.back"),
                lex.get("pdm.PointDatabaseManager.button.startNew"),
                lex.get("pdm.PointDatabaseManager.button.cancel")));

  }

        /**
   * Description of your widget.
   *
   * @class
   * @extends module:bajaux/Widget
   * @alias module:nmodule/easyDatabaseManager/rc/EasyDatabaseManagerWidget
   */
  var EasyDatabaseManagerWidget = function () {
    var _self = this;
    Widget.apply(_self, arguments);
    subscriberMixin(_self);

    _self.wizardOrder = [];
    _self.currentView = null;
    _self.pdmData = {};
    _self.$jobSubscriber = new DepthSubscriber(5);
    _self.getUIView = function(view, type) {
        var tempview = null;
        if(view) {
            var viewIndex = _self.wizardOrder.findIndex(
                function(element) {return element.getViewHeaders().vname === view.getViewHeaders().vname});
            switch (type) {
            case 'next': {
                if(viewIndex >= _self.wizardOrder.length - 1) {
                    tempview = _self.wizardOrder[0];
                } else {
                    tempview = _self.wizardOrder[viewIndex+1];
                }
                break;
            }
            case 'prev' : {
                if(viewIndex > 0) {
                    tempview = _self.wizardOrder[viewIndex-1];
                } else {
                    tempview = _self.wizardOrder[0];
                }
                break;
            }
            default: {
                    tempview = _self.wizardOrder[0];
                    break;
                }
            }
        }
        if(tempview == null) {
            //return the first element in view
            tempview = _self.wizardOrder[0];
        }
        return tempview;
    };

    _self.loadView = function() {
        var dom = _self.jq();
        var params = _self.currentView.getViewHeaders();
        // update header and footer (nav buttons) for the view
        _self.updateHeaderAndFooter(dom, _self.currentView);
        // remove any existing view with currentView id
        $(dom).find("#" + params.vid).remove();
        // call currentView.loadView
        var viewParams = {
                    component: _self.component,
                    updateActionButtonsStatus: updateActionButtonsStatus,
                    service: pointDataManagerService,
                    subscriber: _self.$jobSubscriber,
                    notifyUser: notifyUser,
                    pdmData: _self.pdmData,
                    colorCode:brandColorCode
                };
                _self.currentView.loadView($(dom).find(".PDM-contents"), viewParams);
                $(dom).find("#" + params.vid).addClass("step-active");
    };

    _self.showLoadedView = function() {
        var dom = _self.jq();
        // update header and footer (nav buttons) for the view
        _self.updateHeaderAndFooter(dom, _self.currentView);

        var params = _self.currentView.getViewHeaders();
        $(dom).find("#" + params.vid).removeClass("step-done PDM-hide-element");
        $(dom).find("#" + params.vid).addClass("step-active");

        var viewParams = {
            pdmData: _self.pdmData
        };
        _self.currentView.showLoadedView(viewParams);
    };

            _self.updateView = function (currentView, type) {
                var params = currentView.getViewHeaders();
                var dom = _self.jq();
                //hide previous views before going next
                if (type === "next") {
                    $(dom).find("#" + params.vid).removeClass("step-active");
                    $(dom).find("#" + params.vid).addClass("step-done PDM-hide-element");
                }
                // remove existing view before going back
                if (type === "prev") {
                    $(dom).find("#" + params.vid).removeClass("step-active");
                    $(dom).find("#" + params.vid).remove();
                }
            };
            _self.addEventListeners = addEventListeners;
            _self.updateHeaderAndFooter = updateHeaderAndFooter;
            _self.addNextBtnListener = addNextBtnListener;
            _self.addBackBtnListener = addBackBtnListener;
            _self.addCancelBtnListener = addCancelBtnListener;
            _self.addSkipBtnListener = addSkipBtnListener;
            _self.initializeWizardSteps = initializeWizardSteps;
        };

        function updateActionButtonsStatus(dom, actionBttnStatus) {
            if (dom && actionBttnStatus) {
                if (actionBttnStatus.disabledBack === undefined) {
                    $(dom).find("#PDM-nav-button-back").addClass("PDM-hide-element");
                } else {
                    $(dom).find("#PDM-nav-button-back").prop("disabled", actionBttnStatus.disabledBack);
                }
                if (actionBttnStatus.disabledNext === undefined) {
                    $(dom).find("#PDM-nav-button-next").addClass("PDM-hide-element");
                } else {
                    $(dom).find("#PDM-nav-button-next").prop("disabled", actionBttnStatus.disabledNext);
                }
                if (actionBttnStatus.disabledCancel === undefined) {
                    $(dom).find("#PDM-nav-button-cancel").addClass("PDM-hide-element");
                } else {
                    $(dom).find("#PDM-nav-button-cancel").prop("disabled", actionBttnStatus.disabledCancel);
                }
                if (actionBttnStatus.disabledSkip === undefined) {
                    $(dom).find("#PDM-nav-button-skip").addClass("PDM-hide-element");
                } else {
                    $(dom).find("#PDM-nav-button-skip").prop("disabled", actionBttnStatus.disabledSkip);
                }
            }
        }

        function notifyUser(dom, message) {
            baja.outln(message);
            //hide progress.
            $(dom).find(".PDM-wizard-container").addClass("PDM-hide-element");
            $(dom).find(".PDM-error-message").html(message);
            $(dom).find(".PDM-error-notification").removeClass("PDM-hide-element");
        }

        //extend and set up prototype chain
        EasyDatabaseManagerWidget.prototype = Object.create(Widget.prototype);
        EasyDatabaseManagerWidget.prototype.constructor = EasyDatabaseManagerWidget;

        /**
         * Describe how your widget does its initial setup of the DOM.
         *
         * @param {jQuery} element the DOM element into which to load this widget
         */
        EasyDatabaseManagerWidget.prototype.doInitialize = function (dom) {
            var _self = this;
            dom.html(layout({
                        "stepMessage": lex.get("pdm.pointDataManager.welcomeMsg"),
                    "featureDescription": lex.get("pdm.pointDataManager.featureDescription"),
                    "backButtonMsg": lex.get("pdm.PointDatabaseManager.button.back"),
                    "nextButtonMsg": lex.get("pdm.PointDatabaseManager.button.next"),
                    "cancelButtonMsg": lex.get("pdm.PointDatabaseManager.button.cancel")
                }
            ));
            _self.addEventListeners();
        };

        /**
         * Describe how your widget loads in a value.
         *
         * @param value description of the value to be loaded into this widget
         */
        EasyDatabaseManagerWidget.prototype.doLoad = function (component) {
            var _self = this;
            var dom = _self.jq();
            _self.component = component;
            _self.initializeWizardSteps(dom);
            _self.currentView = _self.getUIView();
            var componentType = component.getType();

            baja.rpc({
                typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                method: 'getBrandColorCode'})
                .then(function (resp) {
                    brandColorCode = resp.colorCode;
                    document.getElementById("hiddenFieldIsWorkBench").value= resp.isWb;
                });

          baja.rpc({
              typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
              method: 'checkFeatureLicense'})
              .then(function (returnValue) {
                  if(!returnValue) {
                      baja.rpc({
                          typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                          method: 'checkEdgeController'
                      }).then( function(returnEdge) {
                          if (returnEdge) {
                              baja.outln("Point Database Manager runs on supervisor only, not on edge controller stations.");
                              notifyUser(dom, lex.get("pdm.PointDatabaseManager.feature.not.OnEdge"));
                          } else {
                              baja.outln("Point Database Manager is not licensed");
                              notifyUser(dom, lex.get("pdm.PointDatabaseManager.feature.not.licensed"));
                          }
                          return;
                      });
                  } else {
                      //if the controller has EDM license, show feature not available message.
                      baja.rpc({
                          typeSpec: 'easyDatabaseManager:PointDataManagerRpc',
                          method: 'checkEdgeController'
                      }).then( function(returnEdge) {
                          if (returnEdge) {
                              baja.outln("Point Database Manager runs on supervisor only, not on edge controller stations.");
                              notifyUser(dom, lex.get("pdm.PointDatabaseManager.feature.not.OnEdge"));
                          } else {
                              if (componentType.toString() === "easyDatabaseManager:EasyDatabaseManagerService") {
                                  pointDataManagerService = component;
                                  _self.loadView();
                              } else {
                                  pointDataManagerService = null;
                                  _self.getPointDataManagerService()
                                      .then(function (result) {
                                          baja.outln("ready to find unused points, retrieved EasyDatabaseManagerService: " + result);
                                          if (result instanceof Error) {
                                              notifyUser(dom, lex.get("pdm.PointDatabaseManager.no.service.message"));
                                          } else {
                                              _self.loadView();
                                          }
                                      }, function (error) {
                                          baja.outln("EasyDatabaseManagerService is unavailable: " + error);
                                          notifyUser(dom, lex.get("pdm.PointDatabaseManager.no.service.message"));
                                      })
                                      .catch(function (err) {
                                          // ORD failed to resolve
                                          baja.outln("Error finding EasyDatabaseManagerService: " + err);
                                          notifyUser(dom, lex.get("pdm.PointDatabaseManager.no.service.message"));
                                      });
                              }
                          }
                      });
                  }
              });

        };

        EasyDatabaseManagerWidget.prototype.getPointDataManagerService = function () {
            return baja.Ord.make('station:|slot:/Services').get({lease: true})
                .then(function (services) {
                    return services.getNavChildren()
                        .then(function (serviceList) {
                            var k;
                            for (k = 0; k < serviceList.length; k++) {
                                if (serviceList[k].getType().toString() === "easyDatabaseManager:EasyDatabaseManagerService") {
                                    pointDataManagerService = serviceList[k];
                                    break;
                                }
                            }
                            baja.outln('retrieved nav children: ' + serviceList.join());
                        })
                        .then(function () {
                            return new promise(function (resolve, reject) {
                                if (pointDataManagerService !== null) {
                                    resolve(pointDataManagerService);
                                } else {
                                    reject(new Error("Failed to retrieve EasyDatabaseManagerService"));
                                }
                            })
                                .catch(function (err) {
                                    baja.error('failed to retrieve available services: ' + err);
                                    return (new Error("Failed to retrieve EasyDatabaseManagerService"));
                                });
                        });
                });

        };


        /**
         * Describe what kind of data you can read out of this widget.
         *
         * @returns {promise} promise to be resolved with the current value
         */
        EasyDatabaseManagerWidget.prototype.doRead = function () {
            return promise.resolve(this.jq().find('input').val());
        };

        return EasyDatabaseManagerWidget;
    });

/*
 *
 *  * Copyright (c) 2019. Honeywell International, Inc. All Rights Reserved.
 *
 */

require(['nmodule/easyDatabaseManager/rc/js/EasyDatabaseManagerWidget'], function (EasyDatabaseManagerWidget) {
  
});


define("nmodule/easyDatabaseManager/rc/js/EasyDatabaseManager.run", function(){});
